//
//   18011   .
//

#include "MPI_1801VM1.h"


#define T       020
#define N       010
#define Z       04
#define V       02
#define C       01


//#define L(x) pHooks->DisAsmStrOut(x,false)
#define L(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }

//#define EM_LOG(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }
#undef EM_LOG

#define DISABLE_ODD_TRAPS  1

#define LNG(x) x

//
//
//
///
void MPI_1801VM1::HALT_TrapToRomOffset( int nROM_Vector_Offset, bool bIRQ1 )
{
#ifdef EM_LOG
	if( bDisAsmFooterNeed )
	{
		std::string sMes;
		
		if( nROM_Vector_Offset ==  02 ) { sMes = LNG("HALT ");            }
		if( nROM_Vector_Offset ==  06 ) { sMes = LNG("Double Bus Error"); }
		if( nROM_Vector_Offset == 012 ) { sMes = LNG("Interrupt sequence timeout"); }

		if( nNestedTrapsTo4 < 3 ) 
		{
			char str[256];
			sTrapMesCash += "\n################\n";
			sprintf(str,"HALT Trap to 1600%02o = %s", nROM_Vector_Offset, sMes.c_str() );
			sTrapMesCash += str;
			sTrapMesCash += "\n################\n";

			if( abWriteAccess[ SEL1 ] )
			{                    
				sprintf(str,"                                                      ;        %06o -> %06o:%06o\n", WORD(SEL1)|BIT_3, SEL1, WORD(SEL1) );
			}
			else
			if( abReadAccess[ SEL1 ] )
			{
				sprintf(str,"                                                      ;        %06o -> %06o: %s..\n", WORD(SEL1)|BIT_3, SEL1, LNG("Read only") );
			}
			else
			{
				sprintf(str,"                                                      ;        %06o -- %s..\n", SEL1, LNG("No memory") );
			}
			sTrapMesCash += str;
		}
		
	}
#endif

///////////////////////////////////////////////////////////////////////////////

	word wSEL1;
	WordRead( SEL1, wSEL1, true );
	wSEL1 |= BIT_3;
	WordWrite(SEL1, wSEL1, 2, true );

///////////////////////////////////////////////////////////////////////////////

#ifdef EM_LOG
	if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
	{
		char str[256];

		if( abWriteAccess[ 0177676 ] )
		{                    
			sprintf(str,"                                                      ;   PSW :%06o -> %06o:%06o\n", PSW, 0177676, WORD(0177676) );
		}
		else
		if( abReadAccess[ 0177676 ] )
		{
			sprintf(str,"                                                      ;   PSW :%06o -> %06o: %s..\n", PSW, 0177676, LNG("Read only") );
		}
		else
		{
			sprintf(str,"                                                      ;   PSW :%06o -> %06o: %s..\n", PSW, 0177676, LNG("No memory") );
		}
		sTrapMesCash += str;
	}
#endif

///////////////////////////////////////////////////////////////////////////////

	word wPC = PC;
	PC += 2;
	
	WordWrite( 0177676, PSW );
	
///////////////////////////////////////////////////////////////////////////////
	
#ifdef EM_LOG
	if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
	{
		char str[256];

		if( abWriteAccess[ 0177674 ] )
		{                    
			sprintf(str,"                                                      ;   PC  :%06o -> %06o:%06o\n", wPC, 0177674, WORD(0177674) );
		}
		else
		if( abReadAccess[ 0177674 ] )
		{
			sprintf(str,"                                                      ;   PC  :%06o -> %06o: %s..\n", wPC, 0177674, LNG("Read only") );
		}
		else
		{
			sprintf(str,"                                                      ;   PC  :%06o -> %06o: %s..\n", wPC, 0177674, LNG("No memory") );
		}
		sTrapMesCash += str;
	}
#endif

///////////////////////////////////////////////////////////////////////////////

	if( !bIRQ1 )
	{
		WordWrite( 0177674, wPC, 1 );
	}
	else
	{
		WordWrite( 0177674, wPC, 2 );
	}

	nALU_Delay = 4;
	Make_ALU_Delay();
	
	word  addr = 0160000 + nROM_Vector_Offset;
	
///////////////////////////////////////////////////////////////////////////////

#ifdef EM_LOG
	if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
	{
		char str[256];

		if( abReadAccess[ addr ] )
		{
			sprintf(str,"                                                      ; %06o:%06o ->   PC  : %06o\n", addr, WORD(addr), PC );
		}
		else
		{
			sprintf(str,"                                                      ; %06o:       ->   PC  : %06o\n", addr, PC );
		}
		sTrapMesCash += str;
	}
#endif

///////////////////////////////////////////////////////////////////////////////


	WordRead( addr, PC );

	nALU_Delay = 4;
	Make_ALU_Delay();

///////////////////////////////////////////////////////////////////////////////

#ifdef EM_LOG
	if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
	{
		char str[256];

		if( abReadAccess[ addr+2 ] )
		{
			sprintf(str,"                                                      ; %06o:%06o ->   PSW : %06o\n", addr+2, WORD(addr+2), PSW );
		}
		else
		{
			sprintf(str,"                                                      ; %06o:       ->   PSW : %06o\n", addr+2, PSW );
		}
		sTrapMesCash += str;
	}
#endif

///////////////////////////////////////////////////////////////////////////////


	WordRead( addr+2, PSW );

	if( !bVM1G ) 
	{
		nALU_Delay += 2;
	}

	nALU_Delay += 3;
	Make_ALU_Delay();


///////////////////////////////////////////////////////////////////////////////

	nNestedTrapsTo4 = 0;
	
	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}	
}


void MPI_1801VM1::TrapTo_4()
{
	nOverrun = 0;

	switch( nBadAccessType ) 
	{
		case 1:
		    sprintf(trap_mes,LNG("Odd PC value: %06o"), wBadAddr );
		break;
		
		case 2:
			sprintf(trap_mes,LNG("Instruction fetch at absent address: %06o"), wBadAddr );
		break;

		case 3:
			sprintf(trap_mes,LNG("Word read of odd address: %06o"), wBadAddr );
		break;

		case 4:
		    sprintf(trap_mes,LNG("Read of absent address: %06o"), wBadAddr );
		break;

		case 5:
			sprintf(trap_mes,LNG("Operand 2: word read of odd address: %06o"), wBadAddr );
		break;

		case 6:
			sprintf(trap_mes,LNG("Operand 2: read of absent address: %06o"), wBadAddr );
		break;

		case 7:
			sprintf(trap_mes,LNG("Word write to odd address: %06o"), wBadAddr );
		break;

		case 8:
			sprintf(trap_mes,LNG("Write to absent address: %06o"), wBadAddr );
		break;

		case 9:
			sprintf(trap_mes,LNG("Word R/W of odd address: %06o"), wBadAddr );
		break;

		case 10:
			sprintf(trap_mes,LNG("Write to Read-Only address: %06o"), wBadAddr );
		break;

		case 11:
			sprintf(trap_mes,LNG("R/W of absent address: %06o"), wBadAddr );
		break;

		case 12:
			sprintf(trap_mes,LNG("Operand 2: Word R/W of odd address: %06o"), wBadAddr );
		break;

		case 13:
			sprintf(trap_mes,LNG("Operand 2: Write to Read-Only address: %06o"), wBadAddr );
		break;

		case 14:
			sprintf(trap_mes,LNG("Operand 2: R/W of absent address: %06o"), wBadAddr );
		break;
		
		case 15:
			sprintf(trap_mes,LNG("Illegal address: R%i"), wBadAddr );
		break;
		
		case 16:
			sprintf(trap_mes,LNG("Bad access to Window address: %06o"), wBadAddr );
		break;
		
		default:
			sprintf(trap_mes,LNG("Bad access to address: %06o"), wBadAddr );
		break;
	}

	if( !nNestedTrapsTo4 )
	{
		/*
		if( (PSW & BIT_10) && nBadAccessType != 15 )
		{
			DebugOut(LNG("\rHALT Trap to 160002 = "));
		}
		else
		{
			DebugOut(LNG("\rTrap to 004 = "));
		}

		DebugOut(LNG("\rBUS ERROR: "));
		DebugOut(trap_mes);
		
		if( Last_TrapTo4_PC != Last_PC )
		{
			DebugOut("\n");
		}//*/
		
		Last_TrapTo4_PC = Last_PC;
	}

#ifdef EM_LOG
	if( bDisAsmFooterNeed )
	{
		if( nNestedTrapsTo4 < 3 )
		{
			sTrapMesCash += "\n################\n";
			char str[256];

			if( (PSW & BIT_10) && (nBadAccessType != 15) )
			{
	//			sprintf(str,"HALT Trap to 0160002 = %s", trap_mes );
			}
			else
			{
				sprintf(str,"Trap to 004 = %s", trap_mes );
			}
			sTrapMesCash += str;
			sTrapMesCash += "\n################\n";
		}
		else
		if( nNestedTrapsTo4 == 3 )
		{
			sTrapMesCash += "################\n";
			sTrapMesCash += LNG("Nested Bus Errors !!!");
			sTrapMesCash += "\n################\n";
		}
	}
#endif

    trap_mes[0]=0;
  
    if( (PSW & BIT_10) && nBadAccessType != 15 )
    {
		nBadAccessType = 0;

		try { HALT_TrapToRomOffset(02); }
		catch(int)
		{
//			DebugOut(LNG("\rHALT Trap to 160002\n"));
//			DebugOut(LNG("FATAL ERROR: Nested HALT Trap !!!\r"));
			Sleep(50);
			nNestedTrapsTo4++;
		}
		return;
    }
    else
    {
		if( nBadAccessType == 15 )
		{
			nALU_Delay += 3;
			Make_ALU_Delay();
		}
    
		nBadAccessType = 0;

		try 
		{    
#ifdef EM_LOG
			if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
			{
				char str[256];
				word wSP = (SP-2)&(~1);
				if( abWriteAccess[ wSP ] )
				{                    
					sprintf(str,"                                                      ;   PSW :%06o -> %06o:%06o\n", PSW, wSP, WORD(wSP) );
				}
				else
				if( abReadAccess[ wSP ] )
				{
					sprintf(str,"                                                      ;   PSW :%06o -> %06o: %s..\n", PSW, wSP, LNG("Read only") );
				}
				else
				{
					sprintf(str,"                                                      ;   PSW :%06o -> %06o: %s..\n", PSW, wSP, LNG("No memory") );
				}
				sTrapMesCash += str;
			}
#endif
			SP -= 2;
			WordWrite( SP, PSW );
		}
		catch(int)
		{
			SP -= 2;
			if( !nNestedTrapsTo4 ) 
			{
//				DebugOut(LNG("\rHALT Trap to 160006\n"));
//				DebugOut(LNG("BUS ERROR: Double Bus Error !!!\n")); 
			}

			try { HALT_TrapToRomOffset(06); }
			catch(int)
			{
				if( nNestedTrapsTo4 < 3 )
				{
//					DebugOut(LNG("FATAL ERROR: Nested Bus Errors !!!\r"));
				}
				nNestedTrapsTo4++;;
			}
			return;
		}

		try 
		{    
#ifdef EM_LOG
			if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
			{
				char str[256];
				word wSP = (SP-2)&(~1);
				if( abWriteAccess[ wSP ] )
				{                    
					sprintf(str,"                                                      ;   PC  :%06o -> %06o:%06o\n", PC, wSP, WORD(wSP) );
				}
				else
				if( abReadAccess[ wSP ] )
				{
					sprintf(str,"                                                      ;   PC  :%06o -> %06o: %s..\n", PC, wSP, LNG("Read only") );
				}
				else
				{
					sprintf(str,"                                                      ;   PC  :%06o -> %06o: %s..\n", PC, wSP, LNG("No memory") );
				}
				sTrapMesCash += str;
			}
#endif

			SP -= 2;
			WordWrite( SP, PC );
		}
		catch(int)
		{
			nNestedTrapsTo4++;
			return;
		}

		nALU_Delay = 4;
		Make_ALU_Delay();

////////////////////////////////////////////////////////////////////////////////////

#ifdef EM_LOG
		if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
		{
			char str[256];
			word addr = 04;
			if( abReadAccess[ addr ] )
			{
				sprintf(str,"                                                      ; %06o:%06o ->   PC\n", addr, WORD(addr) );
			}
			else
			{
				sprintf(str,"                                                      ; %06o:       ->   PC\n", addr );
			}
			sTrapMesCash += str;
		}
#endif

////////////////////////////////////////////////////////////////////////////////////

		try 
		{    
			WordRead( 04, PC );
		}
		catch(int)
		{
			nNestedTrapsTo4++;
			return;
		}

		nALU_Delay = 4;
		Make_ALU_Delay();

////////////////////////////////////////////////////////////////////////////////////

#ifdef EM_LOG
		if( bDisAsmFooterNeed && nNestedTrapsTo4 < 3 )
		{
			char str[256];
			word addr = 06;
			if( abReadAccess[ addr ] )
			{
				sprintf(str,"                                                      ; %06o:   %03o ->   PSW\n", addr, BYTE(addr) );
			}
			else
			{
				sprintf(str,"                                                      ; %06o:       ->   PSW\n", addr );
			}
			sTrapMesCash += str;
		}
#endif

////////////////////////////////////////////////////////////////////////////////////

		try
		{
			WordRead( 06, PSW );
			PSW &= 0xFF;
		}
		catch(int)
		{
			nNestedTrapsTo4++;
			return;
		}
	}

	nNestedTrapsTo4 = 0;


	if( bVM1G ) { nALU_Delay += 3; }
	else        { nALU_Delay += 8; }

	Make_ALU_Delay();


	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}

}
void MPI_1801VM1::TrapTo_10()
{
//	DebugOut(LNG("\rTrap to 010 = "));

	nOverrun = 0;

#ifdef EM_LOG
/*
	if( bDisAsmFooterNeed )
	{
		DisAsmPrint("\n################\n");
		DisAsmPrint("Trap to 010\n");
		DisAsmPrint("################\n");
	}//*/
	if( bDisAsmFooterNeed )
	{
		sTrapMesCash += "\n################\n";
		char str[256];
		if( abReadAccess[010] )
		{                    
			sprintf(str,LNG("Trap to 010                                           ; 000010:%06o ->   PC\n"), WORD(010) );
		}
		else
		{
			sprintf(str,LNG("Trap to 010                                           ; 000010: No memory\n") );
		}
		sTrapMesCash += str;
		sTrapMesCash += "################\n";
	}
#endif

	nALU_Delay += 6;
	Make_ALU_Delay();

	try 
	{    
		SP -= 2;
		word wSP = SP;
		SP -= 2;
		WordWrite( wSP, PSW );
		WordWrite( SP,  PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();

		WordRead( 010, PC );

		nALU_Delay = 4;
		Make_ALU_Delay();

		WordRead( 012, PSW );
		PSW &= 0xFF;
	}
	catch(int)
	{
		return TrapTo_4();
	}


	if( bVM1G ) { nALU_Delay += 3; }
	else        { nALU_Delay += 8; }

	Make_ALU_Delay();


	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}
/*
#ifdef EM_LOG
	if( bDisAsmFooterNeed )
	{
		char str[128];
		sprintf(str,"Trap to 010 -> PC:%06o PSW:%03o\n\n", PC, PSW );
		EM_LOG(str);
	}
#endif//*/
}
void MPI_1801VM1::TrapTo_14()
{
	nOverrun = 0;

	try 
	{    
		word wPC = PC;
		
		if( bRTT )
		{
			PC += 2;
		}

		SP -= 2;
		word wSP = SP;
		SP -= 2;
		WordWrite( wSP, PSW );
		
		if( bRTT )
		{
			WordWrite( SP,  wPC, 2 );
		}
		else
		{
			WordWrite( SP,  wPC, 1 );
		}

		nALU_Delay = 4;
		Make_ALU_Delay();

		WordRead( 014, PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();

		ByteRead( 016, PSW );
	}
	catch(int)
	{
		return TrapTo_4();
	}

	if( bVM1G ) { nALU_Delay += 3; }
	else        { nALU_Delay += 8; }
	
	Make_ALU_Delay();



	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}
}
void MPI_1801VM1::TrapTo_24()
{
	nOverrun = 0;

	try 
	{    
		word wPC = PC;
		PC += 2;
		
		SP -= 2;
		word wSP = SP;
		SP -= 2;
		WordWrite( wSP, PSW );
		WordWrite( SP,  wPC, 2 );

		nALU_Delay = 4;
		Make_ALU_Delay();

		WordRead( 024, PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();

		ByteRead( 026, PSW );
	}
	catch(int)
	{
		return TrapTo_4();
	}


	if( bVM1G ) { nALU_Delay += 3; }
	else        { nALU_Delay += 8; }

	Make_ALU_Delay();



	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}
}
void MPI_1801VM1::TrapTo_100()
{
	nOverrun = 0;

	try 
	{    
		word wPC = PC;
		PC += 2;
		
		SP -= 2;
		word wSP = SP;
		SP -= 2;
		WordWrite( wSP, PSW );
		WordWrite( SP,  wPC, 2 );

		nALU_Delay = 4;
		Make_ALU_Delay();

		WordRead( 0100, PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();

		ByteRead( 0102, PSW );
	}
	catch(int)
	{
		return TrapTo_4();
	}

	if( bVM1G ) { nALU_Delay += 3; }
	else        { nALU_Delay += 8; }

	Make_ALU_Delay();



	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}
}
void MPI_1801VM1::TrapTo( word wVector )
{
	try 
	{    
		SP -= 2;
		word wSP = SP;
		SP -= 2;
		WordWrite( wSP, PSW );
		WordWrite( SP,  PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();

		WordRead( wVector + 0, PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();

		ByteRead( wVector + 2, PSW );

		nALU_Delay = 2;
		Make_ALU_Delay();
	}
	catch(int)
	{
		return TrapTo_4();
	}


	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}
}
void MPI_1801VM1::HardTrap()
{
	nOverrun = 0;

	word uVector;

	try 
	{   
		word wPC = PC;
		PC += 2;
	 
		SP -= 2;
		word wSP = SP;
		SP -= 2;
		WordWrite( wSP, PSW );
		WordWrite( SP,  wPC, 2 );
	}
	catch(int)
	{
		return TrapTo_4();
	}	


	////////////////////////////////////////////

	pVM1_bus->BSY = false;
//	pVM1_bus->DIN = false;
	CLC0_DIN = false;
	
	SwitchToFiber( pMainFiber );
	
	pVM1_bus->IAK = false;

	SwitchToFiber( pMainFiber );

	int nOK = 0;
	
	for( int i = 0 ; i < 64 ; i++ )
	{
		if( !pVM1_bus->RPLY )
		{
			nOK++;
			
			if( nOK > 1 )
			{
				break;
			}
		}

		SwitchToFiber( pMainFiber );
	}

	uVector = ~ pVM1_bus->AD;

//	pVM1_bus->DIN = true;
	CLC0_DIN = true;

	BusClocksDelay(1);

	pVM1_bus->IAK = true;

	nRPLY_OFF_Latency = 0;

	while( !pVM1_bus->RPLY )
	{
		nRPLY_OFF_Latency++;

		SwitchToFiber( pMainFiber );
	}

	pVM1_bus->BSY = true;

	if( !nRPLY_OFF_Latency )
	{
		BusClocksDelay(1);
	}

	BusClocksDelay(1);

	////////////////////////////////////////////

	if( !nOK )
	{
		/*
		DebugOut(LNG("\rHALT Trap to 160012\n"));
		char str[128];
		sprintf(str,LNG("BUS ERROR: Interrupt %03o sequence timeout !\n"), wPending_IRQ_Vector_Orig );
		DebugOut(str);
		//*/
		return HALT_TrapToRomOffset(012);;
	}


#ifdef EM_LOG
	if( bDisAsmFooterNeed && WORD(uVector) >= nP_DisAsmBottomAddr && WORD(uVector) <= nP_DisAsmTopAddr )
	{
		sTrapMesCash += "\n################\n";
		char str[256];
		sprintf(str,LNG("Interrupt: Vector[%03o]"), uVector );
		sTrapMesCash += str;
		sTrapMesCash += "\n################\n";
	}
#endif

	try 
	{    
		WordRead( uVector + 0, PC  );

		nALU_Delay = 4;
		Make_ALU_Delay();
		
		ByteRead( uVector + 2, PSW );
	}
	catch(int)
	{
		return TrapTo_4();
	}	


	if( bVM1G ) { nALU_Delay += 3; }
	else        { nALU_Delay += 8; }

	Make_ALU_Delay();



	if( PSW & T )
	{
		nT_bit_Flag = 1;
		bRTT = true;
	}
	else
	{
		nT_bit_Flag = 0;
		bRTT = false;
	}
}
//
__forceinline void MPI_1801VM1::Fetch( word & nWord )
{
#ifndef DISABLE_ODD_TRAPS
	if( PC & 1 )
	{
		wBadAddr = PC;
		nBadAccessType = 1;
		throw(0);
	}
#endif

	Last_PC = PC;
	PC += 2;

	WordRead( Last_PC, nWord );
}


word MPI_1801VM1::GetAddr( byte nOpMode )
{
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		wBadAddr = nOpMode & 07;
		nBadAccessType = 15;
		throw(0);


		case 01:
		{
			word wAddr = r[nOpMode & 07];

			if( bVM1G ) 
			{
				nALU_Delay += 2;
				Make_ALU_Delay();

				word             data;
				WordRead( wAddr, data );
			}
			else
			{
				BusClocksDelay(2);
			}
			return wAddr;
		}

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			word wAddr = Rx;
			Rx += 2;

			if( bVM1G ) 
			{
				nALU_Delay += 2;
				Make_ALU_Delay();

				word             data;
				WordRead( wAddr, data );
				
				if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}
			}
			else
			{
				BusClocksDelay(5);
			}

			return wAddr;
		}

		case 03:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			word & Rx = r[nOpMode & 07];
			word wAddr = Rx;
			Rx += 2;
			WordRead( wAddr, wAddr );

			if( bVM1G ) 
			{
				if( !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}

				word             data;
				WordRead( wAddr, data );
			}

			return wAddr;
		}

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;

			if( bVM1G ) 
			{
				nALU_Delay += 3;
				Make_ALU_Delay();

				word             data;
				WordRead( Rx, data );
			}
			else
			{
				BusClocksDelay(5);
			}
			
			return Rx;
		}

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			word wAddr;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( Rx, wAddr );

			if( bVM1G ) 
			{
				if( !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}

				word             data;
				WordRead( wAddr, data );
			}

			return wAddr;
		}

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			word wAddr = PC;
			PC += 2;
			WordRead( wAddr, wAddr );
			wAddr += r[nOpMode & 07];

			if( bVM1G ) 
			{
				if( !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}

				word             data;
				WordRead( wAddr, data );
			}

			return wAddr;
		}

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			word wAddr = PC;
			PC += 2;
			WordRead( wAddr, wAddr );
			wAddr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
			
			WordRead( wAddr, wAddr );

			if( bVM1G ) 
			{
				if( !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}

				word             data;
				WordRead( wAddr, data );
			}

			return wAddr;
		}
	}
	return 0;
}

//
void MPI_1801VM1::WordRead( word addr, word & wData, bool bRW_Mode )
{
#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 3;
		throw(0);
	}
#endif

	pVM1_bus->BSY = false;
	word AD       = ~ addr;
	pVM1_bus->AD  = AD;
	
	SwitchToFiber( pMainFiber );

	pVM1_bus->SYNC = false;
	CLC0_DIN = false;
	nCLC0_AD = (word)~0;

	nRPLY_ON_Latency  = 0;

	/*
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = false;
	}//*/
 
	int nOK = 0;

	for( int i = 0 ; i < 62 ; i++ )
	{
		if( !pVM1_bus->RPLY )
		{
			nOK++;
			
//			if( nOK > 1 + (int)bSEL_Mode )
			if( nOK > 1 )
			{
				break;
			}
		}

		SwitchToFiber( pMainFiber );
		
		if( pVM1_bus->RPLY )
		{
			nRPLY_ON_Latency++;
		}
	}

	CLC0_DIN = true;

	if( !nOK )
	{
		pVM1_bus->DIN  = true;

		SwitchToFiber( pMainFiber );

		pVM1_bus->SYNC = true;
		pVM1_bus->BSY  = true;

		BusClocksDelay(6);

		throw(0);
	}
	
	wData = ~ pVM1_bus->AD;

	nRPLY_OFF_Latency = 0;

	/*
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = true;
	}//*/

	while( !pVM1_bus->RPLY )
	{
		SwitchToFiber( pMainFiber );
		
		if( !pVM1_bus->RPLY )
		{
			nRPLY_OFF_Latency++;
		}
	}

	BusClocksDelay(1);
		
	if( !bRW_Mode )
	{
		pVM1_bus->SYNC = true;
		pVM1_bus->BSY  = true;
	}
	
//	SwitchToFiber( pMainFiber );
}

void MPI_1801VM1::WordWrite( word addr, word & wData, int nDOUT_Delay, bool bRW_Mode )
{
#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 7;
		throw(0);
	}
#endif

	bPreFetchEnabled = false;

	if( !bRW_Mode )
	{
		pVM1_bus->BSY  = false;
		pVM1_bus->AD   = ~ addr;
		pVM1_bus->WTBT = false;
		CLC0_WTBT = false;
		
		SwitchToFiber( pMainFiber );

		pVM1_bus->SYNC = false;
		nCLC0_AD = (word)~0;

		nDOUT_Delay++;
	}

//	pVM1_bus->WTBT = true;
	CLC0_WTBT = true;
	
	BusClocksDelay( nDOUT_Delay - 2 );
	
	nCLC0_AD = (word)~ wData;

	BusClocksDelay(1);

	pVM1_bus->DOUT = false;
	CLC0_DOUT = false;

	nRPLY_ON_Latency = 0;

	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = false;
	}

	int nOK = 0;

	for( int i = 0 ; i < 61 ; i++ )
	{
		if( !pVM1_bus->RPLY )
		{
			nOK++;
			
			if( nOK > 1 )
			{
				break;
			}
		}

		SwitchToFiber( pMainFiber );

		if( pVM1_bus->RPLY )
		{
			nRPLY_ON_Latency++;
		}
	}

	CLC0_DOUT = true;

	/*
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = true;
	}//*/

	BusClocksDelay(1);

	pVM1_bus->AD   = ~0;

	nRPLY_OFF_Latency = 0;

	if( !nOK )
	{
		pVM1_bus->SYNC = true;
		pVM1_bus->BSY  = true;

		BusClocksDelay(6);

		throw(0);
	}
	
	while( !pVM1_bus->RPLY )
	{
		nRPLY_OFF_Latency++;

		SwitchToFiber( pMainFiber );
	}

	BusClocksDelay(1);

	pVM1_bus->SYNC = true;
	pVM1_bus->BSY  = true;

//	SwitchToFiber( pMainFiber );
}
void MPI_1801VM1::ByteRead( word addr, word & wData, bool bRW_Mode )
{
	pVM1_bus->BSY = false;
	word AD       = ~ addr;
	pVM1_bus->AD  = AD;
	
	SwitchToFiber( pMainFiber );

	pVM1_bus->SYNC = false;
	CLC0_DIN = false;
	nCLC0_AD = (word)~0;

	nRPLY_ON_Latency = 0;
	
	/*
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = false;
	}//*/

	int nOK = 0;

	for( int i = 0 ; i < 62 ; i++ )
	{
		if( !pVM1_bus->RPLY )
		{
			nOK++;
			
//			if( nOK > 1 + (int)bSEL_Mode )
			if( nOK > 1 )
			{
				break;
			}
		}

		SwitchToFiber( pMainFiber );

		if( pVM1_bus->RPLY )
		{
			nRPLY_ON_Latency++;
		}
	}
	
	CLC0_DIN = true;

	if( !nOK )
	{
		pVM1_bus->DIN  = true;

		SwitchToFiber( pMainFiber );

		pVM1_bus->SYNC = true;
		pVM1_bus->BSY  = true;

		BusClocksDelay(6);

		throw(0);
	}
	
	word  data;

	data = ~ pVM1_bus->AD;

	if( addr & 1 ) { wData = data >> 8;     }
	else           { wData = data & 0x00FF; }

	nRPLY_OFF_Latency = 0;

	/*
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = true;
	}//*/

	while( !pVM1_bus->RPLY )
	{
		SwitchToFiber( pMainFiber );
		
		if( !pVM1_bus->RPLY )
		{
			nRPLY_OFF_Latency++;
		}
	}

	BusClocksDelay(1);
		
	if( !bRW_Mode )
	{
		pVM1_bus->SYNC = true;
		pVM1_bus->BSY  = true;
	}

//	SwitchToFiber( pMainFiber );
}

void MPI_1801VM1::ByteWrite( word addr, word & wData, int nDOUT_Delay, bool bRW_Mode )
{
	bPreFetchEnabled = false;

	if( !bRW_Mode )
	{
		pVM1_bus->BSY  = false;
		pVM1_bus->AD   = ~ addr;
		pVM1_bus->WTBT = false;
		CLC0_WTBT = false;
		
		SwitchToFiber( pMainFiber );

		pVM1_bus->SYNC = false;
		nCLC0_AD = (word)~0;

		nDOUT_Delay++;
	}

//	pVM1_bus->AD   = ~ 0;
//	pVM1_bus->WTBT = true;
	CLC0_WTBT = true;

	int nDelay = nDOUT_Delay - 1;
	
	while( nDelay > 1 )
	{
		nDelay--;
		BusClocksDelay(1);
	}

	word  data = wData;
	
	if( addr & 1 ) { data <<= 8;      }
	else           { data  &= 0x00FF; }

//	pVM1_bus->WTBT = false;
	CLC0_WTBT = false;
	nCLC0_AD = (word)~ data;
	
	BusClocksDelay(1);
	
//	pVM1_bus->AD   = ~ data;
	pVM1_bus->DOUT = false;
	CLC0_DOUT = false;

	nRPLY_ON_Latency = 0;
	
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = false;
	}

	int nOK = 0;

	for( int i = 0 ; i < 61 ; i++ )
	{
		if( !pVM1_bus->RPLY )
		{
			nOK++;
			
			if( nOK > 1 )
			{
				break;
			}
		}

		SwitchToFiber( pMainFiber );

		if( pVM1_bus->RPLY )
		{
			nRPLY_ON_Latency++;
		}
	}

	CLC0_DOUT = true;

	/*
	if( bSEL_Mode )
	{
		pVM1_bus->RPLY = true;
	}//*/

	BusClocksDelay(1);

	pVM1_bus->AD   = ~0;
	pVM1_bus->WTBT = true;
	CLC0_WTBT = true;

	nRPLY_OFF_Latency = 0;

	if( !nOK )
	{
		pVM1_bus->SYNC = true;
		pVM1_bus->BSY  = true;

		BusClocksDelay(6);

		throw(0);
	}
	
	while( !pVM1_bus->RPLY )
	{
		nRPLY_OFF_Latency++;

		SwitchToFiber( pMainFiber );
	}

	BusClocksDelay(1);

	pVM1_bus->SYNC = true;
	pVM1_bus->BSY  = true;
	
//	SwitchToFiber( pMainFiber );
}
//
void MPI_1801VM1::WordRead0( byte nOpMode, word & wData, bool bMUL )
{
	word        addr;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			if( bVM1G ) { nInterruptCheck_Clk_Addon = 5; }
			else        { nInterruptCheck_Clk_Addon = 3; }

			int nReg = nOpMode & 07;
			if( nReg == 7 && !bMUL )
			{
				bPreFetchEnabled = false;
				
				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
				
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				if( !bVM1G )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}
			}
			
			wData = r[nReg];

			return;
		}

		case 01:
		{
			addr = r[nOpMode & 07];

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			addr = Rx;

			nALU_Delay += 3;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( Rx, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

	bPreFetchEnabled = false;
	
//////////////////////////

#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 3;
		throw(0);
	}
#endif			

	WordRead( addr, wData );

	if( nMode == 2 && !nRPLY_ON_Latency )
	{
		BusClocksDelay(1);
	}

	nALU_Delay = 3;
	Make_ALU_Delay();
}

void MPI_1801VM1::WordRead1( byte nOpMode, word & wData )
{
	word        addr;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			int nReg = nOpMode & 07;
			if( nReg == 7 )
			{
				bPreFetchEnabled = false;
			}
			
			nFirstOperandReg = nReg;
			
			wData = r[nReg];

			return;
		}

		case 01:
		{
			addr = r[nOpMode & 07];

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			addr = Rx;

			nALU_Delay += 3;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( Rx, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}
	
	nFirstOperandReg = -1;
	bPreFetchEnabled = false;
	
//////////////////////////

#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 3;
		throw(0);
	}
#endif			

	WordRead( addr, wData );

	nALU_Delay = 3;

	nInterruptCheck_Clk_Addon = 5;
}

void MPI_1801VM1::WordRead2( byte nOpMode, word & wData )
{
	word        addr;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			int nReg = nOpMode & 07; 
			
			wData = r[nReg];

			bPreFetchEnabled = true;

			if( nReg == 7 || nFirstOperandReg == 7 )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
				
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				if( bVM1G && nFirstOperandReg >= 0 )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				{
					if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}
			else
			if( nFirstOperandReg >= 0 )
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 3; }
				else        { nInterruptCheck_Clk_Addon = 5; }
			}

			return;
		}

		case 01:
		{
			addr = r[nOpMode & 07];

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			addr = Rx;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}

			nALU_Delay++;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			
			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}

			nALU_Delay++;
			Make_ALU_Delay();

			WordRead( Rx, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
			
			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}
	
	bPreFetchEnabled = false;

#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 5;
		throw(0);
	}
#endif			

	WordRead( addr, wData );

	if( nMode == 2 && !nRPLY_ON_Latency )
	{
		BusClocksDelay(1);
	}

	nALU_Delay = 3;
	Make_ALU_Delay();
}

void MPI_1801VM1::WordWrite2( byte nOpMode, byte nOp1Mode, word & wData )
{
	word        addr;
	int         nDOUT_Delay = 2;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			int nReg = nOpMode & 07;

			bPreFetchEnabled = true;

			if( nReg == 7 || nFirstOperandReg == 7 )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
				
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }

				if( bVM1G && nFirstOperandReg >= 0 )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				{
					if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}
			else
			if( nFirstOperandReg >= 0 )
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 3; }
				else        { nInterruptCheck_Clk_Addon = 5; }
			}

			r[nReg] = wData;
			
			return;
		}

		case 01:
		{
			addr = r[nOpMode & 07];
			
			nDOUT_Delay = 3;

			if( nRPLY_OFF_Latency > 3 && nFirstOperandReg < 0 )
			{
				nDOUT_Delay--;
			}

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nDOUT_Delay = 6;

			if( nRPLY_OFF_Latency > 3 && nFirstOperandReg < 0 )
			{
				nDOUT_Delay--;
			}

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			addr = Rx;

			nDOUT_Delay = 5;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();

			WordRead( Rx, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
			
			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

	bPreFetchEnabled = false;
	
#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 7;
		throw(0);
	}
#endif

	WordWrite( addr, wData, nDOUT_Delay );
	
	nALU_Delay = 3;
	Make_ALU_Delay();
}

void MPI_1801VM1::Word_RW_Read0( byte nOpMode, word & wData, bool bXOR )
{
	word        addr;
	/*
	if( rw_addr != -222 )
	{
		char str[512];
		sprintf(str,"Program ERROR - bad rw_addr: %i. : %06o \n", rw_addr, rw_addr );
		ErrLog(str);
		EM_LOG(str);
		pConfigI->ExitProgram();

	}//*/

	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();
		
			int nReg = nOpMode & 07;
			wData = r[nReg];
			rw_addr = -1*(nReg+1);

			if( nReg == 7 )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
		
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;

				if( bVM1G ) { if( !bXOR ) { nDelay -= 2; } }
				else        { if( bXOR  ) { nDelay -= 2; } }

				if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
			}
			else
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 5; }
				else        { nInterruptCheck_Clk_Addon = 3; }
			}

			return;
		}

		case 01:
		{
			addr = r[nOpMode & 07];

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			addr = Rx;

			nALU_Delay += 3;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( Rx, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];
			
			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
			
			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 9;
		throw(0);
	}
#endif


	WordRead( addr, wData, true );
	
	if( nMode == 2 && !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
	{
		BusClocksDelay(1);
	}
	
	nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency*2 + 5;

	if( bSEL_Mode )
	{
		nInterruptCheck_Clk = 4;
	}
	
	rw_addr = addr;
}
void MPI_1801VM1::Word_RW_Read2( byte nOpMode, word & wData )
{
	word        addr;
	/*
	if( rw_addr != -222 )
	{
		char str[512];
		sprintf(str,"Program ERROR - bad rw_addr: %i. : %06o \n", rw_addr, rw_addr );
		ErrLog(str);
		EM_LOG(str);
		pConfigI->ExitProgram();
	}//*/

	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			int nReg = nOpMode & 07;
			wData = r[nReg];

			rw_addr = -1*(nReg+1);
			
			bPreFetchEnabled = true;

			if( nReg == 7 || nFirstOperandReg == 7 )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
			
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				if( bVM1G && nFirstOperandReg >= 0 )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				{
					if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}
			else
			if( nFirstOperandReg >= 0 )
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 3; }
				else        { nInterruptCheck_Clk_Addon = 5; }
			}
			
			return;
		}

		case 01:
		{
			addr = r[nOpMode & 07];

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			word & Rx = r[nOpMode & 07];
			addr = Rx;
			Rx += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;
			addr = Rx;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			word & Rx = r[nOpMode & 07];
			Rx -= 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();

			WordRead( Rx, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];
			
			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
			
			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}
	
	
#ifndef DISABLE_ODD_TRAPS
	if( addr & 1 )
	{
		wBadAddr = addr;
		nBadAccessType = 12;
		throw(0);
	}
#endif


	WordRead( addr, wData, true );

	if( nMode == 2 && !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
	{
		BusClocksDelay(1);
	}
	
	nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency*2 + 5;

	if( bSEL_Mode )
	{
		nInterruptCheck_Clk = 4;
	}
	
	rw_addr = addr;
}
void MPI_1801VM1::Word_RW_Write( word & wData )
{
	if( rw_addr < 0 )
	{
		int nReg = -1*rw_addr - 1;
		/*
		if( nReg > 7 )
		{
			char str[512];
			sprintf(str,"Program ERROR - bad rw_addr: %i. : %06o \n", rw_addr, rw_addr );
			ErrLog(str);
			EM_LOG(str);
			pConfigI->ExitProgram();
		}//*/

		r[nReg] = wData;
//		rw_addr = -222;
		return;
	}

	WordWrite( rw_addr, wData, 2, true );
	
//	rw_addr = -222;
}

//
void MPI_1801VM1::ByteRead0( byte nOpMode, word & wData, bool bMTPS )
{
	word        addr;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			if( bVM1G ) { nInterruptCheck_Clk_Addon = 5; }
			else        { nInterruptCheck_Clk_Addon = 3; }

			int nReg = nOpMode & 07;
			if( nReg == 7 && !bMTPS )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
				
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				if( !bVM1G )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
				{
					BusClocksDelay(1);
				}
			}
			
			wData = (byte) r[nReg]; 
			return;
		}

		case 01:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg]++;
			if( nReg >= 6 ) { r[nReg]++; }

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg] += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			int nReg = nOpMode & 07;
			r[nReg]--;
			if( nReg >= 6 ) { r[nReg]--; }
			addr = r[nReg];

			nALU_Delay += 3;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			int nReg = nOpMode & 07;
			r[nReg] -= 2;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( r[nReg], addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

	bPreFetchEnabled = false;

	ByteRead( addr, wData );

	if( nMode == 2 && !nRPLY_ON_Latency && !bMTPS )
	{
		BusClocksDelay(1);
	}

	nALU_Delay = 3;
	Make_ALU_Delay();
}

void MPI_1801VM1::ByteRead1( byte nOpMode, word & wData )
{
	word        addr;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			int nReg = nOpMode & 07;
			if( nReg == 7 )
			{
				bPreFetchEnabled = false;
			}
			
			nFirstOperandReg = nReg;
			
			wData = (byte) r[nReg]; 
			return;
		}

		case 01:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg]++;
			if( nReg >= 6 ) { r[nReg]++; }

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg] += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			int nReg = nOpMode & 07;
			r[nReg]--;
			if( nReg >= 6 ) { r[nReg]--; }
			addr = r[nReg];

			nALU_Delay += 3;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			int nReg = nOpMode & 07;
			r[nReg] -= 2;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( r[nReg], addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

	nFirstOperandReg = -1;
	bPreFetchEnabled = false;

	ByteRead( addr, wData );
	
	nALU_Delay = 3;

	nInterruptCheck_Clk_Addon = 3;
}

void MPI_1801VM1::ByteRead2( byte nOpMode, word & wData )
{
	word        addr;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			int nReg = nOpMode & 07;

			wData = (byte) r[nReg]; 

			bPreFetchEnabled = true;

			if( nReg == 7 || nFirstOperandReg == 7 )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
				
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				if( bVM1G && nFirstOperandReg >= 0 )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				{
					if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}
			else
			if( nFirstOperandReg >= 0 )
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 3; }
				else        { nInterruptCheck_Clk_Addon = 5; }
			}

			if( nFirstOperandReg < 0 )
			{
				nInterruptCheck_Clk_Addon = 5;
			}

			return;
		}

		case 01:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg]++;
			if( nReg >= 6 ) { r[nReg]++; }

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg] += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			int nReg = nOpMode & 07;
			r[nReg]--;
			if( nReg >= 6 ) { r[nReg]--; }
			addr = r[nReg];

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			int nReg = nOpMode & 07;
			r[nReg] -= 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();

			WordRead( r[nReg], addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}
	
	bPreFetchEnabled = false;

	ByteRead( addr, wData );

	if( nMode == 2 && !nRPLY_ON_Latency )
	{
		BusClocksDelay(1);
	}

	nALU_Delay = 3;
	Make_ALU_Delay();
}

void MPI_1801VM1::ByteWrite2( byte nOpMode, byte nOp1Mode, word & wData )
{
	word        addr;
	int         nDOUT_Delay = 2;
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			bPreFetchEnabled = true;

			int nReg = nOpMode & 07;
			
			if( nReg == 7 || nFirstOperandReg == 7 )
			{
				bPreFetchEnabled = false;

				WordRead( PC, wMegaBugData );

				if( nReg == 7 )
				{
					int nOverrun;
					
					if( bVM1G && nFirstOperandReg >= 0 ) 
					{
						nOverrun = ( nRPLY_ON_Latency < 8 ? (8 - nRPLY_ON_Latency) : 0 );

						int nAddon = nRPLY_ON_Latency + nRPLY_OFF_Latency - 8;
						
						if( nAddon > 0 )
						{
							nInterruptCheck_Clk = 3 + nAddon;
						}
					}
					else        
					{
						nOverrun = ( nRPLY_ON_Latency < 6 ? (6 - nRPLY_ON_Latency) : 0 );
						
						int nAddon = nRPLY_ON_Latency + nRPLY_OFF_Latency - 6;
						
						if( nAddon > 0 )
						{
							nInterruptCheck_Clk = 3 + nAddon;
						}
					}

					nALU_Delay = nOverrun;
					Make_ALU_Delay();
				}
			}
		

			short nWord = (char) wData;
			r[nReg] = nWord;
			
			
			if( nReg != 7 && nFirstOperandReg != 7 )
			{
				if( bVM1G && nFirstOperandReg >= 0 )
				{
					nOverrun = ( nRPLY_ON_Latency < 5 ? (5 - nRPLY_ON_Latency) : 0 );
					nInterruptCheck_Clk_Addon = ( nOverrun ? 3 - nRPLY_ON_Latency : -2 );
				}
				else
				{
					nOverrun = ( nRPLY_ON_Latency < 3 ? (3 - nRPLY_ON_Latency) : 0 );
					nInterruptCheck_Clk_Addon = nOverrun;
				}
			}

			return;
		}

		case 01:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];

			nDOUT_Delay = 3;

			if( nRPLY_OFF_Latency > 3 && nFirstOperandReg < 0 )
			{
				nDOUT_Delay--;
			}

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg]++;
			if( nReg >= 6 ) { r[nReg]++; }

			nDOUT_Delay = 6;

			if( nRPLY_OFF_Latency > 3 && nFirstOperandReg < 0 )
			{
				nDOUT_Delay--;
			}

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg] += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			int nReg = nOpMode & 07;
			r[nReg]--;
			if( nReg >= 6 ) { r[nReg]--; }
			addr = r[nReg];

			nDOUT_Delay = 5;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			int nReg = nOpMode & 07;
			r[nReg] -= 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();

			WordRead( r[nReg], addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			addr = PC;
			PC += 2;
			
			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

	
	ByteWrite( addr, wData, nDOUT_Delay );

	nALU_Delay = 3;
	Make_ALU_Delay();
}

void MPI_1801VM1::Byte_RW_Read0( byte nOpMode, word & wData, bool bMFPS )
{
	word        addr;
	/*
	if( rw_addr != -222 )
	{
		char str[512];
		sprintf(str,"Program ERROR - bad rw_addr: %i. : %06o \n", rw_addr, rw_addr );
		ErrLog(str);
		EM_LOG(str);
		pConfigI->ExitProgram();
	}//*/
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			int nReg = nOpMode & 07;
			wData = (byte) r[nReg];
			
			rw_addr = -1*(nReg+1);

			if( nReg == 7 )
			{
				bPreFetchEnabled = false;
				
				word          data;
				WordRead( PC, data );

				if( bMFPS )
				{
					int nDelay = 6 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }

					nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency - 3;

					if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }
				}
				else
				{
					nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
					
					if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


					if( !bVM1G )
					{
						int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
						if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
					}
					else
					{
						if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
						{
							BusClocksDelay(1);
						}
					}
				}
			}
			else
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 5; }
				else        { nInterruptCheck_Clk_Addon = 3; }

				if( bMFPS )
				{
					nOverrun = ( nRPLY_ON_Latency < 3 ? (3 - nRPLY_ON_Latency) : 0 );

					if( nOverrun ) { nInterruptCheck_Clk_Addon = 3; }
					else           { nInterruptCheck_Clk_Addon = 0; }
				}
			}
			return;
		}

		case 01:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg]++;
			if( nReg >= 6 ) { r[nReg]++; }

			nALU_Delay += 2;
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg] += 2;

			nALU_Delay += 2;
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			int nReg = nOpMode & 07;
			r[nReg]--;
			if( nReg >= 6 ) { r[nReg]--; }
			addr = r[nReg];

			nALU_Delay += 3;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			int nReg = nOpMode & 07;
			r[nReg] -= 2;

			nALU_Delay += 3;
			Make_ALU_Delay();

			WordRead( r[nReg], addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			nALU_Delay += 2;
			Make_ALU_Delay();

			addr = PC;
			PC += 2;
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}

	ByteRead( addr, wData, true );

	if( nMode == 2 && !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
	{
		BusClocksDelay(1);
	}

	nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency*2 + 5;

	if( bSEL_Mode )
	{
		nInterruptCheck_Clk = 4;
	}
	
	rw_addr = addr;
}
void MPI_1801VM1::Byte_RW_Read2( byte nOpMode, word & wData )
{
	word        addr;
	/*
	if( rw_addr != -222 )
	{
		char str[512];
		sprintf(str,"Program ERROR - bad rw_addr: %i. : %06o \n", rw_addr, rw_addr );
		ErrLog(str);
		EM_LOG(str);
		pConfigI->ExitProgram();
	}//*/
	
	byte nMode = (nOpMode & 070)>>3;
	__assume( nMode <= 7 );
	switch( nMode )
	{
		case 00:
		{
			Make_ALU_Delay();

			int nReg = nOpMode & 07;
			wData = (byte) r[nReg];

			rw_addr = -1*(nReg+1);
			
			bPreFetchEnabled = true;

			if( nFirstOperandReg < 0 )
			{
				nInterruptCheck_Clk_Addon = 5;
			}

			if( nReg == 7 || nFirstOperandReg == 7 )
			{
				bPreFetchEnabled = false;

				word          data;
				WordRead( PC, data );

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + 2;
			
				if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }


				if( bVM1G && nFirstOperandReg >= 0 )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				{
					if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}
			else
			if( nFirstOperandReg >= 0 )
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 3; }
				else        { nInterruptCheck_Clk_Addon = 5; }
			}
			
			return;
		}

		case 01:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 02:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg]++;
			if( nReg >= 6 ) { r[nReg]++; }

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
		}
		break;

		case 03:
		{
			int nReg = nOpMode & 07;
			addr = r[nReg];
			r[nReg] += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 04:
		{
			int nReg = nOpMode & 07;
			r[nReg]--;
			if( nReg >= 6 ) { r[nReg]--; }
			addr = r[nReg];

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();
		}
		break;

		case 05:
		{
			int nReg = nOpMode & 07;
			r[nReg] -= 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			nALU_Delay++;
			Make_ALU_Delay();

			WordRead( r[nReg], addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 06:
		{
			addr = PC;
			PC += 2;

			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();

			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;

		case 07:
		{
			addr = PC;
			PC += 2;
			
			if( nFirstOperandReg >= 0 ) 
			{
				nALU_Delay += 8;
			}
			Make_ALU_Delay();
			
			WordRead( addr, addr );
			addr += r[nOpMode & 07];

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}

			WordRead( addr, addr );

			if( !nRPLY_OFF_Latency )
			{
				BusClocksDelay(1);
			}
		}
		break;
	}
	

	ByteRead( addr, wData, true );

	if( nMode == 2 && !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
	{
		BusClocksDelay(1);
	}

	nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency*2 + 5;

	if( bSEL_Mode )
	{
		nInterruptCheck_Clk = 4;
	}
	
	rw_addr = addr;
}
void MPI_1801VM1::Byte_RW_Write( word & wData, bool bMFPS )
{
	if( rw_addr < 0 )
	{
		int nReg = -1*rw_addr - 1;
		/*
		if( nReg > 7 )
		{
			char str[512];
			sprintf(str,"Program ERROR - bad rw_addr: %i. : %06o \n", rw_addr, rw_addr );
			ErrLog(str);
			EM_LOG(str);
			pConfigI->ExitProgram();
		}//*/

		if( bMFPS )
		{
			short nWord = (char) wData;
			r[nReg] = nWord;
		}
		else
		{
			*(byte*)(&r[nReg]) = (byte) wData;
		}
//		rw_addr = -222;
		return;
	}

	ByteWrite( rw_addr, wData, 2, true );
	
//	rw_addr = -222;
}

//
void MPI_1801VM1::Clock()
{
	if( !pMainFiber )
	{
		SafeConvertThreadToFiber( NULL );

		pMainFiber = GetCurrentFiber();

		if( !pCPU_Fiber )
		{
			pCPU_Fiber = CreateFiber( 0, MPI_1801VM1_CPU_FiberStart, this );
		}
	}

	///////////////////

	if( pVM1_bus->CLC )
	{
		if( nCLC0_AD >= 0 )
		{
			pVM1_bus->AD = (word) nCLC0_AD;
			nCLC0_AD = -1;
		}
	
		if( bSEL_Mode )
		{
			if( pVM1_bus->DIN && !CLC0_DIN )
			{
				pVM1_bus->RPLY = false;
			}

			if( !pVM1_bus->DIN && CLC0_DIN )
			{
				pVM1_bus->RPLY = true;
			}

			if( !pVM1_bus->DOUT && CLC0_DOUT )
			{
				pVM1_bus->RPLY = true;
			}
		}
		
		pVM1_bus->DIN  = CLC0_DIN;
		pVM1_bus->DOUT = CLC0_DOUT;
		pVM1_bus->WTBT = CLC0_WTBT;

		return;
	}


	bool DCLO = pVM1_bus->DCLO;

	if( !DCLO || !DCLO_Prev )
	{
		pVM1_bus->INIT = DCLO;
	}

	///////////////////

	if( !DCLO && DCLO_Prev )
	{
		DeleteFiber( pCPU_Fiber );
		pCPU_Fiber = CreateFiber( 0, MPI_1801VM1_CPU_FiberStart, this );
	}
	
	DCLO_Prev = DCLO;

	///////////////////

	if( !pVM1_bus->ACLO )
	{
		if( nACLO_OFF_Clk )
		{
			nACLO_ON_Clk  = 1;
			nACLO_OFF_Clk = 0;
		}
		else
		if( nACLO_ON_Clk )
		{
			if( nACLO_ON_Clk < MAX_INTERRUPT_CLK )
			{
				nACLO_ON_Clk++;
			}
		}
	}
	else
	{
		if( nACLO_ON_Clk )
		{
			if( nACLO_OFF_Clk < MAX_INTERRUPT_CLK )
			{
				nACLO_ON_Clk++;
				nACLO_OFF_Clk++;
			}
			else
			{
				nACLO_ON_Clk = 0;
			}
		}
		else
		{//       CheckInterrupts()
			nACLO_OFF_Clk = MAX_INTERRUPT_CLK;
		}
	}

	///////////////////

	if( !pVM1_bus->HALT )
	{
		if( nHALT_OFF_Clk )
		{
			nHALT_ON_Clk  = 1;
			nHALT_OFF_Clk = 0;
		}
		else
		if( nHALT_ON_Clk < MAX_INTERRUPT_CLK )
		{
			nHALT_ON_Clk++;
		}
	}
	else
	{
		if( nHALT_ON_Clk )
		{
			if( nHALT_OFF_Clk < MAX_INTERRUPT_CLK )
			{
				nHALT_ON_Clk++;
				nHALT_OFF_Clk++;
			}
			else
			{
				nHALT_ON_Clk = 0;
			}
		}
	}

	///////////////////

	if( !pVM1_bus->EVNT )
	{
		if( nEVNT_OFF_Clk )
		{
			nEVNT_ON_Clk  = 1;
			nEVNT_OFF_Clk = 0;
		}
		else
		if( nEVNT_ON_Clk )
		{
			if( nEVNT_ON_Clk < MAX_INTERRUPT_CLK )
			{
				nEVNT_ON_Clk++;
			}
		}
	}
	else
	{
		if( nEVNT_ON_Clk )
		{
			if( nEVNT_OFF_Clk < MAX_INTERRUPT_CLK )
			{
				nEVNT_ON_Clk++;
				nEVNT_OFF_Clk++;
			}
			else
			{
				nEVNT_ON_Clk = 0;
			}
		}
		else
		{//       CheckInterrupts()
			nEVNT_OFF_Clk = MAX_INTERRUPT_CLK;
		}
	}

	///////////////////

	if( pVM1_bus->IRQ == 0 )
	{
		if( nIRQ_OFF_Clk )
		{
			nIRQ_ON_Clk  = 1;
			nIRQ_OFF_Clk = 0;
		}
		else
		if( nIRQ_ON_Clk < MAX_INTERRUPT_CLK )
		{
			nIRQ_ON_Clk++;
		}
	}
	else
	{
		if( nIRQ_ON_Clk )
		{
			if( nIRQ_OFF_Clk < MAX_INTERRUPT_CLK )
			{
				nIRQ_ON_Clk++;
				nIRQ_OFF_Clk++;
			}
			else
			{
				nIRQ_ON_Clk = 0;
			}
		}
	}

	///////////////////


	////////////////////////////
	SwitchToFiber( pCPU_Fiber );
	////////////////////////////

	nCLK++;

	if( bHardReset )
	{
		DeleteFiber( pCPU_Fiber );
		pCPU_Fiber = CreateFiber( 0, MPI_1801VM1_CPU_FiberStart, this );
	}

	///////////////////

	if( pVM1_bus->SYNC )
	{
		word  addr = ~ pVM1_bus->AD;

		addr &= ~1;
		
		if( addr == SEL1 )
		{
			pVM1_bus->SEL1 = false;
			pVM1_bus->SEL2 = true;
		}
		else
		if( addr == SEL2 )
		{
			pVM1_bus->SEL1 = true;
			pVM1_bus->SEL2 = false;
		}
		else
		{
			pVM1_bus->SEL1 = true;
			pVM1_bus->SEL2 = true;
		}
		
		if( !pVM1_bus->BSY  )
		{
			bSEL_Mode = false;

			if( ( addr & 0177760 ) == 0177700 )
			{
				bSEL_Mode = true;
			}
		}
	}
}
void MPI_1801VM1::ResetInterruptTriggers()
{
	if( !pVM1_bus->ACLO )
	{
		nACLO_ON_Clk  = 0;
		nACLO_OFF_Clk = 0;
	}
	else
	{
		nACLO_ON_Clk  = 0;
		nACLO_OFF_Clk = MAX_INTERRUPT_CLK;
	}

	if( !pVM1_bus->EVNT )
	{
		nEVNT_ON_Clk  = 0;
		nEVNT_OFF_Clk = 0;
	}
	else
	{
		nEVNT_ON_Clk  = 0;
		nEVNT_OFF_Clk = MAX_INTERRUPT_CLK;
	}
}
bool MPI_1801VM1::CheckInterrupts( bool bFetch )
{
/*
{
char str[512];

if( bFetch )
{
sprintf(str,"\n bFetch: %i  ;  nInterruptCheck_Clk: %2i [%i+%i+%i]  ;  nHALT_ON_Clk: %6i  ;  nHALT_OFF_Clk: %6i \n\n", 
                bFetch, nInterruptCheck_Clk, nRPLY_ON_Latency, nRPLY_OFF_Latency, nInterruptCheck_Clk_Addon, nHALT_ON_Clk, nHALT_OFF_Clk );
}
else
{
sprintf(str,"\n bFetch: %i  ;  nInterruptCheck_Clk: %2i ;  nHALT_ON_Clk: %6i  ;  nHALT_OFF_Clk: %6i \n\n", 
                bFetch, nInterruptCheck_Clk, nHALT_ON_Clk, nHALT_OFF_Clk );
}
L(str);
}//*/

	bool bACLO = ( nACLO_ON_Clk >= nInterruptCheck_Clk && nACLO_OFF_Clk < nInterruptCheck_Clk );

	if( nACLO_ON_Clk >= nInterruptCheck_Clk )
	{
		nACLO_ON_Clk  = 0;
		nACLO_OFF_Clk = 0;
	}

	if( bACLO )
	{
		if( !bWait2 )
		{
			if( !bFetch )
			{
				word          data;
				WordRead( PC, data );
				
				nALU_Delay = 2;
			}

			Make_ALU_Delay();
		}
		else
		{
			BusClocksDelay(5);
		}

		BusClocksDelay(1);

		bWait2 = false;

		TrapTo_24();
		return true;
	}

	////////////////////////////////////

	bool bHALT = ( nHALT_ON_Clk >= nInterruptCheck_Clk && nHALT_OFF_Clk < nInterruptCheck_Clk );

	if( bHALT )
	{
		if( !bWait2 )
		{
			if( !bFetch )
			{
				word          data;
				WordRead( PC, data );
				
				nALU_Delay = 2;
			}

			Make_ALU_Delay();
		}
		else
		{
			BusClocksDelay(5);
		}

		BusClocksDelay(1);

		bWait2 = false;

		HALT_TrapToRomOffset( 02, true );
		return true;
	}

	////////////////////////////////////

	if( PSW & BIT_7 )
	{
		return false;
	}

	////////////////////////////////////

	bool bEVNT = ( nEVNT_ON_Clk >= nInterruptCheck_Clk && nEVNT_OFF_Clk < nInterruptCheck_Clk );

	if( nEVNT_ON_Clk >= nInterruptCheck_Clk )
	{
		nEVNT_ON_Clk  = 0;
		nEVNT_OFF_Clk = 0;
	}

	if( bEVNT )
	{
		if( !bWait2 )
		{
			if( !bFetch )
			{
				word          data;
				WordRead( PC, data );
				
				nALU_Delay = 2;
			}

			Make_ALU_Delay();
		}
		else
		{
			BusClocksDelay(5);
		}

		BusClocksDelay(1);

		bWait2 = false;

		TrapTo_100();
		return true;
	}

	////////////////////////////////////

	bool bIRQ = ( nIRQ_ON_Clk >= nInterruptCheck_Clk && nIRQ_OFF_Clk < nInterruptCheck_Clk );

	if( bIRQ )
	{
		if( !bWait2 )
		{
			if( !bFetch )
			{
				word          data;
				WordRead( PC, data );
				
				nALU_Delay = 2;
			}

			Make_ALU_Delay();
		}
		else
		{
			BusClocksDelay(5);
		}

		BusClocksDelay(1);

		bWait2 = false;

		HardTrap();
		return true;
	}
	
	return false;
}
void MPI_1801VM1::CPU_Step()
{
	word nWord;

// NEXT_TRY:

	if( nNestedTrapsTo4 )
	{
		TrapTo_4();
		return;
	}

	/////////////////////////

	if( !pVM1_bus->DCLO )
	{
		SwitchToFiber( pMainFiber );
		return;
	}

	/////////////////////////


	if( bWait && !(PSW & BIT_10) )
	{
		if( !(PSW & BIT_10) && !nWaitPhase )
		{
			nWaitPhase = 2;
		
			if( ( (nACLO_ON_Clk && !nACLO_OFF_Clk) && !( bVM1G && nT_bit_Flag ) ) || ( !(PSW & BIT_11) && !pVM1_bus->HALT ) )
			{
				bWait = false;
				bWait2 = true;
			}
			else
			if( ( (nEVNT_ON_Clk && !nEVNT_OFF_Clk) || pVM1_bus->IRQ == 0 ) && !(PSW & BIT_7 ) )
			{
				bWait = false;
				bWait2 = true;
			}
			else
			{
				SwitchToFiber( pMainFiber );
				return;
			}
		}
		else
		{
			if( nWaitPhase )
			{
				nWaitPhase--;
			}
			SwitchToFiber( pMainFiber );
			return;
		}
	}


try {
//		while( nStepsToGo-- )
		{
			if( !nSTEP_Flag && !(PSW & BIT_10) )
			{
				if( !nT_bit_Flag || bWait2 )
				{
					if( !bPreFetchEnabled )
					{
						if( CheckInterrupts1() )
						{
							return;
						}
					}
				}

				if( !( --nT_bit_Flag ) )
				{
					if( !bRTT )
					{
						TrapTo_14();
						return;
					}
				}
				else
				if( nT_bit_Flag == 1 )
				{
					bRTT = true;
				}

				if( nT_bit_Flag < 0 )
				{
					nT_bit_Flag = 0;
				}
			}


			//////////////
			Fetch( nWord );
			//////////////
			

			while( nOverrun )
			{
				nOverrun--;
				BusClocksDelay(1);
			}
			
			nALU_Delay = 2;

			if( bPreFetchEnabled )
			{//       .
				nALU_Delay++;
			}


			if( bPreFetchEnabled || bRTT )
			{
				if( !nSTEP_Flag && !(PSW & BIT_10) )
				{
					if( !nT_bit_Flag )
					{
						PC -= 2;

						if( bRTT )
						{
							nALU_Delay += 1;
							Make_ALU_Delay();
							
							TrapTo_14();

							bRTT = false;

							if( PSW & T )
							{
								bRTT = true;
							}

							nOverrun = 0;
							return;
						}
						
						nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency + nInterruptCheck_Clk_Addon;

						if( CheckInterrupts2() )
						{
							return;
						}

						PC += 2;
					}
				}
			}

			nSTEP_Flag = 0;

			bPreFetchEnabled = true;
			nInterruptCheck_Clk = 3;
			nInterruptCheck_Clk_Addon = 2;


			if( nWord <= 016 )
			{
				switch( nWord )
				{
					// HALT
					case 00:
					{
						nALU_Delay += 3;
						Make_ALU_Delay();

						HALT_TrapToRomOffset( 02 );					
						return; /* continue */
					}


					// WAIT
					case 01:
					{
						nALU_Delay += 3;
						Make_ALU_Delay();

						bWait = true;
						nWaitPhase = 0;
						bPreFetchEnabled = false;
						nInterruptCheck_Clk = 1;
						nSTEP_Flag = 0;
						return;
					}
				  

					// RTI
					case 02:
					{
						Make_ALU_Delay();

						WordRead( SP, PC );

						nALU_Delay += 3;
						Make_ALU_Delay();

						word wOldPSW = PSW;

						SP += 2;
						WordRead( SP, PSW );
						PSW &= 0xFF;
						SP += 2;
						
						bRTT = false;
						bPreFetchEnabled = false;

						if( PSW & T || wOldPSW & T )
						{
							nT_bit_Flag = 1;

							nALU_Delay += 3;
						}

						nALU_Delay += 2;
						Make_ALU_Delay();

						if( bVM1G ) { BusClocksDelay(3); }
						else        { BusClocksDelay(6); }

						return; /* continue */
					}


					// BPT
					case 03:
					{
						nALU_Delay += 3;
						Make_ALU_Delay();

						TrapTo(014);
					
						if( bVM1G ) { BusClocksDelay(1); }
						else        { BusClocksDelay(6); }

						return; /* continue */
					}


					// IOT
					case 04:
					{
						nALU_Delay += 3;
						Make_ALU_Delay();

						TrapTo(020);

						if( bVM1G ) { BusClocksDelay(1); }
						else        { BusClocksDelay(6); }

						return; /* continue */
					}


					// RESET
					case 05:
					{
		//				sprintf(str,"\r%06o: RESET\r", Last_PC );
		//				DebugOut(str);

		//				Init();

						Make_ALU_Delay();
						
						pVM1_bus->INIT = false;
						
						BusClocksDelay(566);

						pVM1_bus->INIT = true;

						BusClocksDelay(1);

						/////////////////////////
						ResetInterruptTriggers();
						/////////////////////////
						
						bool bCpuReset = false;

						if( !pVM1_bus->ACLO ) 
						{
							bCpuReset = true;
							pVM1_bus->INIT = false;
						}

						BusClocksDelay(1);

						if( !pVM1_bus->ACLO ) 
						{
							bCpuReset = true;
							pVM1_bus->INIT = false;
						}
						else
						if( bCpuReset )
						{
							pVM1_bus->INIT = true;

							BusClocksDelay(1);
							
							while( !pVM1_bus->ACLO )
							{
								BusClocksDelay(1);
							}
							bHardReset = true;
							SwitchToFiber( pMainFiber );
							return;
						}

						BusClocksDelay(1);

						if( bCpuReset )
						{
							pVM1_bus->INIT = true;

							BusClocksDelay(1);

							while( !pVM1_bus->ACLO )
							{
								BusClocksDelay(1);
							}
							bHardReset = true;
							SwitchToFiber( pMainFiber );
							return;
						}

						BusClocksDelay(567);

						bPreFetchEnabled = false;
						
						return; /* continue */
					}
					


					// RTT
					case 06:
					{
						Make_ALU_Delay();

						WordRead( SP, PC );
						SP += 2;

						nALU_Delay += 3;
						Make_ALU_Delay();

						word wOldPSW = PSW;

						WordRead( SP, PSW );
						SP += 2;

						PSW &= 0xFF;

						bRTT = false;
						bPreFetchEnabled = false;

						if( PSW & T )
						{
							bRTT = true;
							bPreFetchEnabled = true;

							nT_bit_Flag = 2;
						}
						else
						if( wOldPSW & T )
						{
							nT_bit_Flag = 1;
							
							nALU_Delay += 3;
						}

						nALU_Delay += 2;
						Make_ALU_Delay();

						if( bVM1G ) { BusClocksDelay(3); }
						else        { BusClocksDelay(6); }

						return; /* continue */
					}
					

					
					// START
					case 010:
					case 011:
					case 012: // <--
					case 013:
					{
						nALU_Delay += 4;
						Make_ALU_Delay();

						WordRead( 0177674, PC  );

						nALU_Delay += 4;
						Make_ALU_Delay();
						
						WordRead( 0177676, PSW );

						nALU_Delay += 4;
						Make_ALU_Delay();

						word  wSEL1;
						WordRead( SEL1, wSEL1, true );
						wSEL1 &= (~BIT_3);
						WordWrite(SEL1, wSEL1, 2, true );

						PSW &= ~(BIT_9|BIT_8);

						nT_bit_Flag = 0;
						bRTT = false;

						bPreFetchEnabled = false;

						if( !(PSW & BIT_10) && ( PSW & T ) )
						{
							nT_bit_Flag = 1;
							bRTT = true;
						}
						
						nInterruptCheck_Clk = 4;
						
						return; /* continue */
					}

						

					// STEP
					case 014:
					case 015:
					case 016: // <--
					case 017:
					{
						nALU_Delay += 4;
						Make_ALU_Delay();

						WordRead( 0177674, PC  );

						nALU_Delay += 4;
						Make_ALU_Delay();

						WordRead( 0177676, PSW );

						nALU_Delay += 4;
						Make_ALU_Delay();

						word  wSEL1;
						WordRead( SEL1, wSEL1, true );
						wSEL1 &= (~BIT_3);
						WordWrite(SEL1, wSEL1, 2, true );

						PSW &= ~(BIT_9|BIT_8);
						
						nSTEP_Flag = 1;

						nT_bit_Flag = 0;
						bRTT = false;

						if( !(PSW & BIT_10) && ( PSW & T ) )
						{
							nT_bit_Flag = 1;
							bRTT = true;
						}

						bPreFetchEnabled = true;
						
						return; /* continue */
					}


					
					default:
						TrapTo_10();
						return; /* continue */
				}
		  }


		  if( nWord <= 0177 )
		  {
			if( nWord & 0100 )
			{
			  // JMP
				PC = GetAddr( nWord & 077 );

				bPreFetchEnabled = false;

				if( bVM1G ) { nALU_Delay += 6; }
				else        { nALU_Delay += 9; }

				Make_ALU_Delay();

				return; /* continue */
			}

			TrapTo_10();
			return; /* continue */
		  }

		  if( nWord <= 0207 )
		  {
			int nReg = nWord & 07;

			// RTS
			PC = r[nReg];

			nALU_Delay += 8;
			Make_ALU_Delay();

			WordRead( SP, r[nReg] );
			SP += 2;

			bPreFetchEnabled = false;
			
			nALU_Delay += 3;
			Make_ALU_Delay();
			
			return; /* continue */
		  }


		  if( nWord < 0230 )
		  {
			TrapTo_10();
			return; /* continue */
		  }

/*
		  if( nWord <= 0237 )
		  {
			word nPriorityMask = (nWord & 07)<<5;

			// SPL
			PSW &= 0177437;
			PSW |= nPriorityMask;
			continue;
		  }
//*/
		  if( nWord <= 0237 )
		  {
			TrapTo_10();
			return; /* continue */
		  }

		  if( nWord <= 0257 )
		  { // NOP .. CCC
			word nMask = nWord & 017;
			PSW &= ~nMask;

			Make_ALU_Delay();
			
			if( !nRPLY_ON_Latency && nRPLY_OFF_Latency <  3 ) 
			{
				nOverrun = 1;
				nInterruptCheck_Clk_Addon = 3;
			}

			return; /* continue */
		  }

		  if( nWord <= 0277 )
		  { // NOP2 .. SCC
			word nMask = nWord & 017;
			PSW |= nMask;

			Make_ALU_Delay();

			if( !nRPLY_ON_Latency && nRPLY_OFF_Latency <  3 ) 
			{
				nOverrun = 1;
				nInterruptCheck_Clk_Addon = 3;
			}

			return; /* continue */
		  }


		  if( nWord <= 0377 )
		  {
			// SWAB
			word wOperand;
			Word_RW_Read0( nWord & 077, wOperand );
			
			byte *pByte0 = (byte*)(&wOperand);
			
			byte tmp0 = *(pByte0 + 0);
			byte tmp1 = *(pByte0 + 1);

			*(pByte0 + 0) = tmp1;
			*(pByte0 + 1) = tmp0;

			Word_RW_Write( wOperand );

			PSW &= ~(C|V|N|Z);

			if( (signed char) wOperand < 0 )
			{
				// N -> 1
				PSW |= N;
			}
			else
			if( (byte) wOperand == 0 )
			{
				// Z -> 1
				PSW |= Z;
			}
			
			if( !(nWord & 070) )
			{
				nInterruptCheck_Clk_Addon = 2;
				
				if( (nWord & 07) != 7 )
				{
					if( !nRPLY_ON_Latency && nRPLY_OFF_Latency <  3 ) 
					{
						nOverrun = 1;
						nInterruptCheck_Clk_Addon = 3;
					}
				}
			}
			else
			{
				nInterruptCheck_Clk -= 4;
				
				if( nInterruptCheck_Clk < 3 )
				{
					nInterruptCheck_Clk = 3;
				}
				
				if( !nRPLY_ON_Latency )
				{
					nALU_Delay = 1;
					Make_ALU_Delay();
				}
				else
				if( nRPLY_ON_Latency + nRPLY_OFF_Latency > 1 )
				{
					nInterruptCheck_Clk++;
				}
				
				if( bSEL_Mode )
				{
					BusClocksDelay(1);
					nInterruptCheck_Clk = 3;
				}
			}

			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 03777 )
		  {
			nALU_Delay += 5;
			Make_ALU_Delay();
			
			bPreFetchEnabled = false;
			
			switch( nWord & 03400 )
			{
			  case 0400:
				// BR
			  break;

			  case 01000:
				// BNE
				if( PSW & Z ) { return; /* continue */ }
			  break;

			  case 01400:
				//BEQ
				if( !(PSW & Z) ) { return; /* continue */ }
			  break;

			  case 02000:
				// BGE
				if( ((PSW & N)!=0)^((PSW & V)!=0) ) { return; /* continue */ }
			  break;

			  case 02400:
				// BLT
				if( !(((PSW & N)!=0)^((PSW & V)!=0)) ) { return; /* continue */ }
			  break;

			  case 03000:
				// BGT
				if( (PSW & Z) || (((PSW & N)!=0)^((PSW & V)!=0)) ) { return; /* continue */ }
			  break;

			  case 03400:
				// BLE
				if( !(PSW & Z) && !(((PSW & N)!=0)^((PSW & V)!=0)) ) { return; /* continue */ }
			  break;

			  default:
				TrapTo_10();
				return; /* continue */
			}

			int nOffset = (signed char)(nWord & 0377);
			nOffset *= 2;

			PC += nOffset;
			return; /* continue */
		  }


		  if( nWord <= 04777 )
		  { // JSR
			int nReg = ( nWord & 0700 )>>6;

			word tmp_PC = GetAddr( nWord & 077 );

			if( bVM1G ) { nALU_Delay += 4; }
			else        { nALU_Delay += 7; }
			
			Make_ALU_Delay();

			SP -= 2;
			WordWrite( SP, r[nReg], 2 );
			
			r[nReg] = PC;
			PC = tmp_PC;

			int nDelay = 4 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
			if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
			else             { nDelay = 0;               }

			nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency - 1;
			
			if( nInterruptCheck_Clk < 3 ) { nInterruptCheck_Clk = 3; }

			return; /* continue */
		  }


		  if( nWord >= 05700 && nWord <= 05777 )
		  {
			word wOperand;
			WordRead0( nWord & 077, wOperand );
			// TST
			PSW &= ~(C|V|Z|N);

			if( (signed short)wOperand < 0 )
			{
				PSW |= N;
			}
			else
			if( wOperand == 0 )
			{
				PSW |= Z;
			}
			
			return; /* continue */
		  }


		  if( nWord <= 05077 )
		  {
		    //  CLR
			word wOperand;
			Word_RW_Read0( nWord & 077, wOperand );

			wOperand = 0;
			Word_RW_Write( wOperand );

			PSW |= Z;
			PSW &= ~(C|V|N);
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 06377 )
		  {
			word wOperand;
			Word_RW_Read0( nWord & 077, wOperand );
			
			switch( nWord & 07700 )
			{
				case 05100:
				{
				  // COM

					wOperand = ~wOperand;

					Word_RW_Write( wOperand );

					PSW |= C;
					PSW &= ~(V|Z|N);

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05200:
				{
				  // INC

					wOperand += 1;

					Word_RW_Write( wOperand );

					PSW &= ~(V|Z|N);

					if( wOperand == 0100000 )
					{
						PSW |= V;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05300:
				{
				  // DEC

					wOperand -= 1;

					Word_RW_Write( wOperand );

					PSW &= ~(V|Z|N);

					if( wOperand == 077777 )
					{
						PSW |= V;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05400:
				{
				  // NEG

					wOperand *= -1;

					Word_RW_Write( wOperand );

					PSW |= C;
					PSW &= ~(V|Z|N);

					if( wOperand == 0100000 )
					{
						PSW |= V;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
						PSW &= ~C;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05500:
				{
				  // ADC
					bool bFlag = false;

					if( PSW & C )
					{
						bFlag = true;
						wOperand += 1;
					}

					Word_RW_Write( wOperand );

					PSW &= ~(C|V|Z|N);

					if( bFlag && ( wOperand == 0100000 ) )
					{
						PSW |= V;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
						if( bFlag )
						{
							PSW |= C;
						}
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05600:
				{
				  // SBC
					bool bFlag = false;

					if( PSW & C )
					{
						bFlag = true;
						wOperand -= 1;
					}

					Word_RW_Write( wOperand );

					PSW &= ~(C|V|Z|N);

					if( bFlag )
					{
						if( wOperand == 0177777 )
						{
							PSW |= C;
						}
						else
						if( wOperand == 077777 )
						{
							PSW |= V;
						}
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06000:
				{
				  // ROR

					word bit0 = wOperand &1;
					wOperand >>= 1;
				  
					if( PSW & C )
					{
						wOperand |= 0100000;
					}

					Word_RW_Write( wOperand );

					PSW &= ~(C|V|Z|N);

					if( bit0 )
					{
						PSW |= C;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06100:
				{
				  // ROL

					word bit15 = wOperand &0100000;
					wOperand <<= 1;

					if( PSW & C )
					{
						wOperand |= 1;
					}

					Word_RW_Write( wOperand );

					PSW &= ~(C|V|Z|N);

					if( bit15 )
					{
						PSW |= C;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06200:
				{
				  // ASR
				  
					word bit0  = wOperand &1;
					word bit15 = wOperand &0100000;
					wOperand >>= 1;

					if( bit15 )
					{
						wOperand |= 0100000;
					}

					Word_RW_Write( wOperand );

					PSW &= ~(C|V|Z|N);

					if( bit0 )
					{
						PSW |= C;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;

				case 06300:
				{
				  // ASL

					word bit15 = wOperand &0100000;
					wOperand <<= 1;

					Word_RW_Write( wOperand );

					PSW &= ~(C|V|Z|N);

					if( bit15 )
					{
						PSW |= C;
					}

					if( (signed short)wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord >= 06400 && nWord <= 06477 )
		  { // MARK
			SP = PC + ((nWord & 077)<< 1) + 2;
			PC = R5;

			nALU_Delay += 9;
			Make_ALU_Delay();


			WordRead( SP - 2, R5 );

			bPreFetchEnabled = false;
			
			nALU_Delay += 3;
			Make_ALU_Delay();
			
			return; /* continue */
		  }


		  if( nWord >= 06700 && nWord <= 06777 )
		  { // SXT
			word wOperand;
			Word_RW_Read0( nWord & 077, wOperand );

			PSW &= ~(V|Z);

			if( PSW & N )
			{
				wOperand = 0177777;
			}
			else
			{
				wOperand = 0;
				PSW |= Z;
			}

			Word_RW_Write( wOperand );

			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord < 010000 )
		  {
			TrapTo_10();
			return; /* continue */
		  }



		  if( nWord >= 020000 && nWord <= 037777 )
		  {
			word  wOperand1;
			WordRead1( (nWord & 07700)>>6, wOperand1 );
			
			word  wOperand2;
			WordRead2( nWord & 077, wOperand2 );
			
			switch( nWord & 070000 )
			{
				case 020000:
				{
				  // CMP
					short nRes = (short) wOperand1 - (short) wOperand2;

					PSW &= ~(C|V|Z|N);

					if( nRes < 0 )
					{
						PSW |= N;
					}
					else
					if( nRes == 0 )
					{
						PSW |= Z;
					}

					if( wOperand1 < wOperand2 )
					{
						PSW |= C;
					}
  
					if( nRes *(short)wOperand2 > 0  && ((nRes < 0 && (short)wOperand1 >= 0) || (nRes >= 0 && (short)wOperand1 < 0)) )
					{
						PSW |= V;
					}
					
					return; /* continue */
				}
				break;



				case 030000:
				{
				  // BIT
				  short nRes = wOperand1 & wOperand2;

				  PSW &= ~(V|Z|N);

				  if( nRes < 0 )
				  {
					PSW |= N;
				  }
				  else
				  if( nRes == 0 )
				  {
					PSW |= Z;
				  }
				  return; /* continue */
				}
				break;
			}
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 017777 )
		  {
			byte nOp1 = (nWord & 07700)>>6;

			word wOperand1;
			WordRead1(  nOp1, wOperand1 );
			WordWrite2( nWord & 077, nOp1, wOperand1 );
			
			// MOV
			PSW &= ~(V|Z|N);

			if( (signed short) wOperand1 < 0 )
			{
				PSW |= N;
			}
			else
			if( wOperand1 == 0 )
			{
				PSW |= Z;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 067777 )
		  {
			word  wOperand1;
			WordRead1( (nWord & 07700)>>6, wOperand1 );
			
			word  wOperand2;
			Word_RW_Read2( nWord & 077, wOperand2 );


		    switch( nWord & 070000 )
		    {
				case 040000:
				{
				  // BIC
					wOperand2 &= ~wOperand1;
					
					Word_RW_Write( wOperand2 );

					PSW &= ~(V|Z|N);

					if( (signed short) wOperand2 < 0 )
					{
						PSW |= N;
					}
					else
					if( (signed short) wOperand2 == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;

				case 050000:
				{
				  // BIS
					wOperand2 |= wOperand1;

					Word_RW_Write( wOperand2 );

					PSW &= ~(V|Z|N);

					if( (signed short) wOperand2 < 0 )
					{
						PSW |= N;
					}
					else
					if( (signed short) wOperand2 == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;

				case 060000:
				{
				  // ADD
					unsigned long uRes = wOperand2 + wOperand1;

					Word_RW_Write( *((word*)&uRes) );

					PSW &= ~(C|V|Z|N);

					if( uRes > 0177777 )
					{
						PSW |= C;
					}

					if( (short)uRes < 0 )
					{
						PSW |= N;
					}
					else
					if( (short)uRes == 0 )
					{
						PSW |= Z;
					}

					if( (short)wOperand1 * (short)wOperand2 > 0  &&  (((short)uRes < 0 && (short)wOperand2 >= 0) || ((short)uRes >= 0 && (short)wOperand2 < 0)) )
					{
						PSW |= V;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		if( bVM1G )
		{
			if( nWord <= 070777 )
			{ // MUL
				int nReg = ( nWord & 0700 )>>6;
				short wOperand1 = r[nReg];
				word  wOperand2;

				int  nDelay = 0;
				
				if( nWord & 070 )
				{
					BusClocksDelay(3);
					
					nDelay -= 8;
				}
				
				WordRead0( nWord & 077, wOperand2, true );
				
				PSW &= ~(V|Z|N|C);
				
				int dwRes = wOperand1 * (short)wOperand2;
				
				r[nReg]   = word( dwRes >> 16 );
				r[nReg|1] = word( dwRes );

				if( !dwRes )
				{
					PSW |= Z;
				}
				else 
				if( dwRes < 0 )
				{
					PSW |= N;
				  
	  				nDelay += 5;
				}
				else
				if( dwRes == 32768 )
				{
					nDelay += 5;
				}

				
				if( dwRes < -32768 || dwRes > 32767 )
				{
					PSW |= C;

					nDelay -= 5;
				}
				
				bPreFetchEnabled = false;
				
				
				if( wOperand1 & 0100000 )
				{
					nDelay++;
				}

								
				for( word mask = 0100000 ; mask ; mask >>= 1 )
				{
					if( wOperand1 & mask )
					{
						nDelay += 5;
					}
				}

				nDelay += 246;

				BusClocksDelay( nDelay );
				
	//			dwCurrentStepsClocksCount += 431;

				return; /* continue */  //  goto RETURN_TRUE;
			}
		}
		
		/*
		  if( nWord <= 070777 )
		  { // MUL
			int nReg = ( nWord & 0700 )>>6;
			short wOperand1 = r[nReg];
			short wOperand2 = *RefWordRead( nWord & 077 );
			READ_DONE();
			
			PSW &= ~(V|Z|N|C);
			
			int dwRes = wOperand1 * wOperand2;
			
			r[nReg]   = word( dwRes >> 16 );
			r[nReg|1] = word( dwRes );
			
			if( !dwRes )
			{
			  PSW |= Z;
			}
			else if( dwRes < 0 )
			{
			  PSW |= N;
			}
			
			if( dwRes < -32768 || dwRes > 32767 )
			{
			  PSW |= C;
			}

			continue;  //  goto RETURN_TRUE;
		  }



		  if( nWord <= 071777 )
		  { // DIV
			int nReg = ( nWord & 0700 )>>6;

			PSW &= ~(V|Z|N|C);

			long dwOperand1 = (short) r[nReg];
			dwOperand1 <<= 16;
			dwOperand1 |= r[nReg|1];
			word  wOperand2  = *RefWordRead( nWord & 077 );
			READ_DONE();

			if( !wOperand2 )
			{
				PSW |= V;
				PSW |= C;
				PSW |= Z;

//DisAsmPrint("BAD == 1 == \n");
			}
			else
			if( (dwOperand1 == 020000000000) && (wOperand2 == 0177777) )
			{
				PSW |= V;

//DisAsmPrint("BAD == 2 == \n");
			}
			else
			{

//{
//char str[512];
//sprintf(str,"dwOperand1[%i] ; wOperand2[%i] ; R%i[%i] >>> DIV >>> ", dwOperand1, (short)wOperand2, nReg, (short)r[nReg] );
//DisAsmPrint(str);
//}
				long nRes = (long) dwOperand1 / (short) wOperand2;

//{
//char str[512];
//sprintf(str,"nRes[%i] -- ", nRes );
//DisAsmPrint(str);
//}
				if( nRes < 0 )
				{
					PSW |= N;
				}

				if( (nRes > 077777) || (nRes < -0100000) )
				{
					PSW |= V;

//{
//char str[512];
//sprintf(str,"dwOperand1[%i] ; wOperand2[%i] ; R%i[%i] >>> DIV >>> nRes[%i] -- ", dwOperand1, (short)wOperand2, nReg, (short)r[nReg], nRes );
//DisAsmPrint(str);
//}

//DisAsmPrint("BAD == 3 == \n");
				}
				else
				{
// DisAsmPrint("OK : ");
					r[nReg]   = nRes;
					r[nReg|1] = dwOperand1 % (short) wOperand2;

//{
//char str[512];
//sprintf(str,"R%i[%i] ; R%i[%i] \n", nReg, (short)r[nReg], nReg|1, (short)r[nReg|1] );
//DisAsmPrint(str);
//}
					if( !nRes )
					{
						PSW |= Z;
					}
				}
			}

			continue;  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 072777 )
		  { // ASH
			int nReg = ( nWord & 0700 )>>6;
			short *pOperand1 = (short*)(r + nReg);
			const word wOperand2 = *RefWordRead( nWord & 077 );
			READ_DONE();

//{
//char str[512];
//sprintf(str,"PSW[%03o] ; R0[%06o] ; R1[%06o] >>> ASH R1,R0 >>> ", PSW, R0, R1 );
//DisAsmPrint(str);
//}
			char  cOperand2  = wOperand2 & 0x1F;
			int nDir = 1;
			int nOperand2 = cOperand2;

			PSW &= ~(V|Z|N|C);

			if( wOperand2 & 0x20 ) 
			{
			  cOperand2 |= 0xE0;
			  nDir = -1;
			  nOperand2 = -1*cOperand2;
			}
			
			word wBIT_15 = *pOperand1 & BIT_15;
			
			for( int i = 0 ; i < nOperand2 ; i++ )
			{
			  if( nDir > 0 ) 
			  {
				if( (i == nOperand2-1) && (*pOperand1 & BIT_15 ) )
				{
				  PSW |= C;
				}
			    *pOperand1 <<= 1;

				if( (*pOperand1 & BIT_15 ) != wBIT_15 )
				{
				  PSW |= V;
				}
			  }
			  else
			  {
				if( (i == nOperand2-1) && (*pOperand1 & BIT_0 ) )
				{
				  PSW |= C;
				}
			    *pOperand1 >>= 1;
			  }
			}

			if( *pOperand1 == 0 )
			{
			  PSW |= Z;
			}
			else if( *pOperand1 < 0 )
			{
			  PSW |= N;
			}

//{
//char str[512];
//sprintf(str,"PSW[%03o] ; R0[%06o]\n", PSW, R0 );
//DisAsmPrint(str);
//}

			continue;  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 073777 )
		  { // ASHC
			int nReg = ( nWord & 0700 )>>6;

			const word wOperand2 = *RefWordRead( nWord & 077 );
			READ_DONE();

			char  cOperand2  = wOperand2 & 0x1F;
			int nDir = 1;
			int nOperand2 = cOperand2;

			PSW &= ~(V|Z|N|C);

			if( wOperand2 & 0x20 ) 
			{
			  cOperand2 |= 0xE0;
			  nDir = -1;
			  nOperand2 = -1*cOperand2;
			}
				
			int dwRes    = r[nReg]<<16 | r[nReg|1];
			int dwBIT_31 = dwRes & BIT_31;
			
			for( int i = 0 ; i < nOperand2 ; i++ )
			{
				if( nDir > 0 ) 
				{
					if( (i == nOperand2-1) && ( dwRes & BIT_31 ) )
					{
						PSW |= C;
					}
					dwRes <<= 1;
			    
					if( (dwRes & BIT_31) != dwBIT_31 )
					{
						PSW |= V;
					}
				}
				else
				{
					if( (i == nOperand2-1) && ( dwRes & BIT_0 ) )
					{
						PSW |= C;
					}
					dwRes >>= 1;
				}
			}
			
			if( dwRes == 0 )
			{
				PSW |= Z;
			}
			else
			if( dwRes < 0 )
			{
				PSW |= N;
			}
			
			r[nReg]   = word( dwRes >> 16 );
			r[nReg|1] = word( dwRes );

			continue;  //  goto RETURN_TRUE;
		  }
		  //*/
		  
		  
		  if( nWord >= 074000 && nWord <= 074777 )
		  { // XOR
			int nReg = ( nWord & 0700 )>>6;
			int nMode2 = nWord & 070;
			
			if( nReg == 7 && !nMode2 && ( (nWord & 077)!= 7) )
			{
				Make_ALU_Delay();

				word          data;
				WordRead( PC, data );
				
				bPreFetchEnabled = false;
				
				if( bVM1G )
				{
					int nDelay = 3 - nRPLY_ON_Latency - nRPLY_OFF_Latency;
					if( nDelay > 0 ) { BusClocksDelay( nDelay ); }
				}
				else
				{
					if( !nRPLY_ON_Latency && !nRPLY_OFF_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}
			
			word wOperand1 = r[nReg];
			
			if( nMode2 ) 
			{
				BusClocksDelay(3);
			}
			
			word  wOperand2;
			Word_RW_Read0( nWord & 077, wOperand2, true );

			wOperand2 = wOperand2 ^ wOperand1;

			Word_RW_Write( wOperand2 );

			PSW &= ~(V|Z|N);

			if( (signed short) wOperand2 < 0 )
			{
				PSW |= N;
			}
			else
			if( wOperand2 == 0 )
			{
				PSW |= Z;
			}

			if( !nMode2 )
			{
				if( bVM1G ) { nInterruptCheck_Clk_Addon = 3; }
				else        { nInterruptCheck_Clk_Addon = 5; }
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }



		  if( nWord >= 077000 && nWord <= 077777 )
		  { // SOB
			int nReg = ( nWord & 0700 )>>6;

			if( --r[nReg] )
			{
			  int nOffset = (nWord & 077)<<1;
			  PC -= nOffset;
			}

			bPreFetchEnabled = false;

			nALU_Delay += 10;
			Make_ALU_Delay();
			
			return; /* continue */
		  }



		  if( nWord < 0100000 )
		  {
			TrapTo_10();
			return; /* continue */
		  }


		  if( nWord <= 0103777 )
		  {
			nALU_Delay += 5;
			Make_ALU_Delay();

			bPreFetchEnabled = false;

			switch( nWord & 03400 )
			{
			  case 00:
				// BPL
				if( PSW & N ) { return; /* continue */ }
			  break;


			  case 0400:
				// BMI
				if( !(PSW & N) ) { return; /* continue */ }
			  break;


			  case 01000:
				// BHI
				if( (PSW & C)||(PSW & Z) ) { return; /* continue */ }
			  break;


			  case 01400:
				// BLOS
				if( !(PSW & (C|Z) ) ) { return; /* continue */ }
			  break;


			  case 02000:
				// BVC
				if( PSW & V ) { return; /* continue */ }
			  break;


			  case 02400:
				// BVS
				if( !(PSW & V) ) { return; /* continue */ }
			  break;


			  case 03000:
				// BCC ( BHIS )
				if( PSW & C ) { return; /* continue */ }
			  break;

			  case 03400:
				// BCS ( BLO )
				if( !(PSW & C) ) { return; /* continue */ }
			  break;

			  default:
				TrapTo_10();
				return; /* continue */
			}

			int nOffset = (signed char)(nWord & 0377);
			nOffset <<= 1;

			PC += nOffset;
		    
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 0104377 )
		  { // EMT
			nALU_Delay += 3;
			Make_ALU_Delay();

			TrapTo(030);

			if( bVM1G ) { BusClocksDelay(1); }
			else        { BusClocksDelay(6); }

			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 0104777 )
		  { // TRAP
			nALU_Delay += 3;
			Make_ALU_Delay();

			TrapTo(034);

			if( bVM1G ) { BusClocksDelay(1); }
			else        { BusClocksDelay(6); }

			return; /* continue */  //  goto RETURN_TRUE;
		  }



		  if( nWord >= 0105700 && nWord <= 0105777 )
		  {
			word wOperand;
			ByteRead0( nWord & 077, wOperand );
			
			// TSTB
			PSW &= ~(C|V|Z|N);

			if( (signed char) wOperand < 0 )
			{
				PSW |= N;
			}
			else
			if( (byte) wOperand == 0 )
			{
				PSW |= Z;
			}
			return; /* continue */
		  }


		  if( nWord <= 0105077 )
		  {
			// CLRB
			word wOperand;
			Byte_RW_Read0( nWord & 077, wOperand );

			wOperand = 0;

			Byte_RW_Write( wOperand );	

			PSW |= Z;
			PSW &= ~(C|V|N);
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 0106377 )
		  {
			word wOperand;
			Byte_RW_Read0( nWord & 077, wOperand );
			
			
			switch( nWord & 07700 )
			{
				case 05100:
				{
				  // COMB
					wOperand = ~wOperand;

					Byte_RW_Write( wOperand );	

					PSW |= C;
					PSW &= ~(V|Z|N);

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05200:
				{
				  // INCB
					wOperand += 1;

					Byte_RW_Write( wOperand );	

					PSW &= ~(V|Z|N);

					if( (byte) wOperand == 0200 )
					{
						PSW |= V;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05300:
				{
				  // DECB
					wOperand -= 1;

					Byte_RW_Write( wOperand );	

					PSW &= ~(V|Z|N);

					if( (byte) wOperand == 0177 )
					{
						PSW |= V;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05400:
				{
				  // NEGB
					wOperand *= -1;

					Byte_RW_Write( wOperand );	

					PSW |= C;
					PSW &= ~(V|Z|N);

					if( (byte) wOperand == 0200 )
					{
						PSW |= V;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
						PSW &= ~C;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05500:
				{
				  // ADCB
					bool bFlag = false;

					if( PSW & C )
					{
						bFlag = true;
						wOperand += 1;
					}

					Byte_RW_Write( wOperand );	

					PSW &= ~(C|V|Z|N);

					if( bFlag && ((byte) wOperand == 0200) )
					{
						PSW |= V;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
						if( bFlag )
						{
							PSW |= C;
						}
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 05600:
				{
				  // SBCB
					bool bFlag = false;

					if( PSW & C )
					{
						bFlag = true;
						wOperand -= 1;
					}

					Byte_RW_Write( wOperand );	

					PSW &= ~(C|V|Z|N);

					if( bFlag )
					{
						if( (byte) wOperand == 0377 )
						{
							PSW |= C;
						}
						else
						if( (byte) wOperand == 0177 )
						{
							PSW |= V;
						}
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06000:
				{
				  // RORB
					bool bit0 = wOperand & 1;
					wOperand >>= 1;

					if( PSW & C )
					{
						wOperand |= 0200;
					}

					Byte_RW_Write( wOperand );	

					PSW &= ~(C|V|Z|N);

					if( bit0 )
					{
						PSW |= C;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06100:
				{
				  // ROLB
					byte bit7 = wOperand & 0200;
					wOperand <<= 1;

					if( PSW & C )
					{
						wOperand |= 1;
					}

					Byte_RW_Write( wOperand );	

					PSW &= ~(C|V|Z|N);

					if( bit7 )
					{
						PSW |= C;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06200:
				{
				  // ASRB
					byte bit0 = wOperand & 1;
					byte bit7 = wOperand & 0200;

					wOperand >>= 1;

					if( bit7 )
					{
						wOperand |= 0200;
					}

					Byte_RW_Write( wOperand );	

					PSW &= ~(C|V|Z|N);

					if( bit0 )
					{
						PSW |= C;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 06300:
				{
				  // ASLB
					byte bit7 = wOperand & 0200;
					wOperand <<= 1;

					Byte_RW_Write( wOperand );	

					PSW &= ~(C|V|Z|N);

					if( bit7 )
					{
						PSW |= C;
					}

					if( (signed char) wOperand < 0 )
					{
						PSW |= N;
					}
					else
					if( (byte) wOperand == 0 )
					{
						PSW |= Z;
					}

					if( ((PSW & N)!=0)^((PSW & C)!=0) )
					{
						PSW |= V;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 0106477 )
		  { // MTPS
			word wOperand;
			ByteRead0( nWord & 077, wOperand, true );
			
			PSW &= 0xFF00;
			PSW |= byte(wOperand) &(~T);

			if( nT_bit_Flag )
			{
				PSW |= T;
			}
			
			bPreFetchEnabled = false;
			
			int nMode = nWord & 070;
			int nReg  = nWord & 007;
			if( !nMode )
			{
				word          data;
				WordRead( PC, data );
				
				nALU_Delay = ( nRPLY_ON_Latency < 7 ? (7 - nRPLY_ON_Latency) : 0 );
				
				if( nRPLY_OFF_Latency >= 3 ) 
				{
					nALU_Delay--;
				}
				Make_ALU_Delay();

				nInterruptCheck_Clk = nRPLY_ON_Latency + nRPLY_OFF_Latency - 4;

				if( nInterruptCheck_Clk < 3 )
				{
					nInterruptCheck_Clk = 3;
				}
			}
			else
			{
				BusClocksDelay(6);
				
				if( nMode == 020 )
				{
					if( !nRPLY_ON_Latency )
					{
						BusClocksDelay(1);
					}
				}
			}

			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord >= 0106700 && nWord <= 0106777 )
		  { // MFPS
			word wOperand;
			Byte_RW_Read0( nWord & 077, wOperand, true );
			wOperand = (byte)PSW;
			Byte_RW_Write( wOperand, true );	
			
			PSW &= ~(V|Z|N);

			if( (signed char) wOperand < 0 )
			{
				PSW |= N;
			}
			else
			if( (byte) wOperand == 0 )
			{
				PSW |= Z;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord < 0110000 )
		  {
			TrapTo_10();
			return; /* continue */
		  }



		  if( nWord >= 0120000 && nWord <= 0137777 )
		  {
			word  wOperand1;
			ByteRead1( (nWord & 07700)>>6, wOperand1 );
			
			word  wOperand2;
			ByteRead2( nWord & 077, wOperand2 );


			switch( nWord & 070000 )
			{
				case 020000:
				{
				  // CMPB

					signed char nRes = (signed char) wOperand1 - (signed char) wOperand2;

					PSW &= ~(C|V|Z|N);

					if( nRes < 0 )
					{
						PSW |= N;
					}
					else
					if( nRes == 0 )
					{
						PSW |= Z;
					}

					if( (byte) wOperand1 < (byte) wOperand2 )
					{
						PSW |= C;
					}
					
					if( nRes *(signed char)wOperand2 > 0  && ((nRes < 0 && (signed char)wOperand1 >= 0) || (nRes >= 0 && (signed char)wOperand1 < 0)) )
					{
						PSW |= V;
					}
					
					return; /* continue */
				}
				break;



				case 030000:
				{
				  // BITB

					char nRes = (byte) wOperand1 & (byte) wOperand2;

					PSW &= ~(V|Z|N);

					if( nRes < 0 )
					{
						PSW |= N;
					}
					else
					if( nRes == 0 )
					{
						PSW |= Z;
					}

					return; /* continue */
				}
				break;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }


		  if( nWord <= 0117777 )
		  {
			// MOVB
			byte		nOp1 = (nWord & 07700)>>6;
			word  wOperand1;
			ByteRead1( nOp1, wOperand1 );
			ByteWrite2( nWord & 077, nOp1, wOperand1 );

			PSW &= ~(V|Z|N);

			if( (signed char) wOperand1 < 0 )
			{
				PSW |= N;
			}
			else
			if( (byte) wOperand1 == 0 )
			{
				PSW |= Z;
			}

			/*
			if( nOp1 == 07 && !( nWord & 070 ) )
			{// -.
			}//*/
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }



		  if( nWord <= 0157777 )
		  {
			word  wOperand1;
			ByteRead1( (nWord & 07700)>>6, wOperand1 );
			
			word  wOperand2;
			Byte_RW_Read2( nWord & 077, wOperand2 );

			
			switch( nWord & 070000 )
			{
				case 040000:
				{
				  // BICB
					wOperand2 &= ~wOperand1;

					Byte_RW_Write( wOperand2 );

					PSW &= ~(V|Z|N);

					if( (signed char) wOperand2 < 0 )
					{
						PSW |= N;
					}
					else
					if( (signed char) wOperand2 == 0 )
					{
						PSW |= Z;
					}
					
					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;



				case 050000:
				{
				  // BISB
					wOperand2 |= wOperand1;

					Byte_RW_Write( wOperand2 );

					PSW &= ~(V|Z|N);

					if( (signed char) wOperand2 < 0 )
					{
						PSW |= N;
					}
					else
					if( (signed char) wOperand2 == 0 )
					{
						PSW |= Z;
					}

					return; /* continue */  //  goto RETURN_TRUE;
				}
				break;
			}
			
			return; /* continue */  //  goto RETURN_TRUE;
		  }



			if( nWord <= 0167777 )
			{
				word  wOperand1;
				WordRead1( (nWord & 07700)>>6, wOperand1 );
			
				word  wOperand2;
				Word_RW_Read2( nWord & 077, wOperand2 );

				// SUB
				short nRes = (short) wOperand2 - (short) wOperand1;

				Word_RW_Write( (word&)nRes );

				PSW &= ~(C|V|Z|N);
				
				if( nRes < 0 )
				{
					PSW |= N;
				}
				else
				if( nRes == 0 )
				{
					PSW |= Z;
				}

				if( wOperand1 > wOperand2 )
				{
					PSW |= C;
				}

				if( nRes *(short)wOperand1 > 0  && ((nRes < 0 && (short)wOperand2 >= 0) || (nRes >= 0 && (short)wOperand2 < 0)) )
				{
					PSW |= V;
				}
				
				return; /* continue */  //  goto RETURN_TRUE;
			}

			TrapTo_10();
		}
	}
	catch( int nErrorCode ) 
	{
		if( nErrorCode )
		{
			nBadAccessType = (byte)nErrorCode;
			wBadAddr       = nErrorCode >> 16;
		}
		TrapTo_4();
		// goto NEXT_TRY;
		return;
	}
}


////////////////////////

VOID __stdcall  MPI_1801VM1_CPU_FiberStart( LPVOID pThis )
{
	MPI_1801VM1 *pMPI_1801VM1 = (MPI_1801VM1*) pThis;
	
	pMPI_1801VM1->CPU_Fiber();
}

void MPI_1801VM1::CPU_Fiber()
{
	if( !pVM1_bus->DCLO )
	{//  .
		nCLK = 0;
	}

	CLC0_DIN  = true;
	CLC0_DOUT = true;
	CLC0_WTBT = true;
	nCLC0_AD  = -1;

	while( !pVM1_bus->DCLO )
	{
		//+++  +++//

		bHardReset = false;
		
		pVM1_bus->AD   = ~0;
		pVM1_bus->Aext = ~0;
		pVM1_bus->SYNC = true;
		pVM1_bus->RPLY = true;
		pVM1_bus->DIN  = true;
		pVM1_bus->DOUT = true;
		pVM1_bus->WTBT = true;
		pVM1_bus->BS7  = true;
		////////////////////
		pVM1_bus->REF  = true;
		pVM1_bus->INIT = false;
	//	pVM1_bus->HALT = true;
	//	pVM1_bus->EVNT = true;
	//	pVM1_bus->ACLO = false;
	//	pVM1_bus->DCLO = false;
		////////////////////
	//	pVM1_bus->IRQ  = ~0;
		pVM1_bus->IAK  = true;
		////////////////////
	//	pVM1_bus->DMR  = true;
		pVM1_bus->DMG  = true;
	//	pVM1_bus->SACK = true;
		////////////////////
		pVM1_bus->SEL1 = true;
		pVM1_bus->SEL2 = true;
		pVM1_bus->BSY  = true;
		
		//---  ---//

		SwitchToFiber( pMainFiber );
	}

	if( !bHardReset )
	{
		SwitchToFiber( pMainFiber );

		bool ACLO_Prev = pVM1_bus->ACLO;

		while( ACLO_Prev )
		{// ,    DCLO   ACLO.
			SwitchToFiber( pMainFiber );
		}
		
		while( !pVM1_bus->ACLO )
		{//  .
			SwitchToFiber( pMainFiber );
		}
	}
	
	bHardReset = false;

	ResetInterruptTriggers();

	BusClocksDelay( 7 );  //     ACLO   SEL1.

	// .

	WordRead( SEL1, PC );

	PC &= 0xFF00;
	PSW = 0340;

	BusClocksDelay( 9 );  //     SEL1       .

	bPreFetchEnabled = false;
	nInterruptCheck_Clk = 3;

	//   .

	while(true)
	{
		CPU_Step();
	};
}

////////////////////////

MPI_1801VM1::MPI_1801VM1():
nC_MicrocodeStepping( 0 ),	// 0 == 1801VM1A ; 1 == 1801VM1G
nNestedTrapsTo4(0),
nNestedTraps(0),
dwLastWaitReportTC(0),
dwLastStepsLogWriteTC(0),
nSTEP_Flag(0),
nStepsToGo(0),
bWait(false),
bWait2(false),
nWaitPhase(0),
nT_bit_Flag(0),
R0(r[0]),
R1(r[1]),
R2(r[2]),
R3(r[3]),
R4(r[4]),
R5(r[5]),
R6(r[6]),
R7(r[7]),
SP(r[6]),
PC(r[7]),
rw_addr(-222),
Last_TrapTo4_PC(0),
bHardReset(false),
nCLK(0),
nACLO_ON_Clk(0),
nACLO_OFF_Clk( MAX_INTERRUPT_CLK ),
nHALT_ON_Clk(0),
nHALT_OFF_Clk( MAX_INTERRUPT_CLK ),
nEVNT_ON_Clk(0),
nEVNT_OFF_Clk( MAX_INTERRUPT_CLK ),
nIRQ_ON_Clk(0),
nIRQ_OFF_Clk( MAX_INTERRUPT_CLK ),
nOverrun(0),
nALU_Delay(0),
hLatencyLog(0),
bDebugOut(false),
bNoMemoryReported(false),
bPreFetchEnabled(false),
bSEL_Mode(false),
pMainFiber(NULL),
pCPU_Fiber(NULL)
{
	bVM1G = (bool) nC_MicrocodeStepping;

//	AddMessage( "RegisterRW", fastdelegate::MakeDelegate(this, &MPI_1801VM1::RegisterRW_MessageController) );

	if( bVM1G )
	{
		R0 = 0077577;
		R1 = 0176777;
		R2 = 0001010;
		R3 = 0004042;
		R4 = 0011113;
		R5 = 0053756;
		R6 = 0041202;
	}
	else
	{
		R0 = 0133000;
		R1 = 0100514;
		R2 = 0100410;
		R3 = 0040000;
		R4 = 0100057;
		R5 = 0060000;
		R6 = 0000011;
	}
	
	PC  = 0;
	PSW = 0340;
	
}

///