//
//  MPI_1801VM1.h -    18011.
//
#ifndef MPI_1801VM1_class_Defs
#define MPI_1801VM1_class_Defs

#include "MPI_model.h"


/////////////////

class MPI_1801VM1 : public MPI_Interface {
friend VOID __stdcall  MPI_1801VM1_CPU_FiberStart( LPVOID pThis );

public:
	virtual ~MPI_1801VM1() {}
	MPI_1801VM1();

protected:

	static const word SEL1 = 0177716;
	static const word SEL2 = 0177714;
	
	static const dword  MAX_INTERRUPT_CLK = 2048;

	VM1_bus_type      *pVM1_bus;
	MPI_AdapterHooks  *pHooks;

	virtual void   Clock();
	virtual void   Link_MPI( MPI_bus_type *pMPI, MPI_AdapterHooks *pHOOKS )
	{
		pVM1_bus = (VM1_bus_type*) pMPI;
		pHooks   = pHOOKS;
	}
	
	inline  void   BusClocksDelay( int nClocks ) { for( int i = 0 ; i < nClocks ; i++ ) { SwitchToFiber( pMainFiber ); } }


	word &R0;
	word &R1;
	word &R2;
	word &R3;
	word &R4;
	word &R5;
	word &R6;
	word &R7;
	word &SP;
	word &PC;

	////////////////////////////////////
	word r[8];                        //
	word PSW;                         //
	////////////////////////////////////
	
	int  nT_bit_Flag;
	bool bRTT;
	int  nSTEP_Flag;
	int  nNestedTrapsTo4;
	int  nNestedTraps;
	

	bool bWait;
	bool bWait2; //      .
	int  nWaitPhase;
	
	int  nPrintPosition;
	int  nR_Operand[9];
	bool bDebugOut;

	void HardTrap();
	void TrapTo( word wVector );
	void TrapTo_4();
	void TrapTo_10();
	void TrapTo_14();
	void TrapTo_24();
	void TrapTo_100();
	void HALT_TrapToRomOffset( int nROM_Vector_Offset, bool bIRQ1 = false );

	////////////////////////////////////////////////////

	inline void Fetch( word & nWord );
	inline word GetAddr( byte nOpMode );

	       void WordRead(  word addr, word & wData, bool bRW_Mode = false );
	inline void WordWrite( word addr, word & wData ) 
				{
					WordWrite( addr, wData, 1, false );
				}
	inline void WordWrite( word addr, word & wData, bool bRW_Mode ) 
				{
					WordWrite( addr, wData, 1, bRW_Mode );
				}
	       void WordWrite( word addr, word & wData, int nDOUT_Delay, bool bRW_Mode = false );
	       void ByteRead(  word addr, word & wData, bool bRW_Mode = false );
	inline void ByteWrite( word addr, word & wData ) 
				{
					ByteWrite( addr, wData, 1, false );
				}
	inline void ByteWrite( word addr, word & wData, bool bRW_Mode ) 
				{
					ByteWrite( addr, wData, 1, bRW_Mode );
				}
	       void ByteWrite( word addr, word & wData, int nDOUT_Delay, bool bRW_Mode = false );
	
	       void WordRead0( byte nOpMode, word & wData, bool bMUL = false );     //    .
	       void WordRead1( byte nOpMode, word & wData );     //     .
	       void WordRead2( byte nOpMode, word & wData );     //     .
//	       void WordWrite0( byte nOpMode, word & wData );    //    .
	       void Word_RW_Read0( byte nOpMode, word & wData, bool bXOR = false ); //     "  "   .
	inline void Word_RW_Write( word & wData );               //     "  "
	       void Word_RW_Read2( byte nOpMode, word & wData );  //       . 
	
	       void WordWrite2( byte nOpMode, byte nOp1Mode, word & wData );     //     .

	       void ByteRead0( byte nOpMode, word & wData, bool bMTPS = false );
	       void ByteRead1( byte nOpMode, word & wData );
	       void ByteRead2( byte nOpMode, word & wData );
//	       void ByteWrite0( byte nOpMode, word & wData, bool bMovB );
	       void Byte_RW_Read0( byte nOpMode, word & wData, bool bMFPS = false );
	inline void Byte_RW_Write( word & wData, bool bMFPS = false );
	       void Byte_RW_Read2( byte nOpMode, word & wData );
	
	       void ByteWrite2( byte nOpMode, byte nOp1Mode, word & wData );

	////////////////////////////////////////////////////

	word  Last_PC;
	int   rw_addr;

	char trap_mes[128];
	
	word Last_TrapTo4_PC;
	
	word wBadAddr;
	int  nBadAccessType;
	
	int  nFirstOperandReg;
	
	int  hLatencyLog;
	
	dword dwLastWaitReportTC;
	
	int nStepsToGo;
	
	void  CPU_Fiber();
	void  CPU_Step();
	
	word  wMegaBugData;

	bool  CLC0_DIN;
	bool  CLC0_DOUT;
	int   nCLC0_AD;
	bool  CLC0_WTBT;
	
private:

	int  hEmLog;

	bool bNoMemoryReported;
	
	std::string               sHiddenCommandsCash;
	std::string               sTrapMesCash;
	
	dword       dwLastStepsLogWriteTC;
	
	LPVOID  pMainFiber;
	LPVOID  pCPU_Fiber;
	
	int    nInterruptCheck_Clk;
	int    nInterruptCheck_Clk_Addon;

	bool   bHardReset;

	dword  nACLO_ON_Clk;
	dword  nACLO_OFF_Clk;
	dword  nHALT_ON_Clk;
	dword  nHALT_OFF_Clk;
	dword  nEVNT_ON_Clk;
	dword  nEVNT_OFF_Clk;
	dword  nIRQ_ON_Clk;
	dword  nIRQ_OFF_Clk;
	
	dword  nCLK;

	
	bool  DCLO_Prev;

	       bool CheckInterrupts( bool bFetch );	
	inline bool CheckInterrupts1()
	       {
				return CheckInterrupts( false );
	       }
	inline bool CheckInterrupts2()
	       {
				return CheckInterrupts( true );
	       }

	
	void  ResetInterruptTriggers();
	       

	dword  nRPLY_ON_Latency;
	dword  nRPLY_OFF_Latency;
	dword  nOverrun;
	dword  nALU_Delay;

	inline void Make_ALU_Delay()
	{//        nRPLY_OFF_Latency    0..2
		for( int nDelay = nALU_Delay - nRPLY_OFF_Latency ; nDelay > 0 ; nDelay-- )
		{
			SwitchToFiber( pMainFiber );
		}
		nALU_Delay = 0;
	}
	
	bool  bSEL_Mode;

	bool  bPreFetchEnabled;

	const int    nC_MicrocodeStepping;
	bool         bVM1G;
};

#endif
