//
//  MPI_DL11.cpp
//

#include "MPI_DL11.h"

#include <conio.h>

// #define L(x) pHooks->DisAsmStrOut(x,false)
#define L(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }

//
//

//

MPI_DL11::MPI_DL11():
MPI_DeviceClass( 4 ) //  RPLY = 4 .
{
	IRQ_User_ID = 100;		//    .   .

	abReadAccess[  TTKS ] = true;
	abWriteAccess[ TTKS ] = true;
	
	abReadAccess[  TTKS+1 ] = true;
	abWriteAccess[ TTKS+1 ] = true;
	
	abReadAccess[  TTKB ] = true;
	abWriteAccess[ TTKB ] = true;
	
	abReadAccess[  TTKB+1 ] = true;
	abWriteAccess[ TTKB+1 ] = true;
	
	abReadAccess[  TTPS ] = true;
	abWriteAccess[ TTPS ] = true;
	
	abReadAccess[  TTPS+1 ] = true;
	abWriteAccess[ TTPS+1 ] = true;
	
	abReadAccess[  TTPB ] = true;
	abWriteAccess[ TTPB ] = true;
	
	abReadAccess[  TTPB+1 ] = true;
	abWriteAccess[ TTPB+1 ] = true;

	wTTKS = 0;
	wTTKB = 0;
	wTTPS = 0;
	wTTPB = 0;
	
	cRusLat = 017;

	nTTK_Ready_res = 0;
	bLast_TTP_IntEnable = false;
	bLast_TTK_IntEnable = false;
}

void MPI_DL11::Init()
{
	wTTPS = 0200;
	bLast_TTP_IntEnable = false;
	wTTPB = 0;

	wTTKS = 0000;
	bLast_TTK_IntEnable = false;
	wTTKB = 0;
	nTTK_Ready_res = 0;
	
	ClearIRQ();
}
 
void MPI_DL11::Clock()
{
	if( !(qwClocksCount%10000) )
	{
		if( (wTTKS&0100) && !nTTK_Ready_res )
		{
			if( _kbhit() )
			{
				nTTK_Ready_res = 0200;
				wTTKB = _getch();

				// TTKINT;
				SetIRQ( TTKINT );
			}
		}
	}

	MPI_DeviceClass::Clock();
}

void MPI_DL11::IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData )
{
	bool  bTTP_ReadyChanged = false;

	if( IO_Mode == IO_READ )
	{
		switch( nIO_Addr )
		{
			case TTKS:
			case TTKS|1:
			{
				wTTKS &= 0100;
				wTTKS |= nTTK_Ready_res;

				if( !nTTK_Ready_res )
				{
					if( _kbhit() )
					{
						nTTK_Ready_res = 0200;
						wTTKB = _getch();
					}
				}
			
				if( IO_Size == IO_WORD ) 
				{
					wData = wTTKS;
				}
				else
				{
					byte*   pByte = (byte*) & wTTKS;
					wData = pByte[ nIO_Addr &1 ];
				}
			}
			break;

			case TTKB:
			case TTKB|1:
			{
				if( !nTTK_Ready_res )
				{
					if( _kbhit() )
					{
						wTTKB = _getch();
					}
				}

				if( IO_Size == IO_WORD ) 
				{
					wData = wTTKB;
				}
				else
				{
					byte*   pByte = (byte*) & wTTKB;
					wData = pByte[ nIO_Addr &1 ];
				}
			
				nTTK_Ready_res = 0;
				wTTKS &= 0100;
			}
			break;

			case TTPS:
			case TTPS|1:
			{
				if( IO_Size == IO_WORD ) 
				{
					wData = wTTPS;
				}
				else
				{
					byte*   pByte = (byte*) & wTTPS;
					wData = pByte[ nIO_Addr &1 ];
				}
			}
			break;

			case TTPB:
			case TTPB|1:
			{
				if( IO_Size == IO_WORD ) 
				{
					wData = wTTPB;
				}
				else
				{
					byte*   pByte = (byte*) & wTTPB;
					wData = pByte[ nIO_Addr &1 ];
				}
			}
			break;
		}
	}
	else
	if( IO_Mode == IO_WRITE )
	{
		switch( nIO_Addr )
		{
			case TTKS:
			case TTKS|1:
			{
				if( IO_Size == IO_WORD ) 
				{
					wTTKS = wData;
				}
				else
				{
					byte* pByte = (byte*) & wTTKS;
					pByte[ nIO_Addr &1 ] = (byte)wData;
				}
			
				wTTKS &= 0100;
				wTTKS |= nTTK_Ready_res;

				bool bTTK_IntEnable = ( (wTTKS & 0100) != 0);

				if( bTTK_IntEnable && !bLast_TTK_IntEnable && nTTK_Ready_res )
				{
					// TTKINT;
					SetIRQ( TTKINT );
				}
				bLast_TTK_IntEnable = bTTK_IntEnable;
			}
			break;

			case TTKB:
			case TTKB|1:
			{
			}
			break;

			case TTPS:
			case TTPS|1:
			{
				if( IO_Size == IO_WORD ) 
				{
					wTTPS = wData;
				}
				else
				{
					byte* pByte = (byte*) & wTTPS;
					pByte[ nIO_Addr &1 ] = (byte)wData;
				}
			
				wTTPS &= 0100;
			}
			break;

			case TTPB:
			case TTPB|1:
			{
				bTTP_ReadyChanged = true;
			
				if( IO_Size == IO_WORD ) 
				{
					wTTPB = wData;
				}
				else
				{
					byte* pByte = (byte*) & wTTPB;
					pByte[ nIO_Addr &1 ] = (byte)wData;
				}
				
				wTTPB &= 0x00FF;
				
				byte c = (byte)wTTPB;

				if (c == 016) 
				{
					cRusLat = c;
					break;
				}
				else
				if (c == 017) 
				{
					cRusLat = c;
					break;
				}

				if( cRusLat == 016  &&  c >= '@' )
				{
					static byte tab[0100] = {
					/* Codepage 1251 */
//					0376, 0340, 0341, 0366, 0344, 0345, 0364, 0343, /* @ABCDEFG */
//					0365, 0350, 0351, 0352, 0353, 0354, 0355, 0356, /* HIJKLMNO */
//					0357, 0377, 0360, 0361, 0362, 0363, 0346, 0342, /* PQRSTUVW */
//					0374, 0373, 0347, 0370, 0375, 0371, 0367, 0372, /* XYZ[\]^_ */
//					0336, 0300, 0301, 0326, 0304, 0305, 0324, 0303, /* `abcdefg */
//					0325, 0310, 0311, 0312, 0313, 0314, 0315, 0316, /* hijklmno */
//					0317, 0337, 0320, 0321, 0322, 0323, 0306, 0302, /* pqrstuvw */
//					0334, 0333, 0307, 0330, 0335, 0331, 0327, 0332, /* xyz{|}~  */ 
        			
        			/* Codepage 866 */
					0356, 0240, 0241, 0346, 0244, 0245, 0344, 0243, /* @ABCDEFG */
					0345, 0250, 0251, 0252, 0253, 0254, 0255, 0256, /* HIJKLMNO */
					0257, 0357, 0340, 0341, 0342, 0343, 0246, 0242, /* PQRSTUVW */
					0354, 0353, 0247, 0350, 0355, 0351, 0347, 0352, /* XYZ[\]^_ */
					0236, 0200, 0201, 0226, 0204, 0205, 0224, 0203, /* `abcdefg */
					0225, 0210, 0211, 0212, 0213, 0214, 0215, 0216, /* hijklmno */
					0217, 0237, 0220, 0221, 0222, 0223, 0206, 0202, /* pqrstuvw */
					0234, 0233, 0207, 0230, 0235, 0231, 0227, 0232, /* xyz{|}~  */
					};
										
					c = tab [c - '@']; 
				}
    				
				printf("%c", c );
			}
			break;
		}

		wTTPS |= 0200; // TT -> Ready

		bool bTTP_IntEnable = (( wTTPS & 0100 ) != 0 );

		if(  bTTP_IntEnable && ( bTTP_ReadyChanged || !bLast_TTP_IntEnable ) )
		{
			// TTPINT;
			SetIRQ( TTPINT );
		}

		bLast_TTP_IntEnable = bTTP_IntEnable;
	}
}

