//
//  MPI_HD.h -  HD t1  .
//
#ifndef MPI_HD_Defs
#define MPI_HD_Defs

#include "MPI_model.h"


/////////////////

static const word  HDCMD = 0177720;
static const word  HDDAT = HDCMD+2;

class MPI_HD : public MPI_DeviceClass {
public:
	virtual ~MPI_HD(){}
	MPI_HD( const char *acDSK_File, const byte *pMemory, bool bReadBoot_HD0 );

protected:
	virtual void  IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData );
	
	word  wHDCMD;
	word  wHDDAT;
	
	byte *aMemory;

	int            hDSK[9];
	unsigned long  anDSKlen[9];

	word  HD_Unit;
	word  HD_BlockNum;
	word  HD_BufAddr;
	word  HD_WordCount;

	int HDReadDSK(  word nHDnum, word nBlockNum, word nWordCount, word nEmulBufAddr );
	int HDWriteDSK( word nHDnum, word nBlockNum, word nWordCount, word nEmulBufAddr );
	int MountHdUnit( word nHDnum, const char* acDSK_File );
	void HD_device_command( word cmd );
};


#endif
