//
//  MPI_Memory.h -     .
//
#ifndef MPI_Memory_Defs
#define MPI_Memory_Defs

#include "MPI_model.h"


/////////////////

class MPI_RAM : public MPI_DeviceClass {
public:
	virtual ~MPI_RAM(){}
	MPI_RAM( word wStartAddr, word wRamSizeBytes );

	inline const byte* operator()(void)const { return aRAM; }

protected:

	virtual void IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData );
	
	byte aRAM[0x10000];
};

class MPI_ROM : public MPI_DeviceClass {
public:
	virtual ~MPI_ROM(){}
	MPI_ROM( word wStartAddr, word wRomSizeBytes, const char *acBIN_File );

protected:

	virtual void IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData );
	
	byte aROM[0x10000];
};

class MPI_SEL1 : public MPI_DeviceClass {
public:
	virtual ~MPI_SEL1(){}
	MPI_SEL1( word wStartAddr );

protected:

	virtual void IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData );
	
	word wSEL1;
};

#endif
