//
//  -   .
//

#include "MPI_VE_Timer.h"


// #define L(x) pHooks->DisAsmStrOut(x,true)
#define L(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }


//

MPI_VE_Timer::MPI_VE_Timer():
MPI_DeviceClass( 0, 0 ) //  RPLY = 0  ON, 0  OFF.
{
	abReadAccess[  0177706 ] = true;
	abWriteAccess[ 0177706 ] = true;

	abReadAccess[  0177707 ] = true;
	abWriteAccess[ 0177707 ] = true;

	abReadAccess[  0177710 ] = true;
	abWriteAccess[ 0177710 ] = true;

	abReadAccess[  0177711 ] = true;
	abWriteAccess[ 0177711 ] = true;

	abReadAccess[  0177712 ] = true;
	abWriteAccess[ 0177712 ] = true;

	abReadAccess[  0177713 ] = true;
	abWriteAccess[ 0177713 ] = true;

	
	nVE_CPU_Clock_Divider = 128;
	bVE_Go = false;
	bVE_NoReload = false;
	bVE_Monitor = false;
	bVE_NoRestart = false;
	bVE_Expiry = false;
	nVE_MonitoredExpiryCount = 0;
}
void MPI_VE_Timer::Power_ON()
{
	MPI_DeviceClass::Power_ON();

	w177706 = 0104014;
	w177710 = wVE_Timer_Counter = 0177777;
	w177712 = 0177400;

	nVE_CPU_Clock_Divider = 128;
	bVE_Go = false;
	bVE_NoReload = false;
	bVE_Monitor = false;
	bVE_NoRestart = false;
	bVE_Expiry = false;
	nVE_MonitoredExpiryCount = 0;
}
void MPI_VE_Timer::Init()
{
	word wData = 0;
	IO_fun( IO_READ, IO_WORD, 0177710, wData );

	nVE_CPU_Clock_Divider = 128;
	bVE_Go = false;
	bVE_NoReload = false;
	bVE_Monitor = false;
	bVE_NoRestart = false;
	bVE_Expiry = false;
	nVE_MonitoredExpiryCount = 0;
	
	w177712 = 0177400;
}
void MPI_VE_Timer::IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData )
{
	switch( nIO_Addr )
	{
		// VE-Timer Counter Initial Value
		case 0177706:
		case 0177707:
		{
			if( IO_Mode == IO_READ )
			{
				wData = w177706;
			}
			else
			if( IO_Mode == IO_WRITE )
			{
				w177706 = wData;
				
				if( IO_Size == IO_BYTE )
				{
					if( nIO_Addr & 01 ) { w177706 <<= 8;   }
					else                { w177706 &= 0xFF; }
				}

				word xxx;
				IO_fun( IO_READ, IO_WORD, 0177710, xxx );

				if( bVE_Go && !bVE_NoReload && !bVE_NoRestart )
				{
					if( qwClocksCount >= qwNextVE_TimerStart_CPU_Clocks )
					{
						qwPrevVE_TimerStart_CPU_Clocks = qwNextVE_TimerStart_CPU_Clocks;
						dwPrevInitialVE_CounterVal     = dwNextInitialVE_CounterVal;
						
						qword qwUsedCPU_Clocks = qwClocksCount - qwPrevVE_TimerStart_CPU_Clocks;
						qword qwCurrentVE_Timer_Clocks = qwUsedCPU_Clocks/nVE_CPU_Clock_Divider;
					
						dword dwTimerClocksLow = qwCurrentVE_Timer_Clocks % dwPrevInitialVE_CounterVal;
						
						qwNextVE_TimerStart_CPU_Clocks = qwPrevVE_TimerStart_CPU_Clocks;
						qwNextVE_TimerStart_CPU_Clocks += ( dwPrevInitialVE_CounterVal - dwTimerClocksLow ) * nVE_CPU_Clock_Divider;
					}
					
					dwNextInitialVE_CounterVal = w177706;
					
					if( !dwNextInitialVE_CounterVal ) { dwNextInitialVE_CounterVal = 0x10000; }
				}
			}
		}
		break;
		
		// VE-Timer Counter
		case 0177710:
		case 0177711:
		{
			if( IO_Mode == IO_WRITE )
			{
				w177710 = wVE_Timer_Counter;
			}
			else
			if( IO_Mode == IO_READ )
			{
				if( bVE_Go )
				{
					qword qwVE_TimerStart_CPU_Clocks = qwPrevVE_TimerStart_CPU_Clocks;
					dword dwInitialVE_CounterVal     = dwPrevInitialVE_CounterVal;
					
					if( qwClocksCount >= qwNextVE_TimerStart_CPU_Clocks )
					{
						bVE_Expiry = true;
						
						if( !bVE_NoRestart )
						{
							qwVE_TimerStart_CPU_Clocks = qwNextVE_TimerStart_CPU_Clocks;
							dwInitialVE_CounterVal     = dwNextInitialVE_CounterVal;
						}
					}
					
					qword qwUsedCPU_Clocks = qwClocksCount - qwVE_TimerStart_CPU_Clocks;
					qword qwCurrentVE_Timer_Clocks = qwUsedCPU_Clocks/nVE_CPU_Clock_Divider;
					
					dword dwTimerClocksHi  = qwCurrentVE_Timer_Clocks / dwInitialVE_CounterVal;
					dword dwTimerClocksLow = qwCurrentVE_Timer_Clocks % dwInitialVE_CounterVal;

					if( bVE_Expiry )
					{
						if( bVE_Monitor && (dwTimerClocksHi > nVE_MonitoredExpiryCount) )
						{
							nVE_MonitoredExpiryCount = dwTimerClocksHi;
						}
						
						if( bVE_NoReload )
						{
							wVE_Timer_Counter = dwInitialVE_CounterVal - dwTimerClocksLow;
						}
						else if( bVE_NoRestart )
						{
							bVE_Go = false;
							
							wVE_Timer_Counter = w177706;

							if( dwTimerClocksHi == 1 && !dwTimerClocksLow )
							{
								if( qwClocksCount%128 < 4 )
								{
									wVE_Timer_Counter = 0;
								}
							}						
						}
						else
						{
							wVE_Timer_Counter = dwInitialVE_CounterVal - dwTimerClocksLow;
							
							if( !dwTimerClocksLow )
							{
								if( qwClocksCount%128 < 4 )
								{
									wVE_Timer_Counter = 0;
								}
							}
						}
					}
					else
					{ // !bVE_Expiry
						wVE_Timer_Counter = dwInitialVE_CounterVal - dwTimerClocksLow;
					}
					
					w177710 = wVE_Timer_Counter;
				}
				
				wData = w177710;
			}
		}
		break;
		
		// VE-Timer CSR
		case 0177712:
		case 0177713:
		{
			word xxx;
			IO_fun( IO_READ, IO_WORD, 0177710, xxx );

			word wVE_Timer_CSR = w177712;

			if( IO_Mode == IO_READ )
			{
				if( bVE_Expiry )
				{
					if( bVE_Monitor && nVE_MonitoredExpiryCount > 1 )
					{
						wVE_Timer_CSR |= BIT_7;
					}
					
					if( bVE_NoRestart && !bVE_NoReload )
					{
						wVE_Timer_CSR &= ~BIT_4;
					}
				}

				wData = w177712 = wVE_Timer_CSR|0xFF00;
			}
			else
			if( IO_Mode == IO_WRITE )
			{
				wVE_Timer_CSR = wData;
				
				if( IO_Size == IO_BYTE )
				{
					if( nIO_Addr & 01 ) { wVE_Timer_CSR <<= 8;   }
					else                { wVE_Timer_CSR &= 0xFF; }
				}
			
				if( nVE_MonitoredExpiryCount )
				{
					nVE_MonitoredExpiryCount = 2;
				}
			
				bVE_Expiry = false;
				
				bVE_Go = wVE_Timer_CSR & BIT_4;

				if( wVE_Timer_CSR & BIT_0 )
				{
					bVE_Go = false;
				}

				bVE_NoReload  = wVE_Timer_CSR & BIT_1;
				bVE_Monitor   = wVE_Timer_CSR & BIT_2;
				bVE_NoRestart = wVE_Timer_CSR & BIT_3;

				nVE_CPU_Clock_Divider = 128;
				
				if( wVE_Timer_CSR & BIT_5 )
				{
					nVE_CPU_Clock_Divider *= 16;
				}

				if( wVE_Timer_CSR & BIT_6 )
				{
					nVE_CPU_Clock_Divider *= 4;
				}

				
				if( bVE_Go )
				{
					qword qwVE_TimerStart_CPU_Clocks = qwClocksCount;
					qwVE_TimerStart_CPU_Clocks -= qwVE_TimerStart_CPU_Clocks%128;

					dword dwInitialVE_CounterVal = w177706;
					if( !dwInitialVE_CounterVal ) { dwInitialVE_CounterVal = 0x10000; }
					
					dwPrevInitialVE_CounterVal = dwInitialVE_CounterVal;
					dwNextInitialVE_CounterVal = dwInitialVE_CounterVal;
					
					if( bVE_NoReload )
					{
						dwNextInitialVE_CounterVal = 0x10000;
					}

					qwPrevVE_TimerStart_CPU_Clocks = qwVE_TimerStart_CPU_Clocks;
					qwNextVE_TimerStart_CPU_Clocks = qwVE_TimerStart_CPU_Clocks;
					qwNextVE_TimerStart_CPU_Clocks += dwInitialVE_CounterVal * nVE_CPU_Clock_Divider;
				}

				wVE_Timer_Counter = w177706;
				
				w177710 = wVE_Timer_Counter;
				w177712 = wVE_Timer_CSR|0xFF00;
			}
		}
		break;
	}
}
///