//
//   18011       Verilog.
//

#include "MPI_VM1_V.h"


// #define L(x) pHooks->DisAsmStrOut(x,false)
#define L(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }

//
//
void MPI_VM1_V::Clock()
{
	getPins();

	if( !pVM1_bus->CLC ) 
	{
		core.eval_n( nClk );	//   
	}
	else
	{
		core.eval_p( nClk );	//   
		nClk++;
	}

	setPins();
}

//

MPI_VM1_V::MPI_VM1_V():
nC_MicrocodeStepping( 0 ),	// 0 == 1801VM1A ; 1 == 1801VM1G
nClk(0),
bCPU_RPLY_Prev( false ),
bDout_AD( false ),
nCPU_AD_Prev( -1 ),
pMPI( new MPI() )
{
	core.SetCpuType( nC_MicrocodeStepping ? C1801VM1::CPU_TYPE::CPU_VM1G : C1801VM1::CPU_TYPE::CPU_VM1A );
	core.m_IOPins.clear();

	pMPI->clear();
	
	m_nDeviceID = pMPI->RegisterDevice();
	core.RegisterDevice( pMPI );
}

///

void MPI_VM1_V::getPins()
{
	/*
	pMPI->dcok_n = pVM1_bus->DCLO;
	pMPI->pok_n  = pVM1_bus->ACLO;
	pMPI->irq1_n = pVM1_bus->IRQ1;
	pMPI->irq2_n = pVM1_bus->IRQ2;
	pMPI->irq3_n = pVM1_bus->IRQ3;
	pMPI->irq0_n = pVM1_bus->IRQ & BIT_0;

	pMPI->init_n = pVM1_bus->INIT;

	pMPI->ad_n   = pVM1_bus->AD;

	pMPI->dout_n = pVM1_bus->DOUT;
	pMPI->din_n  = pVM1_bus->DIN;

	pMPI->sync_n = pVM1_bus->SYNC;


	//    RPLY    CLC -   .
//	if( pVM1_bus->CLC || !pVM1_bus->RPLY )
	if( pVM1_bus->CLC )
	{
		pMPI->rply_n = pVM1_bus->RPLY;
	}

	pMPI->dmr_n  = pVM1_bus->DMR;
	pMPI->sack_n = pVM1_bus->SACK;

	pMPI->dmgi_n = pVM1_bus->DMGI;

	//*/

	pMPI->dcok_n = pVM1_bus->DCLO;
	pMPI->pok_n  = pVM1_bus->ACLO;
	pMPI->irq1_n = pVM1_bus->IRQ1;
	pMPI->irq2_n = pVM1_bus->IRQ2;
	pMPI->irq3_n = pVM1_bus->IRQ3;
	pMPI->irq0_n = pVM1_bus->IRQ & BIT_0;

	pMPI->dmgi_n = pVM1_bus->DMGI;

	//
	// Shared Qbus lines
	//
	
	if( !pMPI->dout_n )
	{
		bDout_AD = true;
	}
	else
	if( pVM1_bus->RPLY )
	{
		bDout_AD = false;
	}

	if( !bDout_AD )
	{
		pMPI->SetAD( m_nDeviceID, !pVM1_bus->RPLY, pVM1_bus->AD );
	}

//	pMPI->dmgo_n = core.m_IOPins.pin_dmgo_n;

	//
	// "Open collector" outputs
	//
	
	bool bCPU_RPLY = pMPI->m_nRPLYmask & BIT_1;

	if( !bCPU_RPLY )
	{
		/*
		if( pVM1_bus->CLC || !pVM1_bus->RPLY )
		{
			pMPI->SetRPLY( m_nDeviceID, !pVM1_bus->RPLY, false );
		}//*/

		pMPI->SetRPLY( m_nDeviceID, !pVM1_bus->RPLY, false );
	}

//	pMPI->SetDMR(  m_nDeviceID, !pVM1_bus->DMR, false  );
}

void MPI_VM1_V::setPins()
{
	pVM1_bus->AD = pMPI->ad_n;
	
	//
	// Shared Qbus lines
	//

	pVM1_bus->DOUT = pMPI->dout_n;
	pVM1_bus->DIN  = pMPI->din_n;
	pVM1_bus->WTBT = pMPI->wtbt_n;
	pVM1_bus->IAKO = pMPI->iak0_n;
	pVM1_bus->SYNC = pMPI->sync_n;
	pVM1_bus->DMGO = pMPI->dmgo_n;

	//
	// "Open collector" outputs
	//

	/*
	if( bCPU_RPLY_Prev || !core.m_IOPins.pin_rply_n )
	{
		pVM1_bus->RPLY =  core.m_IOPins.pin_rply_n;
		bCPU_RPLY_Prev = !core.m_IOPins.pin_rply_n;
	}//*/
	
	bool core_pin_rply_n = !(pMPI->m_nRPLYmask & BIT_1);
	
	if( bCPU_RPLY_Prev || !core_pin_rply_n )
	{
		pVM1_bus->RPLY =  core_pin_rply_n;
		bCPU_RPLY_Prev = !core_pin_rply_n;
	}
	
/*
FILE *pLog = fopen("MPI.log", "a");
fprintf(pLog, "\n setPins:: bCPU_RPLY_Prev: %i ; core.m_IOPins.pin_rply_n: %i ; pVM1_bus->RPLY: %i \n\n", bCPU_RPLY_Prev, core.m_IOPins.pin_rply_n, pVM1_bus->RPLY );
fclose(pLog);
//*/
	pVM1_bus->INIT = pMPI->init_n;
	pVM1_bus->SACK = pMPI->sack_n;
	pVM1_bus->DMR  = pMPI->dmr_n;
	pVM1_bus->BSY  = pMPI->bsy_n;
	pVM1_bus->SEL1 = pMPI->sel1_n;
	pVM1_bus->SEL2 = pMPI->sel2_n;
}