#pragma once

typedef unsigned long long QWORD;

//#define GETBIT(s,n) ((bool)(((s) >> (n)) & 1) == 1)
//#define GETBIT(s,n) ((bool)(((s) & (1 << (n))) == (1 << (n))))
#define GETBIT(s,n) ((bool)(((s) & (1 << (n))) ? true : false))


#define SETBIT(d,n,v) ((v) ? ((d) |= (1 << (n))) : ((d) &= ~(1 << (n))))

#define BIN__N(x) (x) | x>>3 | x>>6 | x>>9
#define BIN__B(x) (x) & 0xf | (x)>>12 & 0xf0

#define BIN8(v) (BIN__B(BIN__N(0x##v)))

#define BIN16(x1,x2) \
    ((BIN8(x1)<<8)+BIN8(x2))

#define BIN24(x1,x2,x3) \
    ((BIN8(x1)<<16)+(BIN8(x2)<<8)+BIN8(x3))

#define BIN32(x1,x2,x3,x4) \
    ((BIN16(x1,x2)<<16)+BIN16(x3,x4))

#define BIN64(x1,x2,x3,x4,x5,x6,x7,x8) \
    ((__int64(BIN32(x1,x2,x3,x4)) << 32) + __int64(BIN32(x5,x6,x7,x8)))


extern const WORD g_WordBitMask[16];
extern const DWORD g_DwordBitMask[32];
extern const QWORD g_QwordBitMask[64];

// ,   
class MPI
{
public:

	int m_nRegDevNumber; //   .

	//    .
	DWORD m_nADmask;
	DWORD m_nAEmask;
	DWORD m_nSYNCmask;
	DWORD m_nDINmask;
	DWORD m_nDOUTmask;
	DWORD m_nRPLYmask;
	DWORD m_nWTBTmask;
	DWORD m_nBS7mask;
	DWORD m_nREFmask;
	DWORD m_nDMRmask;
	DWORD m_nDMGOmask;
	DWORD m_nSACKmask;
	DWORD m_nVIRQmask;
	DWORD m_nIRQ1mask;
	DWORD m_nIRQ2mask;
	DWORD m_nIRQ3mask;
	DWORD m_nIAKOmask;
	DWORD m_nIAK1mask;
	DWORD m_nIAK2mask;
	DWORD m_nIAK3mask;
	DWORD m_nEVNTmask;
	DWORD m_nINITmask;
	DWORD m_nHALTmask;
	DWORD m_nPOKmask;
	DWORD m_nDCOKmask;
	DWORD m_nDMGImask;
	DWORD m_nBSYmask;
	DWORD m_nSEL1mask;
	DWORD m_nSEL2mask;

public:
	//  
	WORD ad_n;		//- 15-0										-
	BYTE ae_n;		//  23-16									-
	//  
	bool sync_n;	// 										- 
	bool din_n;		// 												-
	bool dout_n;	// 												-
	bool rply_n;	// 											-
	bool wtbt_n;	// "-"										-
	bool bs7_n;		// 											-
	bool ref_n;		// "" -						 - 
	//  
	bool dmr_n;		// 											 -
					//  							 -
	bool dmgo_n;	//   							- 
					//    		- 
	bool sack_n;	// 										-
	// 
	bool irq0_n;	//  								4	-
	bool irq1_n;	//  								5	-
	bool irq2_n;	//  								6	-
	bool irq3_n;	//  								7	-
	bool iak0_n;	// 								4	-
	bool iak1_n;	// 								5	-
	bool iak2_n;	// 								6	-
	bool iak3_n;	// 								7	-
	bool evnt_n;	//   							-
	// 
	bool init_n;	//													, - 
	bool halt_n;	//													-
	bool pok_n;		//  					ACLO			 -
	bool dcok_n;	//  					DCLO			 - 
	// ,       ,     .
	bool dmgi_n;	// bus granted input
	bool bsy_n;  	// bus busy flag
	bool sel1_n;
	bool sel2_n;

	void clear()
	{
		ad_n = -1;
		ae_n = -1;
		sync_n = true;
		din_n  = true;
		dout_n = true;
		rply_n = true;
		wtbt_n = true;
		bs7_n  = true;
		ref_n  = true;
		dmr_n  = true;
		dmgo_n = true;
		sack_n = true;
		irq0_n = true;
		irq1_n = true;
		irq2_n = true;
		irq3_n = true;
		iak0_n = true;
		iak1_n = true;
		iak2_n = true;
		iak3_n = true;
		evnt_n = true;
		init_n = true;
		halt_n = true;
		pok_n  = true;
		dcok_n = true;
		dmgi_n = true;
		bsy_n  = true;
		sel1_n = true;
		sel2_n = true;
		//
		m_nADmask   = 0;
		m_nAEmask   = 0;
		m_nRPLYmask = 0;
		m_nDOUTmask = 0;
		m_nDINmask  = 0;
		m_nWTBTmask = 0;
		m_nBS7mask  = 0;
		m_nREFmask  = 0;
		m_nSYNCmask = 0;
		m_nINITmask = 0;
		m_nSACKmask = 0;
		m_nVIRQmask = 0;
		m_nIRQ1mask = 0;
		m_nIRQ2mask = 0;
		m_nIRQ3mask = 0;
		m_nIAKOmask = 0;
		m_nIAK1mask = 0;
		m_nIAK2mask = 0;
		m_nIAK3mask = 0;
		m_nEVNTmask = 0;
		m_nDMRmask  = 0;
		m_nDMGOmask = 0;
		m_nHALTmask = 0;
		m_nPOKmask  = 0;
		m_nDCOKmask = 0;
		m_nDMGImask = 0;
		m_nBSYmask  = 0;
		m_nSEL1mask = 0;
		m_nSEL2mask = 0;
	};
	//
	MPI()
		: m_nRegDevNumber(0){}
	//
	~MPI(){}
	/*
	 *    .
	 *    DeviceID - -  DWORD
	 * ..       32
	 **/
	DWORD RegisterDevice()
	{
		if (m_nRegDevNumber >= 32)
		{
			return -1; //  ,      (     64)
		}
		DWORD nID = 1 << m_nRegDevNumber++;
		return nID;
	}
	/*
	 *    
	 * : bEna -  
	 *       nData -  ()
	 *       nID -  ,    
	 */
	void SetAD(DWORD nID, bool bEna, WORD nData)
	{
		if (bEna)	//  
		{
			if (m_nADmask & nID) //     
			{
				ad_n = nData;		//      (     )
			}
			else	// -   .
			{
				ad_n &= nData;		//    
			}
			m_nADmask |= nID;	//,     
		}
		else
		{
			m_nADmask &= ~nID;	//   ,  ,      
		}

		if (m_nADmask == 0) //       ,
		{
			ad_n = -1;		//       Z 
		}
	}
	void SetAE(DWORD nID, bool bEna, BYTE nData)
	{
		if (bEna)	//  
		{
			if (m_nAEmask & nID) //     
			{
				ae_n = nData;		//      (     )
			}
			else	// -   .
			{
				ae_n &= nData;		//    
			}
			m_nAEmask |= nID;	//,     
		}
		else
		{
			m_nAEmask &= ~nID;	//   ,  ,      
		}

		if (m_nAEmask == 0) //       ,
		{
			ae_n = -1;		//       Z 
		}
	}

#define SETMPI_FUNC(FUNC_NAME, VARMASK_NAME, VAR_NAME)	\
	void FUNC_NAME(DWORD nID, bool bEna, bool nData)	\
	{													\
		if (bEna)										\
		{												\
			if (VARMASK_NAME & nID)						\
			{											\
				VAR_NAME = nData;						\
			}											\
			else										\
			{											\
				VAR_NAME &= nData;						\
			}											\
			VARMASK_NAME |= nID;						\
		}												\
		else											\
		{												\
			VARMASK_NAME &= ~nID;						\
		}												\
														\
		if (VARMASK_NAME == 0)							\
		{												\
			VAR_NAME = true;							\
		}												\
	}

	SETMPI_FUNC(SetRPLY, m_nRPLYmask, rply_n);
	SETMPI_FUNC(SetDOUT, m_nDOUTmask, dout_n);
	SETMPI_FUNC(SetDIN,  m_nDINmask,  din_n);
	SETMPI_FUNC(SetWTBT, m_nWTBTmask, wtbt_n);
	SETMPI_FUNC(SetBS7,  m_nBS7mask,  bs7_n);
	SETMPI_FUNC(SetREF,  m_nREFmask,  ref_n);
	SETMPI_FUNC(SetVIRQ, m_nVIRQmask, irq0_n);
	SETMPI_FUNC(SetIRQ1, m_nIRQ1mask, irq1_n);
	SETMPI_FUNC(SetIRQ2, m_nIRQ2mask, irq2_n);
	SETMPI_FUNC(SetIRQ3, m_nIRQ3mask, irq3_n);
	/*
	 *iak0_n...     
	 *     
	 *   ,   iak4, 5  ..
	 *    ,        .
	 **/
	SETMPI_FUNC(SetIAKO, m_nIAKOmask, iak0_n);
	SETMPI_FUNC(SetIAK1, m_nIAK1mask, iak1_n);
	SETMPI_FUNC(SetIAK2, m_nIAK2mask, iak2_n);
	SETMPI_FUNC(SetIAK3, m_nIAK3mask, iak3_n);
	SETMPI_FUNC(SetEVNT, m_nEVNTmask, evnt_n);
	SETMPI_FUNC(SetSYNC, m_nSYNCmask, sync_n);
	SETMPI_FUNC(SetINIT, m_nINITmask, init_n);
	SETMPI_FUNC(SetSACK, m_nSACKmask, sack_n);
	SETMPI_FUNC(SetDMR,  m_nDMRmask,  dmr_n);
	SETMPI_FUNC(SetDMGO, m_nDMGOmask, dmgo_n);
	SETMPI_FUNC(SetHALT, m_nHALTmask, halt_n);
	SETMPI_FUNC(SetPOK,  m_nPOKmask,  pok_n);
	SETMPI_FUNC(SetDCOK, m_nDCOKmask, dcok_n);
	SETMPI_FUNC(SetDMGI, m_nDMGImask, dmgi_n);
	SETMPI_FUNC(SetBSY,  m_nBSYmask,  bsy_n);
	SETMPI_FUNC(SetSEL1, m_nSEL1mask, sel1_n);
	SETMPI_FUNC(SetSEL2, m_nSEL2mask, sel2_n);
};
