// rev 0.06

#include "stdafx.h"
#include "vm1.h"

const WORD g_WordBitMask[16] =
{
	1 << 0,
	1 << 1,
	1 << 2,
	1 << 3,
	1 << 4,
	1 << 5,
	1 << 6,
	1 << 7,
	1 << 8,
	1 << 9,
	1 << 10,
	1 << 11,
	1 << 12,
	1 << 13,
	1 << 14,
	1 << 15
};

const DWORD g_DwordBitMask[32] =
{
	1 << 0,
	1 << 1,
	1 << 2,
	1 << 3,
	1 << 4,
	1 << 5,
	1 << 6,
	1 << 7,
	1 << 8,
	1 << 9,
	1 << 10,
	1 << 11,
	1 << 12,
	1 << 13,
	1 << 14,
	1 << 15,
	1 << 16,
	1 << 17,
	1 << 18,
	1 << 19,
	1 << 20,
	1 << 21,
	1 << 22,
	1 << 23,
	1 << 24,
	1 << 25,
	1 << 26,
	1 << 27,
	1 << 28,
	1 << 29,
	1 << 30,
	1 << 31
};

const QWORD g_QwordBitMask[64] =
{
	1i64 << 0,
	1i64 << 1,
	1i64 << 2,
	1i64 << 3,
	1i64 << 4,
	1i64 << 5,
	1i64 << 6,
	1i64 << 7,
	1i64 << 8,
	1i64 << 9,
	1i64 << 10,
	1i64 << 11,
	1i64 << 12,
	1i64 << 13,
	1i64 << 14,
	1i64 << 15,
	1i64 << 16,
	1i64 << 17,
	1i64 << 18,
	1i64 << 19,
	1i64 << 20,
	1i64 << 21,
	1i64 << 22,
	1i64 << 23,
	1i64 << 24,
	1i64 << 25,
	1i64 << 26,
	1i64 << 27,
	1i64 << 28,
	1i64 << 29,
	1i64 << 30,
	1i64 << 31,
	1i64 << 32,
	1i64 << 33,
	1i64 << 34,
	1i64 << 35,
	1i64 << 36,
	1i64 << 37,
	1i64 << 38,
	1i64 << 39,
	1i64 << 40,
	1i64 << 41,
	1i64 << 42,
	1i64 << 43,
	1i64 << 44,
	1i64 << 45,
	1i64 << 46,
	1i64 << 47,
	1i64 << 48,
	1i64 << 49,
	1i64 << 50,
	1i64 << 51,
	1i64 << 52,
	1i64 << 53,
	1i64 << 54,
	1i64 << 55,
	1i64 << 56,
	1i64 << 57,
	1i64 << 58,
	1i64 << 59,
	1i64 << 60,
	1i64 << 61,
	1i64 << 62,
	1i64 << 63
};

C1801VM1::C1801VM1()
	: m_nClk(0)
	, m_bInit(false)
	, m_pMPI(NULL)
{
	srand((unsigned)time(NULL));

#ifdef DBG_OUT_PLI_LOG
#define DBG_PLI_LOG_NAME "_PLI_log.txt"
	m_PLILog = fopen(DBG_PLI_LOG_NAME, "wt");
	fprintf(m_PLILog, "        ");
	fprintf(m_PLILog, "     19     18     17     16     15     14     13     12     11     10     09     08     07     06     05     04     03     02     01     00       ");
	fprintf(m_PLILog, "     10     09     08     07     06     05     04     03     02     01     00\n");
	fprintf(m_PLILog, "        ");
	fprintf(m_PLILog, " VE-Trq IRQ3rq QBV-to IRQ2rq PSW4-T IRQ1rq ACLOup WAITmd ACLOdn DblErT QBOAto VIRQrq unused unused unused PSW7-P UnkOpc  PSW11 FBO-B4  PSW10       ");
	fprintf(m_PLILog, " RqDtRe MiCR12 RqDtRe MiCR13 RqDtRe MiCR14 FB-Pri VG-Sel VG-Sel VG-Sel VG-Sel\n");
#endif
#ifdef DBG_OUT_PLM_LOG
#define DBG_PLM_LOG_NAME "_PLM_log.txt"
	m_PLMLog = fopen(DBG_PLM_LOG_NAME, "wt");
	fprintf(m_PLMLog, "        ");
	fprintf(m_PLMLog, "                                    33     32     31     30     29     28     27     26     25     24     23     22     21     20     19     18     17     16     15     14     13     12     11     10     09     08     07     06     05     04     03     02     01     00\n");
	fprintf(m_PLMLog, "        ");
	fprintf(m_PLMLog, "opcode  PRI T N Z V C Addr/St                                 ~mj0                               ~mj1                               ~mj2                         mj3               UncOpc                  mj4 OpType OpType OpType    mj5                               ~mj6\n");
#endif
#ifdef DBG_OUT_WIRESDIFF
#define DBG_WIRESDIFF_LOG_NAME "_wiresdiff_log.txt"
	FILE *f = fopen(DBG_WIRESDIFF_LOG_NAME, "wt");
	fclose(f);
#endif
	m_IOPins.clear();
	reg.clear();
	wire.clear();

	m_nCpuType = CPU_VM1A;

	pli_matrix_a = new vm1a_pli();
	pli_matrix_g = new vm1g_pli();
	plm_matrix_a = new vm1a_plm();
	plm_matrix_g = new vm1g_plm();

	initial();
}

C1801VM1::~C1801VM1()
{
	if (pli_matrix_a)
	{
		delete pli_matrix_a;
	}
	if (pli_matrix_g)
	{
		delete pli_matrix_g;
	}
	if (plm_matrix_a)
	{
		delete plm_matrix_a;
	}
	if (plm_matrix_g)
	{
		delete plm_matrix_g;
	}
#ifdef DBG_OUT_PLI_LOG
	fclose(m_PLILog);
#endif
#ifdef DBG_OUT_PLM_LOG
	fclose(m_PLMLog);
#endif
}

void C1801VM1::RegisterDevice(MPI *pMPI)
{
	m_pMPI = pMPI;
	ASSERT(m_pMPI);
	m_nDeviceID = m_pMPI->RegisterDevice();
	ASSERT(m_nDeviceID != -1);
}


/*     */
void C1801VM1::initial()
{
	//plm[33:0] = 34'o000000000000;
	for (int i = 0; i < 34; ++i)
	{
		reg.plm[i] = false;
	}
	//reg.psw[15:0] = 16'o000000;
	for (int i = 0; i < 16; ++i)
	{
		reg.psw[i] = false;
	}

	for (int i = 0; i < 14; ++i)
	{
		//  0 -   .    .
		reg.gpr[i] = 0; // (WORD)((double)rand() / (RAND_MAX + 1) * (65535));
	}
	//reg.tve_count = (WORD)((double)rand() / (RAND_MAX + 1) * (65535));
	//reg.tve_limit = (WORD)((double)rand() / (RAND_MAX + 1) * (65535));
}
void C1801VM1::initCPU()
{
	m_bInit = false;
}

/*       */
void C1801VM1::eval_p(int nClk)
{
	m_nClk = nClk;

	if (!m_bInit)
	{
		//  .   
		m_bInit = true;
		assign_all("sp");
		eval_all_p();
		eval_all_n();
		assign_all("ip");
	}
	else
	{
		assign_all("p>");	//  assign
	}
	eval_all_p();	//  always   
	assign_all("p<");	//  assign

}

/*       */
void C1801VM1::eval_n(int nClk)
{
	m_nClk = nClk;

	if (!m_bInit)
	{
		//  .   
		m_bInit = true;
		assign_all("sn");
		eval_all_n();
		eval_all_p();
		assign_all("in");
	}
	else
	{
		assign_all("n>");	//  assign
	}
	eval_all_n();	//  always   
	assign_all("n<");	//  assign

}

/*   assign
 *    ,   assign      .
 * 
 *         3 ,     2.
 *  -   inout,        ,
 *     - pin_ad_in,  - .
 */
static bool wire_qbus_tena_prev = false; //TODO:       .
static bool wire_pin_dclo_prev = false;
static bool wire_tve_reset_prev = false;
void C1801VM1::assign_all(const char *str)
{
	int n = 0;
l_mochala:
	bool bChng = false;
	wire_qbus_tena_prev = wire.qbus_tena;
	wire_pin_dclo_prev = wire.pin_dclo;
	wire_tve_reset_prev = wire.tve_reset;

	assign_func();
	//    ,    ,    
	do{
		prev_wire = wire;
		assign_func();
		if (++n > 200)
		{
			//
			TRACE1("Steps num: %d\n", n);
			ASSERT(FALSE);
			break;
		}
#ifdef DBG_OUT_WIRESDIFF
		if (prev_wire != wire)
		{
			Out_Difference(m_nClk, n, str);
		}
#endif
	} while (prev_wire != wire); //       .

	if (wire_qbus_tena_prev && !wire.qbus_tena)
	{
		always_posedge_pin_clk_n_or_negedge_qbus_tena_part_qbus_tena();
		bChng = true;
	}
	// --   -------------------
	if (!wire_pin_dclo_prev && wire.pin_dclo)
	{
		always_posedge_pin_clk_p_or_posedge_pin_dclo_part_pin_dclo();
		always_posedge_pin_clk_p_timer_part_pin_dclo();
		bChng = true;
	}
	if (!wire_tve_reset_prev && wire.tve_reset)
	{
		always_posedge_pin_clk_p_or_posedge_tve_reset_part_tve_reset();
		always_posedge_pin_clk_p_timer_part_tve_reset();
		bChng = true;
	}
	if (bChng)
	{
		goto l_mochala; //  ,   -  
	}
	//TRACE2("Clock: %d, Steps num: %d\n", m_nClk, n);
}

/*   always    */
void C1801VM1::eval_all_p()
{
	snap_reg = reg; //  .      reg,   - snap_reg
	always_a(); //always   (*)

	// --   -------------------
	if (!wire.pin_dclo)
	{
		always_posedge_pin_clk_p_or_posedge_pin_dclo_part_pin_clk_p();
	}
	if (!wire.tve_reset)
	{
		always_posedge_pin_clk_p_or_posedge_tve_reset_part_pin_clk_p();
	}
	if (!(wire.pin_dclo || wire.tve_reset))
	{
		always_posedge_pin_clk_p_timer();
	}
	//----------------------------------

	always_posedge_pin_clk_p(); //reg.mjres, reg.reset, reg.abort  

	if (!snap_reg.mjres && reg.mjres) //    posedge,  snap_reg -   ,   reg - 
	{
		always_posedge_pin_clk_p_or_posedge_mjres_part_mjres();
		always_posedge_pin_clk_n_or_posedge_mjres_part_mjres();
	}
	else
	{
		always_posedge_pin_clk_p_or_posedge_mjres_part_pin_clk_p();
	}

	if (!snap_reg.reset && reg.reset)
	{
		always_posedge_pin_clk_p_or_posedge_reset_part_reset();
		always_posedge_pin_clk_n_or_posedge_reset_part_reset();
	}
	else
	{
		always_posedge_pin_clk_p_or_posedge_reset_part_pin_clk_p();
	}

	if (!snap_reg.abort && reg.abort)
	{
		always_posedge_pin_clk_p_or_posedge_abort_part_abort();
	}
	else
	{
		always_posedge_pin_clk_p_or_posedge_abort_part_pin_clk_p();
	}

}

/*   always    */
void C1801VM1::eval_all_n()
{
	snap_reg = reg;
	always_a();

	always_posedge_pin_clk_n();

	if (wire.qbus_tena)
	{
		always_posedge_pin_clk_n_or_negedge_qbus_tena_part_pin_clk_n();
	}

	always_posedge_pin_clk_n_or_posedge_mjres_part_pin_clk_n();
	always_posedge_pin_clk_n_or_posedge_reset_part_pin_clk_n();
}

void C1801VM1::assign_func()
{
	bool bTmpB1, bTmpB2;
	/*         */
	/*    . -      3 ,   -  2. */
	//
	// External connection assignments
	//
	wire.pin_pa = (~m_IOPins.pin_pa_n) & 3;
	bool pin_ctrl_ena = reg.qbus_win || reg.iako_oe;	// enable control outputs
	bool pin_bsy_out  = reg.sync_out || pin_ctrl_ena;	// bus busy flag
	bool pin_dout_out = reg.dout_out && reg.dout_out_l;	// data output strobe output
	bool pin_sync_ena = reg.sync_ena || reg.sync_out;	// address strobe enable

	wire.pin_dclo	= !m_pMPI->dcok_n;		//input			// processor reset
	wire.pin_aclo	= !m_pMPI->pok_n;		//input			// power fail notification
	wire.pin_irq[0] = !m_pMPI->irq0_n;		//input			// vectored interrupt request
	wire.pin_irq[1] = !m_pMPI->irq1_n;		//input			// radial interrupt requests
	wire.pin_irq[2] = !m_pMPI->irq2_n;		//input			// radial interrupt requests
	wire.pin_irq[3] = !m_pMPI->irq3_n;		//input			// radial interrupt requests
	wire.pin_dmgi	= !m_pMPI->dmgi_n;		//input			// bus granted input

	wire.pin_sync_in = pin_sync_ena ? reg.sync_out : !m_pMPI->sync_n;	//inout			// address strobe
	bool pin_dout_in = pin_ctrl_ena ? pin_dout_out : !m_pMPI->dout_n;	//inout			// data output strobe
	bool pin_din_in  = pin_ctrl_ena ? reg.din_out  : !m_pMPI->din_n;	//inout			// data input strobe
	bool sel_in  = reg.sel_xx && pin_din_in;
	wire.sel_out = reg.sel_xx && pin_dout_in;
	//!!!   .   : pin_rply_in = pin_rply_out ? true : !m_pMPI->rply_n
	// pin_rply_out    pin_rply_in
	bool pin_rply_in = !m_pMPI->rply_n;		//inout			// transaction reply
	bool pin_rply_out = (sel_in || wire.sel_out) && (pin_rply_in || (reg.sel_reg != 1) || !reg.rply_s2);	// transaction reply output

	bool dout_ext = reg.dout_out || reg.dout_out_l;
	wire.sync_stb = reg.qbus_win && !(reg.sync_out_h && reg.qbus_win_h);

	WORD pin_ad_out = 0;	// address/data bus output
	if (sel_in)
	{
		switch (reg.sel_reg)
		{
		case 0:
			pin_ad_out = 0177740 | (wire.pin_pa << 3) | (reg.reg_csr & 7);
			break;
		case 1:
			pin_ad_out = 0177777;
			break;
		case 2:
			pin_ad_out = reg.reg_err & 0377;
			break;
			//
			// Reading the timer registers content to the shared bus
			//
		case 3:
			pin_ad_out = reg.tve_limit;
			break;
		case 4:
			pin_ad_out = reg.tve_count;
			break;
		case 5:
			pin_ad_out = 0177400 | reg.tve_csr;
			break;
		}
	}
	else if (wire.sync_stb)
	{
		pin_ad_out = reg.areg;
	}
	else if (dout_ext)
	{
		pin_ad_out = reg.au_ta0 ? ((reg.qreg & 0377) << 8) : (reg.plrt[6] ? (reg.qreg & 0377) : reg.qreg);
	}

	bool pin_ad_ena = wire.sync_stb || dout_ext || ((reg.sel_reg != 7) && (reg.sel_reg != 6) && sel_in);	// address/data bus enable
	bool pin_wtbt_out = (wire.sync_stb && !reg.plrt[8]) || (dout_ext && reg.plrt[6]);	// write/byte status

	wire.pin_ad_in = pin_ad_ena ? pin_ad_out : ~m_pMPI->ad_n;			//inout[15:0]	// inverted address/data bus

	//
	// Master processor never asserts DMR_OUT
	//
	wire.dmr_out = reg.dmr_req && wire.pin_pa;
	//bool pin_dmr_in = wire.dmr_out ? true : !m_pMPI->dmr_n; 		//inout			// bus request shared line
	bool pin_dmr_in = wire.dmr_out || !m_pMPI->dmr_n; 		//inout			// bus request shared line

	//wire.dma_in = pin_dmr_in || (reg.sack_out ? true : !m_pMPI->sack_n); // bus acknowledgement
	wire.dma_in = pin_dmr_in || (reg.sack_out || !m_pMPI->sack_n); // bus acknowledgement

	//______________________________________________________________________________
	//
	// Reset circuits
	//
	wire.reset_rc =  wire.pin_dclo || (wire.pin_aclo && !reg.init_out[0] && reg.init_out[2]);
	wire.abort_rc = (reg.qbus_tovf || wire.exc_oat || wire.exc_uop || reg.abort) && !(reg.abort_tm || wire.reset_rc);
	wire.mjres_rc =  wire.reset_rc || wire.abort_rc;

	bool pin_init_out = reg.init_out[0] || wire.reset_rc; // reg.reset;	// peripheral reset output
	//wire.tve_reset = pin_init_out || (pin_init_out ? true : !m_pMPI->init_n);		//inout			// peripheral reset
	wire.tve_reset = pin_init_out || !m_pMPI->init_n;		//inout			// peripheral reset

	wire.au_astb  = reg.au_astb_xa || (reg.ustb && reg.au_astb_xu);
	wire.au_qstbx = reg.au_qstb_xa || (reg.ustb && reg.au_qstb_xu);

	//
	// Odd address trap detector is blocked on 1801BM1
	//
	wire.exc_oat  = false;
	wire.exc_uop  = reg.plm_ena  &&  reg.plr[12];
	wire.exc_err7 = reg.plm1x_hl && !reg.plr[30];
	//______________________________________________________________________________
	//
	// 1801BM1 can issue preliminary transaction address, so the reg.plm->reg.plr strobe
	// should be delayed till current transaction in progress completed
	//
	bTmpB1 = reg.qbus_aseq[1] || (wire.au_astb && reg.qbus_aseq[0]);
	bool qbus_nrdy = bTmpB1 && !reg.oe_clr;
	wire.uplr_stb = (bTmpB1 &&  reg.oe_clr) || (wire.au_astb && !reg.qbus_aseq[0]);
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	wire.sync_fedge = reg.sync_out && !reg.sync_ena;
	//wire.din_done   = reg.din_out_l && reg.rply_ack[3]; // 
	wire.din_done = reg.din_out_l && (reg.rply_ack[3] || reg.rply_ack[2]); //  -     1 

	//wire.tplm_rc bit1 instruction early prefetch
	//wire.tplm_rc bit2 data retrieving
	//wire.tplm_rc bit3 instruction fetch
	if (reg.mjres || wire.mjres_rc || wire.din_done)
	{
		wire.tplm_rc = 0;
	}
	else
	{
		wire.tplm_rc = ((wire.uplr_stb ? 0xe : 0) & reg.tplmz) | reg.tplm;
	}
	//
	// tplm1 - instruction prefetch
	// tplm3 - instruction fetch
	//
	wire.ir_seq_rc = !(reg.mjres || wire.mjres_rc) && (reg.ir_seq ? (reg.tplm & (1<<1|1<<3)) : reg.plm23_wait);
	wire.ir_clr = ((wire.tplm_rc ^ (1 << 3)) & reg.tplm & (1 << 3)) || (!wire.ir_seq_rc && reg.ir_seq);

	wire.plm_ena_fc = !(reg.sop_out[0] || qbus_nrdy) && (reg.mjres || reg.ustb1_h || !reg.alu_busy_rp);
	wire.plm_stb_rc = !(reg.plm_stb || reg.sop_out[3] || !(reg.sop_out[2] || reg.sop_out[1]));

	//______________________________________________________________________________
	//
	// Qbus logic
	//
	wire.qbus_done = (wire.din_done && !reg.plrt[7]) || reg.dout_done || reg.mjres;
	wire.iako_out  = reg.din_out && reg.iak_flag;
	//
	// Reply acknowledgement latches
	// (converted to flip-flops approach)
	//
	wire.rply_ack_fc = pin_rply_in && pin_bsy_out;
	wire.qbus_tena  = reg.dout_out || reg.din_out;

	wire.qbus_gnt = (reg.qbus_nosr_h || (reg.sync_out_h && !reg.qbus_win_h)) && (reg.qbus_free_h || (wire.dmr_out && reg.sack_out));
	wire.qbus_nosr_rc = !(pin_rply_in || wire.pin_sync_in);
	wire.qbus_flag_rc = !wire.qbus_done && (wire.sync_fedge || reg.qbus_flag);
	wire.dmr_req_rc = (reg.sync_out || !reg.qbus_win) && (wire.au_astb || reg.dmr_req);
	wire.dout_req_rc = (!reg.plrt[8] && wire.au_qstbx && (wire.dmr_req_rc || reg.qbus_own_rp)) || (!wire.qbus_done && reg.dout_req);
//	wire.dout_start = wire.dout_req_rc && wire.qbus_flag_rc && !reg.rply_ack[3]; // originally !snap_reg.rply_ack[1]
	wire.dout_start = wire.dout_req_rc && wire.qbus_flag_rc && !reg.rply_ack[2]; // originally !snap_reg.rply_ack[1]
	
	bool qbus_own = reg.qbus_own_fp || reg.qbus_own_rp;
	bool dmgo_out = (!(reg.iako_oe || qbus_own) && wire.pin_pa && pin_dmr_in) || (!reg.qbus_req && reg.dmgi_in_l);
	wire.oe_set_fc  = wire.qbus_gnt && reg.iak_flag && !(reg.dmr_req || qbus_own);

	//______________________________________________________________________________
	//

	//------------- ----------------
	//
	//
	// Hidden clock prescaler, generates the /4 and /128 frequencies
	//
	wire.tve_tclk128 = (reg.tve_pre & 0177) == 0177;
	wire.pin_spclk = (reg.tve_edge & 6) == 2;  //reg.tve_edge[1] && !reg.tve_edge[2];

	wire.tve_zero = (reg.tve_count == 0) && !(reg.tve_csr & (1<<1));
	wire.tve_back = (reg.tve_csr & (1<< 4 | 1 << 1)) && wire.pin_spclk && reg.tve_tclk4;
	//______________________________________________________________________________
	//
	// Interrupt controller
	//
	switch (m_nCpuType)
	{
	default:
	case CPU_VM1A:
		pli_matrix_a->eval(reg.rq, wire.pli);	//  
		break;
	case CPU_VM1G:
		pli_matrix_g->eval(reg.rq, wire.pli);	//  
		break;
	}
#ifdef DBG_OUT_PLI_LOG
	OutPLILog();
#endif

	//
	// Detector's reset
	//
	bTmpB1  = reg.plm1x_hl && !reg.plr[27];
	wire.aclo_ack = bTmpB1 && (reg.plir == 1); //!reg.plir[3] && !reg.plir[2] &&  reg.plir[1];
	wire.uop_ack  = bTmpB1 && (reg.plir == 0); //!reg.plir[3] && !reg.plir[2] && !reg.plir[1];
	wire.irq2_ack = bTmpB1 && (reg.plir == 6); // reg.plir[3] &&  reg.plir[2] && !reg.plir[1];
	wire.irq3_ack = bTmpB1 && (reg.plir == 4); // reg.plir[3] && !reg.plir[2] && !reg.plir[1];
	wire.tve_ack  = bTmpB1 && (reg.plir == 5); // reg.plir[3] && !reg.plir[2] &&  reg.plir[1];
	wire.pli_req_rc = reg.plm23_ichk || reg.abort;

	//______________________________________________________________________________
	//
	// Microcode state machine
	//
	WORD nMJ; //  .
	bita2data(reg.mj, nMJ, 15);
	switch (m_nCpuType)
	{
	default:
	case CPU_VM1A:
		plm_matrix_a->eval(reg.ir, nMJ, wire.plx);
		break;
	case CPU_VM1G:
		plm_matrix_g->eval(reg.ir, nMJ, wire.plx);
		break;
	}
#ifdef DBG_OUT_PLM_LOG
	OutPLMLog();
#endif

	bTmpB1 = wire.plm_ena_fc && !reg.plm[12];
	bTmpB2 = reg.plm[11] && reg.plm[13];
	wire.plm1x_fc = bTmpB1 &&  bTmpB2;
	wire.plm2x_fc = bTmpB1 && !bTmpB2;

	//plm23_fc bit   irq check  wait IR  start IR     Note
	//       0          no       yes       no         RTT opcode, wait fetch completion
	//       1          yes      yes       yes        usual IR fetch
	//       2          yes      no        no         WAIT opcode, check irq only
	//       3          yes      yes       no         ~RTT opcode, wait fetch completion
	if (wire.plm_ena_fc && (reg.nPLM & 2))
	{
		wire.plm23_fc = (BYTE)g_WordBitMask[(reg.nPLM >> 2) & 3];
	}
	else
	{
		wire.plm23_fc = 0;
	}

	wire.plop = (BYTE)g_WordBitMask[((reg.nPLR >> 20) & 6) | (reg.plr[4] ? 1 : 0)];
// 	wire.plop[0] = !reg.plr[22] && !reg.plr[21] && !reg.plr[4]; // 000
// 	wire.plop[1] = !reg.plr[22] && !reg.plr[21] &&  reg.plr[4]; // 001
// 	wire.plop[2] = !reg.plr[22] &&  reg.plr[21] && !reg.plr[4]; // 010
// 	wire.plop[3] = !reg.plr[22] &&  reg.plr[21] &&  reg.plr[4]; // 011
// 	wire.plop[4] =  reg.plr[22] && !reg.plr[21] && !reg.plr[4]; // 100
// 	wire.plop[5] =  reg.plr[22] && !reg.plr[21] &&  reg.plr[4]; // 101
// 	wire.plop[6] =  reg.plr[22] &&  reg.plr[21] && !reg.plr[4]; // 110
// 	wire.plop[7] =  reg.plr[22] &&  reg.plr[21] &&  reg.plr[4]; // 111

	//______________________________________________________________________________
	//
	// ALU
	//
	int nYAddr = ((reg.nPLR >> 25) & 0xf);
	int nXAddr = ((reg.nPLR >> 30) & 0xf);

	bTmpB1 = !(reg.plr[11] || reg.plr[13]);

	static WORD pRecode[16] = {
		-1, 7, 11, 3, 13, 5, 9, 1, -1, 6, 10, 2, 12, 4, 8, 0
	};
	WORD n;
	WORD rs0 = -1; //       ,
	if (reg.plr[13] && reg.plr[14])
	{
		rs0 = 12;	//,  rs0[x]    1   14 .
					//        rs0[12],    
					// .
	}
	else if (bTmpB1)
	{
		rs0 = pRecode[reg.yadr];
	}

	WORD rs1 = n = pRecode[reg.xadr];

	if (n == 12 || !reg.plr[20])
	{
		wire.rsw = 12;
	}
	else if (reg.plr[20])
	{
		wire.rsw = n;
	}
	else
	{
		wire.rsw = -1;
	}

	bTmpB2 = (reg.plr[13] && !reg.plr[14]) || reg.plr[11];
	bool vc_vsel = (nYAddr == 2) && bTmpB2;
	bool vc_csel = (nYAddr != 2) && bTmpB2;

	wire.xr = (rs1 < 14) ? reg.gpr[rs1] : 0;	//X bus
	wire.yr = (rs0 < 14) ? reg.gpr[rs0] : 0;	//Y bus
	if (vc_vsel)
	{
		wire.yr |= reg.vmux;
	}
	if (vc_csel)
	{
		wire.yr |= reg.cmux;
	}

	wire.au_pswy = (nYAddr == 8) && bTmpB1;
	wire.au_qsy  = (nYAddr == 0) && bTmpB1;
	wire.au_pswx = (nXAddr == 8);
	wire.au_qsx  = (nXAddr == 0);

	wire.au_is0 = !(reg.plr[13] && reg.plr[14] && reg.plr[25] && reg.plr[26] && !reg.plr[27]);

	wire.au_pstbx = wire.au_pswx && reg.plr[20];


	//______________________________________________________________________________
	//
	// ALU function unit
	//
	WORD nx = reg.alu_x ? ~reg.xreg : reg.xreg;
	//
	// ALU controls
	//
	// plr[17:13]  cl  alu_b alu_c alu_d alu_e alu_x   oxy   axy      h     alu
	//    00x00    1     0     1     0     0     0    ~x|~y ~x&~y  ~(x^y)   x+y
	//    00x01    1     0     1     0     0     0      -     -       -      -
	//    00x11    1     0     1     0     0     0      -     -       -      -
	//    00x10    1     0     0     0     1     0    ~x|~y  ~x    ~(x&~y)  x&~y
	//    01x00    0     0     1     0     0     1     x|~y  x&~y    x^y    y-x
	//    01x01    0     0     1     0     0     1      -     -       -      -
	//    01x11    0     0     1     0     0     1      -     -       -      -
	//    01x10    0     0     1     0     1     0    ~x|~y ~x&~y  ~(x^y)   x^y
	//    10x00    1     1     1     0     1     0    ~x|y  ~x&~y    ~y      y
	//    10x01    1     0     0     0     1     0      1    ~x      ~x      x
	//    10x10    1     0     1     0     1     0      1   ~x&~y  ~(x|y)   x|y
	//    10x11    1     0     0     0     1     0      1    ~x      ~x      x
	//    11x00    0     1     0     1     0     0    ~x|y  ~x&y     x^y    x-y
	//    11x01    0     1     0     1     0     0      -     -       -      -
	//    11x11    0     1     0     1     0     0      -     -       -      -
	//    11x10    1     1     0     0     1     0    ~x|y   ~x    ~(x&y)   x&y
	//
	wire.alu_e_fc = (reg.plr[17] && !reg.plr[16]) ||  (reg.plr[14] && !reg.plr[13]);
	wire.cl_fc    = (reg.plr[17] && wire.alu_e_fc) || !reg.plr[16];
	wire.alu_b_fc =  reg.plr[17] && (reg.plr[16]  || !(reg.plr[14] || reg.plr[13]));
	wire.alu_c_fc = (!reg.plr[13] && (reg.plr[16] ^ reg.plr[17])) || !(wire.alu_e_fc || reg.plr[17]);
	bTmpB1 = !wire.alu_e_fc && reg.plr[16];
	wire.alu_d_fc = bTmpB1 &&  reg.plr[17];
	wire.alu_x_fc = bTmpB1 && !reg.plr[17];
	wire.alu_s_fc = !(reg.plr[13] && reg.plr[14]) || (reg.plr[25] && reg.plr[26]);

	//
	// ALU and/or products
	//
	WORD oxy = ~(nx & ((reg.plr[17] ? 0 : ~reg.yreg) | (reg.alu_b ? reg.yreg : 0)));	// OR product
	WORD axy = ~(nx | (reg.alu_d ? reg.yreg : 0) | (reg.alu_c ? ~reg.yreg : 0));		// AND product
	//
	// ALU selectable function
	//
	WORD h = ~(oxy | axy) | (oxy & axy);	// half summ
	bool bAXY[16], bOXY[16], bC[16], bF[16], bH[16];
	data2bita(oxy, bOXY, 16);
	data2bita(axy, bAXY, 16);
	data2bita(h, bH, 16);
	bool cn, cl = reg.cl;
	if (reg.alu_e)
		for (int i = 0; i < 16; ++i)
		{
			bC[i] = cn = (cl || bAXY[i]) && bOXY[i];	//carry
			bF[i] = bH[i];	//ALU function inverted output
			cl = cn;
		}
	else
		for (int i = 0; i < 16; ++i)
		{
			bC[i] = cn = (cl || bAXY[i]) && bOXY[i];	//carry
			bF[i] = !(cl ^ bH[i]);	//ALU function inverted output
			cl = cn;
		}

	WORD f;	// ALU function inverted output
	bita2data(bF, f, 16);
	//
	// ALU result shifter
	//
	bool fctl[8];
	fctl[2] = !(reg.plr[25] || reg.plr[26]) && reg.plr[27];
	fctl[1] = fctl[2] && !reg.plr[18];
	fctl[3] = reg.plr[27] && reg.plr[18];
	bTmpB1 = reg.plr[13] && reg.plr[14] && reg.plr[27];
	fctl[4] = bTmpB1 && !reg.plr[25] &&  reg.plr[26];
	fctl[6] = bTmpB1 &&  reg.plr[25] && !reg.plr[26];
	fctl[5] = fctl[4] && !reg.plr[18];
	fctl[7] = fctl[6] && !reg.plr[18];

	bool fbitc = !(reg.psw[0] && !reg.plr[25] && reg.plr[26]);
	bool fbit7 = fctl[1] && bF[7]
			  || fctl[3] && bF[8]
			  || fctl[7] && bC[7]
			  || fctl[5] && fbitc;
	bool fbit15 = fctl[2] && bF[15]
			   || fctl[6] && bC[15]
			   || fctl[4] && fbitc;

	//
	// alu_shr = !alu_s &&  reg.plr[27];
	// alu_shl = !alu_s && !reg.plr[27];
	//
	WORD alu;	// ALU output to X/Y bus
	if (reg.alu_s)
	{
		alu = ~f;
	}
	else if (reg.plr[27])
	{
		alu = ~(((f & 0177376) >> 1) | (fbit15 ? 0100000 : 0) | (fbit7 ? 0200 : 0));
	}
	else
	{
		alu = ~(((f & 077777) << 1) | (fbitc ? 1 : 0));
	};

	//
	// X bus (12 entries)
	//    AU_RSX0  - general purpose regs
	//    AU_RSX1  - general purpose regs
	//    AU_QSX   - qbus temporary reg
	//    AU_PSWX  - PSW
	//
	//    AU_ALSx  - ALU result strobe     (writeonly)
	//    AU_ASTB  - A address register    (readonly)
	//    AU_ASTB  - A address register    (readonly)
	//    AU_QSTBX - Qbus temporary reg    (readonly)
	//    AU_QSTBX - Qbus temporary reg    (readonly)
	//    AU_IS0   - ALU X argument        (readonly)
	//    AU_IS1   - ALU X argument        (readonly)
	//
	// Y bus, inverted (9 entries)
	//    AU_RSY0  - general purpose regs
	//    AU_RSY1  - general purpose regs
	//    AU_QSY   - Qbus temporary reg
	//    AU_PSWY  - PSW
	//
	//    AU_ALSx  - ALU result strobe     (writeonly))
	//    AU_VSELY - vector generator      (Y-writeonly)
	//    AU_CSELY - constant generator    (Y-writeonly)
	//    ALU_U    - ALU Y argument        (readonly)
	//
	WORD nPSW;
	bita2data(reg.psw, nPSW, 16);
	wire.x = reg.au_alsl ? (reg.au_alsh ? alu : alu & 0377) :
		(wire.xr
		| (wire.au_qsx ? reg.qreg : 0)
		| (wire.au_pswx ? nPSW : 0));

	wire.y = ~(wire.yr
			| (wire.au_qsy ? reg.qreg : 0)
			| (wire.au_pswy ? nPSW : 0));

	//
	// ALU result condition flags
	//
	bool fmux[2];
	fmux[0] = reg.cl ? (reg.alu_e || (reg.plr[18] ? bC[15] : bC[7])) : !(reg.alu_e || (reg.plr[18] ? bC[15] : bC[7]));
	fmux[1] = (bF[0] || !reg.plr[27]) && (reg.plr[27] || (reg.plr[18] ? bF[15] : bF[7]));

	wire.flag[0] = reg.alu_s ? !fmux[0] : !fmux[1];									// C
	wire.flag[2] = (!reg.plr[18] || ((alu & 0177400) == 0)) && ((alu & 0377) == 0);	// Z
	wire.flag[3] = reg.plr[18] ? GETBIT(alu, 15) : GETBIT(alu, 7);					// N
	wire.flag[1] = !((reg.alu_s && reg.alu_e)										// V
				 || ((reg.alu_s || (fmux[1] ^ wire.flag[3])) && (reg.plr[18] ? (bC[14] ^ !bC[15]) : (bC[6] ^ !bC[7]))));

	//
	// External connection assignments
	//

//--      . -      3 . -------------

	//  Z,      ,     setPins
	//
	// Shared Qbus lines
	//
	m_pMPI->SetSYNC(m_nDeviceID, pin_sync_ena, !reg.sync_out);		//inout			// address strobe
	m_pMPI->SetAD(m_nDeviceID,   pin_ad_ena,   ~pin_ad_out);		//inout[15:0]	// inverted address/data bus
	m_pMPI->SetDOUT(m_nDeviceID, pin_ctrl_ena, !pin_dout_out);		//inout			// data output strobe
	m_pMPI->SetDIN(m_nDeviceID,  pin_ctrl_ena, !reg.din_out );		//inout			// data input strobe
	m_pMPI->SetWTBT(m_nDeviceID, pin_ctrl_ena, !pin_wtbt_out);		//output		// write/byte status
	m_pMPI->SetIAKO(m_nDeviceID, pin_ctrl_ena, !reg.iako_out_lh);	//output		// interrupt vector input

	m_pMPI->SetDMGO(m_nDeviceID, true, !dmgo_out); 					//output		// bus granted output
	//
	// "Open collector" outputs
	//
	m_pMPI->SetINIT(m_nDeviceID, pin_init_out,	false);			//inout			// peripheral reset
	m_pMPI->SetSACK(m_nDeviceID, reg.sack_out,	false);			//inout			// bus acknowlegement
	m_pMPI->SetRPLY(m_nDeviceID, pin_rply_out,	false);			//inout			// transaction reply
	m_pMPI->SetDMR(m_nDeviceID,  wire.dmr_out,	false);			//inout			// bus request shared line
	m_pMPI->SetBSY(m_nDeviceID,  pin_bsy_out,	false);			//output		// bus busy flag
	m_pMPI->SetSEL1(m_nDeviceID, (reg.sel_reg == 7),	false);			//output		// register select outputs
	m_pMPI->SetSEL2(m_nDeviceID, (reg.sel_reg == 6),	false);			//output		// register select outputs
}

// ---   ---------------------------------------------------------
void C1801VM1::always_posedge_pin_clk_p_or_posedge_pin_dclo_part_pin_dclo()
{
}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_pin_dclo_part_pin_clk_p()
{
	if (m_IOPins.pin_ena)
	{
		reg.tve_pre = (snap_reg.tve_pre + 1) & 0177;
		//
		// Documented divisor 1/4, 1/16, 1/64
		//
		if (wire.tve_tclk128)
		{
			reg.tve_div = (snap_reg.tve_div + 1) & 077;
		}
	}
}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_tve_reset_part_tve_reset()
{
}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_tve_reset_part_pin_clk_p()
{
	if (m_IOPins.pin_ena)
	{
		reg.tve_tclk4 = (snap_reg.tve_pre & 3) == 3;
		//
		// Timer clock selector
		//
		/*
		reg.tve_tclk = (snap_reg.tve_csr[0]) ?
			( wire.pin_spclk && ((snap_reg.tve_pre & 3) == 3) ) :
			( wire.tve_tclk128 && ( !snap_reg.tve_csr[6] && !snap_reg.tve_csr[5]
								 ||  snap_reg.tve_csr[6] && !snap_reg.tve_csr[5] && ((snap_reg.tve_div & 3) == 3)
								 || !snap_reg.tve_csr[6] &&  snap_reg.tve_csr[5] && ((snap_reg.tve_div & 017) == 017)
								 ||  snap_reg.tve_csr[6] &&  snap_reg.tve_csr[5] && ((snap_reg.tve_div & 077) == 077) ) );
		*/
		if (snap_reg.tve_csr & (1<<0))
		{
			reg.tve_tclk = wire.pin_spclk && reg.tve_tclk4;//,  reg.tve_tclk4    (snap_reg.tve_pre & 3) == 3
		}
		else
		{
			bool b;
			switch ((snap_reg.tve_csr >> 5) & 3)
			{
			case 0: b = true;
				break;
			case 1: b = ((snap_reg.tve_div & 017) == 017);
				break;
			case 2: b = ((snap_reg.tve_div & 3) == 3);
				break;
			case 3: b = ((snap_reg.tve_div & 077) == 077);
				break;
			}
			reg.tve_tclk = wire.tve_tclk128 && b;
		}

		//
		// Falling edge detector (raising for the inverted input pin_sp)
		//
		if (snap_reg.tve_tclk4)
		{
			//
			// Input metastability eliminator and synchronizer
			//
			reg.tve_edge = (snap_reg.tve_edge << 1) | (m_IOPins.pin_sp_n ? 0 : 1);
			//
			// Counter zero flag edge detector
			//
			reg.tve_zprev = wire.tve_zero;
		}
	}

	if (!((snap_reg.tve_csr & (1 << 2)) && (wire.tve_zero || wire.tve_back)))
	{
		reg.tve_intrq[1] = snap_reg.tve_intrq[0];
	}

	if (m_IOPins.pin_ena)
	{
		//
		// Interrupt flags
		//
		if ((snap_reg.tve_csr & (1<<2)) && (wire.tve_zero || wire.tve_back))
		{
			reg.tve_intrq[0] = true;
		}
	}
	else if (wire.tve_ack)
	{
		//
		// New timer interrupt request raising while 
		// acknowledgement can be missed
		//
		reg.tve_intrq[0] = false;
	}
}

//
// Timer counter, preload/capture and control registers
//
void C1801VM1::always_posedge_pin_clk_p_timer_part_pin_dclo()
{
	reg.tve_limit = 0104014;    // random initial value after POWER_ON
	reg.tve_count = 0177777;    // random initial value after POWER_ON

	reg.tve_pre = 0;
	reg.tve_div = 0;

	reg.tve_tclk4 = 0;
	reg.tve_tclk = 0;
	reg.tve_edge = 0;
	reg.tve_intrq[0] = false;
	reg.tve_intrq[1] = false;
	reg.tve_zprev = false;

	reg.tve_csr = 0;
}
void C1801VM1::always_posedge_pin_clk_p_timer_part_tve_reset()
{
	//
	// The control timer register reset is implemented in the original chip
	//
	reg.tve_csr = 0;
}
void C1801VM1::always_posedge_pin_clk_p_timer()
{
	//
	// Timer counter, preload/capture and control registers
	//
	//
	// Timer control register
	//
	// csr[0]   - selects external clock source
	// csr[1]   - selects capture mode
	// csr[2]   - enables interrupt request
	// csr[3]   - selects one-shot mode
	// csr[4]   - timer count enable
	// csr[5]   - 1/16 divider enable
	// csr[6]   - 1/4 divider enable
	// csr[7]   - interrupt overflow flag
	//
	bool tve_csr_wr = wire.sel_out && (snap_reg.sel_reg == 5);
	bool tve_lim_wr = wire.sel_out && (snap_reg.sel_reg == 3);

	if (tve_csr_wr)
	{
		//
		// The prioritized CSR write from bus
		// Clocked every system bus cycle
		//
		reg.tve_csr = LOBYTE(wire.pin_ad_in);
		//
		// Counter is written unconditionally at every CSR bus write
		//
		reg.tve_count = snap_reg.tve_limit;
	}

	if (tve_lim_wr)
	{
		//
		// The prioritized register write from bus
		// Clocked every system bus cycle
		//
		reg.tve_limit = wire.pin_ad_in;
	}

	if (m_IOPins.pin_ena)
	{
		//
		// Timer counter, preload/capture and control registers
		//
		if (!tve_csr_wr)
		{
			if (wire.tve_zero && (snap_reg.tve_csr & (1 << 3)))
			{
				//
				// Reset the RUN bit in one-shot mode
				//
				reg.tve_csr &= ~(1<<4);
			}

			if (snap_reg.tve_intrq[1] && (snap_reg.tve_csr & (1 << 2)) && (wire.tve_zero || wire.tve_back))
			{
				//
				// Set the interrupt overflow flag if enabled
				//
				reg.tve_csr |= 1<<7;
			}

			//
			// Decrementing counter register
			//
			if (!snap_reg.tve_zprev && wire.tve_zero && snap_reg.tve_tclk4 && !(snap_reg.tve_csr & (1 << 1))) // timer counter load
			{
				//
				// Counter is being reloaded
				//
				reg.tve_count = snap_reg.tve_limit;
			}
			else if (snap_reg.tve_tclk && (snap_reg.tve_csr & (1 << 4)))
			{
				//
				// Count selected clock events if enabled
				//
				reg.tve_count = snap_reg.tve_count - 1;
			}
		}

		//
		// Timer preload and capture value register
		//
		if (!tve_lim_wr && wire.tve_back)
		{
			//
			// Capture the current counter value
			//
			reg.tve_limit = snap_reg.tve_count;
		}
	}
}

//------------------------------------------------------------------------

void C1801VM1::always_posedge_pin_clk_n()
{
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	reg.plm_ena = wire.plm_ena_fc;

	reg.sop_out[1] = snap_reg.sop_out[0];
	reg.sop_out[3] = snap_reg.ir_stop || snap_reg.pli_req || snap_reg.ir_stb2 || snap_reg.mjres_h || (snap_reg.alu_nrdy && (wire.plop & (1<<0|1<<4)));

	reg.ustb1 = snap_reg.ustb_h;
	reg.ustb1_hl = snap_reg.ustb1_h;

	reg.ir_set = (wire.plm23_fc & (1 << 3 | 1 << 1 | 1 << 0)) ? true : false; //wire.plm23_fc[0] || wire.plm23_fc[1] || wire.plm23_fc[3];

	//______________________________________________________________________________
	//
	// Qbus logic
	//
//	reg.rply_ack[0] = wire.rply_ack_fc;
	reg.rply_ack[2] = snap_reg.rply_ack[1];
	reg.dmr_req_l = snap_reg.dmr_req;

	//reg.dout_done = !wire.dout_start && snap_reg.dout_out_l; // 
	reg.dout_done = snap_reg.rply_ack[1] && snap_reg.dout_out; //  -     1 
	reg.dout_out_l = snap_reg.dout_out;
	reg.din_out_l = snap_reg.din_out;
	//bool oe_clr_fc = reg.oe_clr = snap_reg.mjres || (!(snap_reg.rply_ack[0] || snap_reg.qbus_flag) && snap_reg.rply_ack[2]); //   - 
	//bool oe_clr_fc = reg.oe_clr = snap_reg.mjres || (!(wire.rply_ack_fc || snap_reg.qbus_flag) && snap_reg.rply_ack[2]); //  - 
	bool oe_clr_fc = reg.oe_clr = snap_reg.mjres || (!(wire.rply_ack_fc || snap_reg.qbus_flag) && snap_reg.rply_ack[1]); //  -   SYNC  1 

	reg.oe_set = wire.oe_set_fc;

	reg.sync_out = snap_reg.qbus_win_h;
	reg.sync_ena = snap_reg.sync_out_h;
	reg.qbus_gnt_l = wire.qbus_gnt;

	reg.dmgi_in_l = wire.pin_dmgi;
	reg.rply_s3 = !snap_reg.rply_s2;
	reg.rply_s2 = snap_reg.start_irq;

	if (oe_clr_fc)
	{
		reg.iako_oe = false;
	}
	else if (wire.oe_set_fc)
	{
		reg.iako_oe = true;
	}

	if (oe_clr_fc)
	{
		reg.qbus_win = false;
	}
	else if (snap_reg.dmr_req && wire.qbus_gnt)
	{
		reg.qbus_win = true;
	}

	if (snap_reg.qbus_own_rp)
	{
		reg.qbus_own_fp = false;
	}
	else if (snap_reg.dmr_req && wire.qbus_gnt)
	{
		reg.qbus_own_fp = true;
	}


	//______________________________________________________________________________
	//
	// Microcode state machine
	//
	reg.plm23_wait = (wire.plm23_fc & (1 << 3 | 1 << 0)) ? true : false; //wire.plm23_fc[0] || wire.plm23_fc[3];
	reg.plm23_ichk = (wire.plm23_fc & (1 << 3 | 1 << 2 | 1 << 1)) ? true : false;//wire.plm23_fc[1] || wire.plm23_fc[2] || wire.plm23_fc[3];

	reg.plm1x = wire.plm1x_fc;
	reg.plm2x = wire.plm2x_fc;
	reg.plm1x_hl = snap_reg.plm1x;

	if (snap_reg.plm_ena)
	{
		reg.psw_stb = (wire.plop & (1 << 0 | 1 << 2 | 1 << 7)) ? false : true;
		reg.psw_stbc = (wire.plop & (1 << 0 | 1 << 2 | 1 << 7 | 1 << 1 | 1 << 3)) ? false : true;
		bool btmp1 = (wire.plop & (1 << 1 | 1 << 5 | 1 << 7)) ? false :true;
		reg.psw_mj = (wire.plop & (1 << 7)) && snap_reg.ir_stb2;
		//reg.mj_stb1 = ((wire.plop & (1 << 7)) && snap_reg.ir_stb2) || btmp1;
		//reg.mj_stb2 = ((wire.plop & (1 << 7)) && snap_reg.ir_stb2) || (btmp1 && !(wire.plop & (1 << 3)));
		reg.mj_stb1 = reg.psw_mj || btmp1; //,      reg.psw_mj
		reg.mj_stb2 = reg.psw_mj || (btmp1 && !(wire.plop & (1 << 3)));
	}
	//______________________________________________________________________________
	//
	if (wire.plm_ena_fc)
	{
		for (int i = 0; i < 34; ++i)
		{
			reg.plr[i] = snap_reg.plm[i];
		}
		reg.nPLR = snap_reg.nPLM;
	}
	//
	// ALU result flags and PSW
	//
	if (snap_reg.au_alsl)
	{
		reg.freg[0] = wire.flag[0];
		reg.freg[1] = wire.flag[1];
		reg.freg[2] = wire.flag[2];
		reg.freg[3] = wire.flag[3];
	}

	//
	// ALU general purpose registers
	//

	reg.xadr = (snap_reg.nPLR >> 30) & 0xf;
	reg.yadr = (snap_reg.nPLR >> 25) & 0xf;

	reg.vc_vreg = snap_reg.vsel;

	if (wire.rsw < 14)
	{
		if (snap_reg.au_alsl)
		{
			//  
			reg.gpr[wire.rsw] &= 0xff00;
			reg.gpr[wire.rsw] |= wire.x & 0xff;
		}
		if (snap_reg.au_alsh)
		{
			//  
			reg.gpr[wire.rsw] &= 0xff;
			reg.gpr[wire.rsw] |= wire.x & 0xff00;
		}
	}

	reg.au_alsl = snap_reg.alu_busy_rp && snap_reg.ustb_h;
	//reg.au_alsh = snap_reg.alu_busy_rp && snap_reg.ustb_h && snap_reg.plr[18];
	reg.au_alsh = reg.au_alsl && snap_reg.plr[18]; //,      reg.au_alsl
	bool btmp2 = snap_reg.plr[7] || snap_reg.plr[8];
	//bool btmp1 = snap_reg.alu_busy_rp && snap_reg.ustb_h && !((!snap_reg.plr[14] && snap_reg.plr[13]) || snap_reg.plr[23]);
	bool btmp1 = reg.au_alsl && !((!snap_reg.plr[14] && snap_reg.plr[13]) || snap_reg.plr[23]);
	reg.au_astb_xa = btmp1 &&  btmp2;
	reg.au_qstb_xa = btmp1 && !btmp2;
	btmp1 = !(snap_reg.plr[14] || snap_reg.plr[23]) && snap_reg.plr[13];
	reg.au_astb_xu = btmp1 &&  btmp2;
	reg.au_qstb_xu = btmp1 && !btmp2;

	if (wire.au_astb)
	{
		reg.areg = wire.x;
	}
	//
	// ALU input parameters (from X and Y buses) registers
	//
	reg.xreg = (wire.au_is0) ? wire.x : ((wire.x & 0xff) << 8) | ((wire.x & 0xff00) >> 8);

	reg.yreg = wire.y;

	reg.cl    = wire.cl_fc;
	reg.alu_b = wire.alu_b_fc;
	reg.alu_c = wire.alu_c_fc;
	reg.alu_d = wire.alu_d_fc;
	reg.alu_e = wire.alu_e_fc;
	reg.alu_x = wire.alu_x_fc;
	reg.alu_s = wire.alu_s_fc;
}


void C1801VM1::always_posedge_pin_clk_p()
{
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	reg.ir_seq = wire.ir_seq_rc;
	reg.sop_out[2] = snap_reg.sop_out[1];

	if (wire.plm_stb_rc)
	{
		reg.sop_out[0] = false;
	}
	else if (wire.mjres_rc || snap_reg.plm_ena)
	{
		reg.sop_out[0] = true;
	}

	reg.plm_stb = wire.plm_stb_rc;
	reg.ustb1_h = snap_reg.ustb1;
	reg.tplm = wire.tplm_rc;

	//
	//      plr[6]  QBUS operation type: byte operation flag
	//      plr[7]  QBUS operation type: write flag
	//      plr[8]  QBUS operation type: read flag
	//                      00x - nothing
	//                      010 - write word
	//                      011 - write byte
	//                      100 - read word
	//                      101 - read byte
	//                      110 - read-modify-write word
	//                      111 - read-modify-write byte
	//
	reg.plrtz[6] = snap_reg.plr[6];
	reg.plrtz[7] = snap_reg.plr[7] && snap_reg.plr[8];
	reg.plrtz[8] = snap_reg.plr[8];

	//
	// Reset Read Flag after read completion within
	// read-modify-write operations
	//
	if (wire.din_done)
	{
		reg.plrt[8] = false;
	}
	else if (wire.uplr_stb)
	{
		reg.plrt[8] = snap_reg.plrtz[8];
	}

	if (wire.uplr_stb)
	{
		reg.plrt[7] = snap_reg.plrtz[7];
		reg.plrt[6] = snap_reg.plrtz[6];
	}

	//______________________________________________________________________________
	//
	// Qbus logic
	//
	reg.iako_out_lh = wire.iako_out;
//	reg.rply_ack[1] = snap_reg.rply_ack[0];
	reg.rply_ack[1] = wire.rply_ack_fc;
	reg.rply_ack[3] = snap_reg.rply_ack[2];

	if (wire.uplr_stb)
	{
		reg.qbus_adr = true;
	}
	else if (snap_reg.mjres || wire.mjres_rc || wire.sync_fedge)
	{
		reg.qbus_adr = false;
	}

	reg.qbus_win_h = snap_reg.qbus_win;
	reg.sync_out_h = snap_reg.sync_out;
	reg.qbus_free_h = !wire.dma_in && (wire.pin_pa == 0);
	reg.qbus_nosr_h = wire.qbus_nosr_rc;

	if (wire.qbus_done)
	{
		reg.qbus_own_rp = false;
	}
	else if (snap_reg.dmr_req_l && snap_reg.qbus_gnt_l)
	{
		reg.qbus_own_rp = true;
	}

	reg.qbus_flag = wire.qbus_flag_rc;
	reg.qbus_tovf = ((snap_reg.qbus_timer & 074) == 074);
	//
	// Error register at 177704
	// Bit 0 is Double Error
	// Bit 1 is Undefine Opcode
	// Bit 5 is not used (always read as one)
	// Bit 6 is Odd Address Trap (is not implmented)
	//
	if (wire.reset_rc || snap_reg.ir_set)
	{
		reg.reg_err = 040;
	}
	else
	{
		if (wire.sel_out && (snap_reg.sel_reg == 2))
		{
			reg.reg_err = (wire.pin_ad_in & 0377) | 040;
		}
		else
		{
			//
			// Bit 0 - double error
			//
			if (   (snap_reg.exc_dbl[0] && wire.exc_uop)
				|| (snap_reg.exc_dbl[1] && snap_reg.qbus_tovf)
				|| (snap_reg.exc_dbl[2] && wire.exc_oat)
				|| (snap_reg.exc_dbl[3] && wire.exc_err7) )
			{
				reg.reg_err |= (1 << 0);
			}
			//
			// Bit 1 - undefined opcode
			//
			if (wire.exc_uop)
			{
				reg.reg_err |= (1 << 1);
			}
			//
			// Bit 2 && 3 - unknown error, exceptions not implemented
			//
			if (snap_reg.plm1x_hl && !snap_reg.plr[26])
			{
				reg.reg_err |= (1 << 2);
			}
			if (snap_reg.plm1x_hl && !snap_reg.plr[28])
			{
				reg.reg_err |= (1 << 3);
			}
			//
			// Bit 4 - qbus timeout
			//
			if (snap_reg.qbus_tovf)
			{
				reg.reg_err |= (1 << 4);
			}
			//
			// Bit 6 - odd address trap
			//
			if (wire.exc_oat)
			{
				reg.reg_err |= (1 << 6);
			}
			//
			// Bit 7 - unknown error, no exception
			//
			if (wire.exc_err7)
			{
				reg.reg_err |= (1 << 7);
			}
		}
	}
	//
	// Double error detectors
	//
	if (!wire.exc_uop)
	{
		reg.exc_dbl[0] = GETBIT(snap_reg.reg_err,1);
	}
	if (!snap_reg.qbus_tovf)
	{
		reg.exc_dbl[1] = GETBIT(snap_reg.reg_err,4);
	}
	if (!wire.exc_oat)
	{
		reg.exc_dbl[2] = GETBIT(snap_reg.reg_err,6);
	}
	if (!wire.exc_err7)
	{
		reg.exc_dbl[3] = GETBIT(snap_reg.reg_err,7);
	}

	if (!wire.pin_sync_in)
	{
		bool sel177x = reg.sel_xx = ((wire.pin_ad_in & 0177760) == (0177700 | (wire.pin_pa << 4))); // peripheral block access
		if (sel177x)
		{
			reg.sel_reg = ((wire.pin_ad_in & 0xf) >> 1); // 0..7
		}
		else
		{
			reg.sel_reg = -1; // , ..     0..7 => 00 .. 016
		}
	}

	//
	// Original circuit contains error
	// The start_irq request is reset by interrupt ack and EMT execution (last one is wrong)
	//
	if (snap_reg.reset || (((snap_reg.vsel & 7) == 6) && (((snap_reg.nPLR >> 25) & 0xf) == 2) && ((snap_reg.plr[13] && !snap_reg.plr[14]) || snap_reg.plr[11])))
	{
		reg.start_irq = false;
	}
	else if ((snap_reg.sel_reg == 1) && wire.sel_out && snap_reg.rply_s3)
	{
		reg.start_irq = true;
	}
	//______________________________________________________________________________
	// Interrupt controller
	//
	//
	reg.rq = 0;
	if (snap_reg.psw[10])							reg.rq |= 1 << 0;
	if (snap_reg.plir0)								reg.rq |= 1 << 1;   // pli4r
	if (snap_reg.psw[11])							reg.rq |= 1 << 2;
	if (snap_reg.uop)								reg.rq |= 1 << 3;
	if (snap_reg.psw[7])							reg.rq |= 1 << 4;
	//
	// Not used matrix inputs
	//
	// if (false) reg.rq |= 1 << 5;
	// if (false) reg.rq |= 1 << 6;
	// if (false) reg.rq |= 1 << 7;
	//
	// Only master CPU processes vectored interrupts
	// Matrix accepts low level as active (asserted request)
	//
	if (!(wire.pin_irq[0] && (wire.pin_pa == 0)))	reg.rq |= 1 << 8 ;
	if (snap_reg.qbto)								reg.rq |= 1 << 9 ;
	if (snap_reg.reg_err & 1)						reg.rq |= 1 << 10;
	if (wire.pin_aclo && snap_reg.aclo)				reg.rq |= 1 << 11;
	if (snap_reg.reg_csr & (1<<2))					reg.rq |= 1 << 12;
	if (!wire.pin_aclo && snap_reg.acok)			reg.rq |= 1 << 13;
	if (wire.pin_irq[1])							reg.rq |= 1 << 14;
	if (snap_reg.psw[4])							reg.rq |= 1 << 15;
	if (wire.pin_irq[2] && snap_reg.irq2)			reg.rq |= 1 << 16;
	if (snap_reg.ivto)								reg.rq |= 1 << 17;
	if (wire.pin_irq[3] && snap_reg.irq3)			reg.rq |= 1 << 18;
	if (snap_reg.tve_intrq[0])						reg.rq |= 1 << 19;	// VE-timer interrupt request (vm1a_pli ignores)

	if (snap_reg.pli_req)
	{
		reg.plir = 0;
		if (wire.pli[6])  reg.plir |= 1 << 0;
		if (wire.pli[8])  reg.plir |= 1 << 1;
		if (wire.pli[10]) reg.plir |= 1 << 2;
	}
	//
	// ACLO edge detectors
	//
	if (snap_reg.reset || wire.aclo_ack)
	{
		reg.aclo = false;
	}
	else if (!wire.pin_aclo)
	{
		reg.aclo = true;
	}

	if (wire.pin_dclo || wire.aclo_ack)
	{
		reg.acok = false;
	}
	else if (wire.pin_aclo)
	{
		reg.acok = true;
	}
	//
	// IRQ2 and IRQ3 falling edge detectors
	// Also resettable by internal INIT
	//
	if (wire.tve_reset)
	{
		reg.irq2 = false;
		reg.irq3 = false;
	}
	else
	{
		if (wire.irq2_ack)
		{
			reg.irq2 = false;
		}
		else if (!wire.pin_irq[2])
		{
			reg.irq2 = true;
		}

		if (wire.irq3_ack)
		{
			reg.irq3 = false;
		}
		else if (!wire.pin_irq[3])
		{
			reg.irq3 = true;
		}
	}
	//
	// Error exception latches
	//
	if (snap_reg.reset || wire.uop_ack)
	{
		reg.uop = false;
		reg.qbto = false;
		reg.ivto = false;
	}
	else
	{
		if (wire.exc_uop)
		{
			reg.uop = true;
		}
		if (snap_reg.qbus_tovf && wire.iako_out)
		{
			reg.ivto = true;
		}
		if (snap_reg.qbus_tovf || wire.exc_oat)
		{
			reg.qbto = true;
		}
	}

	reg.pli_req = wire.pli_req_rc;

	if (snap_reg.pli_req)
	{
		reg.vsel = 0;
		if (wire.pli[3])  reg.vsel |= 1 << 3;
		if (!wire.pli[2]) reg.vsel |= 1 << 2;
		if (wire.pli[1])  reg.vsel |= 1 << 1;
		if (wire.pli[0])  reg.vsel |= 1 << 0;
	}
	else if (snap_reg.plm1x)
	{
		reg.vsel = 0;
		if ( snap_reg.plr[18]) reg.vsel |= 1<<3;
		if (!snap_reg.plr[20]) reg.vsel |= 1<<2;
		if (!snap_reg.plr[21]) reg.vsel |= 1<<1;
		if (!snap_reg.plr[22]) reg.vsel |= 1<<0;
	}
	//______________________________________________________________________________
	//
	// Reset circuits
	//
	reg.reset = wire.reset_rc;
	reg.mjres = wire.mjres_rc;
	reg.mjres_h = snap_reg.mjres;
	reg.abort = wire.abort_rc;
	reg.abort_tm = snap_reg.abort && !wire.reset_rc;

	if (wire.reset_rc)
	{
		reg.init_out[0] = false;
	}
	else if (snap_reg.plm1x_hl)
	{
		if (!snap_reg.plr[23])
		{
			reg.init_out[0] = false;
		}
		else if (!snap_reg.plr[10])
		{
			reg.init_out[0] = true;
		}
	}

	reg.init_out[1] = snap_reg.init_out[0];
	reg.init_out[2] = snap_reg.init_out[1];
	//______________________________________________________________________________
	//
	// Microcode state machine
	//
	//
	// Instruction register
	//
	bool ir_stb1 = (snap_reg.tplm & (1<<1|1<<3))? true : false;
	if (ir_stb1)
	{
		reg.ira = wire.pin_ad_in;
	}

	if (snap_reg.ir_stb2)
	{
		reg.ir = (ir_stb1) ? wire.pin_ad_in : snap_reg.ira;
	}

	//
	// Other bits have no reset facility
	//
	if (wire.plm_stb_rc)
	{
		//
		// Some of plm is not used here (microcode address directly uses plx instead)
		//
		for (int i = 0; i < 34; ++i)
		{
			reg.plm[i] = wire.plx[i];
		}
		bita2data(reg.plm, reg.nPLM, 34);

	}
	// Microcode register
	//
	if (snap_reg.ustb1_hl)
	{
		if (snap_reg.mj_stb1)
		{
			reg.mj[11] = snap_reg.psw[4];
			if (snap_reg.psw_mj)
			{
				reg.mj[10] = snap_reg.psw[3];
				reg.mj[9]  = snap_reg.psw[2];
				reg.mj[8]  = snap_reg.psw[1];
			}
			else
			{
				reg.mj[10] = snap_reg.freg[3];
				reg.mj[9]  = snap_reg.freg[2];
				reg.mj[8]  = snap_reg.freg[1];
			}
		}

		if (snap_reg.mj_stb2)
		{
			reg.mj[7] = snap_reg.psw_mj ? snap_reg.psw[0] : snap_reg.freg[0];
		}
	}
	//
	// ALU
	//

	//
	// ALU qbus register
	//
	if (wire.au_qstbx)
	{
		reg.qreg = wire.x;
	}
	else if (wire.iako_out || (snap_reg.tplm & (1 << 2)))
	{
		reg.qreg = (wire.pin_ad_in & 0177400) | ((snap_reg.au_ta0) ? ((wire.pin_ad_in & 0177400) >> 8) : (wire.pin_ad_in & 0377));
	}

	//
	// Transaction address low bit latch
	//
	if (wire.sync_stb)
	{
		reg.au_ta0 = GETBIT(snap_reg.areg, 0) && snap_reg.plrt[6];
	}
}

void C1801VM1::always_posedge_pin_clk_n_or_posedge_mjres_part_mjres()
{
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	reg.ustb = false;
	reg.alu_busy_fp = false;
	reg.tplmz = 0;
	//______________________________________________________________________________
	//
	// Qbus logic
	//
	reg.qbus_aseq[0] = false;
	reg.qbus_aseq[1] = false;
}

void C1801VM1::always_posedge_pin_clk_n_or_posedge_mjres_part_pin_clk_n()
{
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	bool bTmpB1 = snap_reg.plr[7] || snap_reg.plr[8];
	// Qbus data ready
	bool alu_qrdy = (!snap_reg.qbus_adr || snap_reg.plr[23] || !bTmpB1)				// wait for reg.areg free
				 && (!snap_reg.dout_req || snap_reg.plr[23] ||  bTmpB1)				// wait for write complete
				 && (snap_reg.plr[10] || !((snap_reg.tplm & (1<<2)) || snap_reg.iak_flag));	// wait for data or vector fetch

	if (snap_reg.ustb_h)
	{
		reg.ustb = false;
	}
	else if ((snap_reg.alu_busy_rp || (snap_reg.alu_busy_fp && !snap_reg.ustb1_h)) && alu_qrdy)
	{
		reg.ustb = true;
	}

	reg.alu_busy_fp = snap_reg.alu_busy_rp;

	if (wire.plm_ena_fc)
	{
		switch (((snap_reg.nPLM & 0xf) >> 1))
		{
		case 4:	reg.tplmz = 1 << 1;	break;
		case 2:	reg.tplmz = 1 << 2;	break;
		case 3:	reg.tplmz = 1 << 3;	break;
		default: reg.tplmz = 0;
		}
	}
	//______________________________________________________________________________
	//
	// Qbus logic
	//
	//
	// Reset the completed request if it is only one
	//
	if (wire.au_astb)
	{
		reg.qbus_aseq[0] = true;
	}
	else if (snap_reg.oe_clr && !snap_reg.qbus_aseq[1])
	{
		reg.qbus_aseq[0] = false;
	}
	//
	// The third request is impossible - the state machine
	// is suspended by qbus_nrdy
	//
	if (snap_reg.oe_clr)
	{
		reg.qbus_aseq[1] = false;
	}
	else if (wire.au_astb && snap_reg.qbus_aseq[0])
	{
		reg.qbus_aseq[1] = true;
	}

}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_mjres_part_mjres()
{
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	reg.ustb_h = false;
	reg.alu_busy_rp = false;
	reg.alu_nrdy = false;
	reg.ir_stb2 = false;
	reg.ir_stop = false;
	//______________________________________________________________________________
	//
	// Qbus logic
	//
	reg.dmr_req = false;
	reg.dout_req = false;
	reg.dout_out = false;
	reg.din_out = false;
	reg.sack_out = false;
	reg.qbus_req = false;
	//______________________________________________________________________________
	//
	// Interrupt controller
	//
	reg.iak_flag = false;
	//______________________________________________________________________________
	//
	// Microcode register
	//
	//
	// Least bits are produced directly from main matrix
	// and have the async reset feature (next microcode address)
	//
	reg.mj[6] = true;
	reg.mj[5] = true;
	reg.mj[4] = true;
	reg.mj[3] = true;
	reg.mj[2] = true;
	reg.mj[1] = true;
	//
	// Bits 14:12 poll the interrupt controller state
	//
	reg.mj[14] = false;
	reg.mj[13] = false;
	reg.mj[12] = false;
}
void C1801VM1::always_posedge_pin_clk_p_or_posedge_mjres_part_pin_clk_p()
{
	//______________________________________________________________________________
	//
	// Control and glue logic
	//
	reg.ustb_h = snap_reg.ustb;

	if (snap_reg.plm2x)
	{
		reg.alu_busy_rp = true;
	}
	else if (snap_reg.ustb1)
	{
		reg.alu_busy_rp = false;
	}

	if (snap_reg.plm2x)
	{
		reg.alu_nrdy = true;
	}
	else if (snap_reg.ustb1_h)
	{
		reg.alu_nrdy = false;
	}

	if (wire.ir_clr)
	{
		reg.ir_stb2 = false;
	}
	else if (snap_reg.ir_set)
	{
		reg.ir_stb2 = true;
	}

	if (!(snap_reg.reg_csr & 1))
	{
		reg.ir_stop = false;
	}
	else if (wire.ir_clr)
	{
		reg.ir_stop = true;
	}
	//______________________________________________________________________________
	//
	// Qbus logic
	//
	reg.dmr_req = wire.dmr_req_rc;
	reg.dout_req = wire.dout_req_rc;

	if (snap_reg.dout_done)
	{
		reg.dout_out = false;
	}
	else if (wire.dout_start)
	{
		reg.dout_out = true;
	}

	if (wire.din_done)
	{
		reg.din_out = false;
	}
	else if (snap_reg.oe_set || (snap_reg.plrt[8] && wire.sync_fedge))
	{
		reg.din_out = true;
	}

	if (wire.qbus_done)
	{
		reg.sack_out = false;
	}
	else if (wire.pin_dmgi && (wire.qbus_nosr_rc || (snap_reg.sync_out && !snap_reg.qbus_win)) && snap_reg.qbus_req)
	{
		reg.sack_out = true;
	}

	if (wire.qbus_done)
	{
		reg.qbus_req = false;
	}
	else if (wire.dmr_out && !wire.pin_dmgi)
	{
		reg.qbus_req = true;
	}
	//______________________________________________________________________________
	//
	// Interrupt controller
	//
	if (wire.din_done)
	{
		reg.iak_flag = false;
	}
	else if (snap_reg.plm_ena && (((snap_reg.nPLR >> 25) & 0xf) == 2) && (snap_reg.plr[11] || (snap_reg.plr[13] && !snap_reg.plr[14])) && (snap_reg.vsel == 017))
	{
		reg.iak_flag = true;
	}
	//______________________________________________________________________________
	//
	// Microcode register
	//
	//
	// Least bits are produced directly from main matrix
	// and have the async reset feature (next microcode address)
	//
	if (wire.plm_stb_rc)
	{
		reg.mj[1] = !wire.plx[24];
		reg.mj[2] = !wire.plx[19];
		reg.mj[3] =  wire.plx[15];
		reg.mj[4] =  wire.plx[9];
		reg.mj[5] =  wire.plx[5];
		reg.mj[6] = !wire.plx[0];
	}
	//
	// Bits 14:12 poll the interrupt controller state
	//
	if (snap_reg.pli_req)
	{
		reg.mj[14] = !wire.pli[5];
		reg.mj[13] = !wire.pli[7];
		reg.mj[12] =  wire.pli[9];
	}
	else if (snap_reg.plm1x)
	{
		reg.mj[14] = !snap_reg.plr[14];
		reg.mj[13] =  snap_reg.plr[16];
		reg.mj[12] = !snap_reg.plr[17];
	}

}

//
// Qbus timeout counter
//
// original 1801BM1 timer has 1/8 input prescaler which is no reset and
// provides bus timeout in a range 56..63 processor clocks. This model
// emulates the average value 60 clocks.
//
// Timeout exception request should be synchronized with raising clk's edge
//
void C1801VM1::always_posedge_pin_clk_n_or_negedge_qbus_tena_part_qbus_tena()
{
	reg.qbus_timer = 0;
}

void C1801VM1::always_posedge_pin_clk_n_or_negedge_qbus_tena_part_pin_clk_n()
{
	if (!snap_reg.qbus_tovf)
	{
		reg.qbus_timer = (snap_reg.qbus_timer + 1) & 077;
	}
}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_reset_part_reset()
{
	//______________________________________________________________________________
	//
	// Qbus logic
	//
	//
	// Control register at 177700
	//
	reg.reg_csr= 0;
	//______________________________________________________________________________
	//
	// Interrupt controller
	//
	reg.plir0 = false;
}
void C1801VM1::always_posedge_pin_clk_p_or_posedge_reset_part_pin_clk_p()
{
	//______________________________________________________________________________
	//
	// Qbus logic
	//
	//
	// Control register at 177700
	//
	if (wire.sel_out && (snap_reg.sel_reg == 0))
	{
		reg.reg_csr = wire.pin_ad_in & 7;
	}
	else
	{
		//
		// Bit 0 of control register
		//
		if ((snap_reg.plm1x_hl && !snap_reg.plr[25]) || (snap_reg.ir_set && (snap_reg.reg_csr & (1<<1))))
		{
			reg.reg_csr |= 1 << 0;
		}
		//
		// Bit 1 of control register (controls set of bit 0)
		//

		//
		// Bit 2 of control register (wait state)
		//
		if (snap_reg.plm1x_hl && !snap_reg.plr[27])
		{
			reg.reg_csr &= ~(1 << 2);
		}
		else if (snap_reg.plm1x_hl && !snap_reg.plr[7])
		{
			reg.reg_csr |= 1 << 2;
		}
	}
	//______________________________________________________________________________
	//
	// Interrupt controller
	//
	if (snap_reg.pli_req)
	{
		reg.plir0 = wire.pli[4];
	}

}

void C1801VM1::always_posedge_pin_clk_n_or_posedge_reset_part_reset()
{
	for (int i = 0; i < 16; ++i)
	{
		reg.psw[i] = false;
	}
	reg.psw[8] = ((wire.pin_pa & 1) == 1);
	reg.psw[9] = ((wire.pin_pa & 2) == 2);
}

void C1801VM1::always_posedge_pin_clk_n_or_posedge_reset_part_pin_clk_n()
{
	//
	// ALU result flags and PSW
	//
	//
	// Start microcode correctly sets the PSW
	// But simulator can not calculate ALU function
	// correctly if PSW in initially undefined
	//
	// The PSW is written by microcode with 340 value
	// while executing reset sequence
	//
	if (snap_reg.au_alsl && wire.au_pstbx)
	{
		for (int i = 0; i < 8; ++i)
		{
			reg.psw[i] = (wire.x & g_WordBitMask[i]) ? true : false;
		}
	}
	else
	{
		//
		// Latch the ALU flag results immediately after ALU completion
		//
		if (snap_reg.psw_stbc && snap_reg.ustb1_hl)
		{
			reg.psw[0] = snap_reg.freg[0];
		}

		if (snap_reg.psw_stb && snap_reg.ustb1_hl)
		{
			reg.psw[1] = snap_reg.freg[1];
			reg.psw[2] = snap_reg.freg[2];
			reg.psw[3] = snap_reg.freg[3];
		}
	}

	if (snap_reg.au_alsh && wire.au_pstbx)
	{
		reg.psw[8] = ((wire.pin_pa & 1) == 1);
		reg.psw[9] = ((wire.pin_pa & 2) == 2);
		for (int i = 10; i < 16; ++i)
		{
			reg.psw[i] = wire.x & g_WordBitMask[i] ? true: false;
		}
	}
}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_abort_part_abort()
{
	reg.mj[0] = false;
}

void C1801VM1::always_posedge_pin_clk_p_or_posedge_abort_part_pin_clk_p()
{
	//______________________________________________________________________________
	//
	// Microcode register
	//
	//
	// The least bit is reset by abort
	// and set by common reset
	//
	if (snap_reg.reset)
	{
		reg.mj[0] = true;
	}
	else if (wire.plm_stb_rc)
	{
		reg.mj[0] = !wire.plx[29];
	}

}

//
// On schematics vc_vreg is {pli[3], !pli[2], pli[1], pli[0]}
//
void C1801VM1::always_a()
{
	static WORD pVMuxData[16] = {
		0160006,	//0	// double error
		0000020,	//1	// IOT instruction
		0000010,	//2	// reserved opcode
		0000014,	//3	// T-bit/BPT trap
		0000004,	//4	// invalid opcode
		0177716,	//5	// or qbus timeout
		0000030,	//6	// EMT instruction
		0160012,	//7	// int ack timeout
		0000270,	//8	// IRQ3 falling edge
		0000024,	//9	// ACLO falling edge
		0000100,	//10// IRQ2 falling edge
		0160002,	//11// IRQ1 low level/HALT
		0000034,	//12// TRAP instruction
		0,			//13//instruction register
		0,			//14 //start @177704
		0			//15 //unused vector (iako)
	};
	//snap_reg.vc_vreg &= 0xf;     vc_vreg  0..15
	switch (snap_reg.vc_vreg)
	{
	case 5:  reg.vmux = pVMuxData[snap_reg.vc_vreg] | (wire.pin_pa << 4);	// qbus timeout
		break;
	case 13: reg.vmux = snap_reg.ir;		// instruction register
		break;
	default: reg.vmux = pVMuxData[snap_reg.vc_vreg];					//
	}

	//
	// Constant generator and opcode fields shifter/truncator
	//
	// On schematics csel is plr[28:25]
	//
	//    csel0 = 4b'00xx
	//    csel1 = 4b'01xx
	//    csel2 = 4b'10xx
	//    csel3 = 4b'11xx
	//    csel4 = 4b'xx00
	//    csel5 = 4b'xx01
	//    csel6 = 4b'xx10
	//    csel7 = 4b'xx11
	//
	
	static WORD pCMuxData[16] = {
		0,			//0	// csel0 && csel4 (CLx/SEx)
		0000340,	//1	// csel0 && csel5 (start PSW constant)
		0000000,	//2	// csel0 && csel6 (vector output)
		0000002,	//3	// csel0 && csel7
		0,			//4	// csel1 && csel4 (MARK/SOB)
		0177716,	//5	// csel1 && csel5
		0177777,	//6	// csel1 && csel6
		0000001,	//7	// csel1 && csel7
		0,			//8	// csel2 && csel4
		0100000,	//9	// csel2 && csel5
		0177676,	//10// csel2 && csel6
		0000020,	//11// csel2 && csel7 (MUL)
		0,			//12// csel3 && csel4 (ADC/SBC)
		0177400,	//13// csel3 && csel5 (start address AND)
		0000010,	//14// csel3 && csel6
		0000000		//15// csel3 && csel7 (vector read/vsel)
	};
	int nx = (snap_reg.nPLR >> 25) & 0xf;
	switch (nx)
	{
	case 0:	reg.cmux = snap_reg.ir & 0xf;			// csel0 && csel4 (CLx/SEx)
		break;
	case 4: reg.cmux = (snap_reg.ir & 077) << 1;	// csel1 && csel4 (MARK/SOB)
		break;
	case 8:											//
	{												// csel2 && csel4
		if (GETBIT(snap_reg.ir, 7))								//
			reg.cmux = 0177000 | (snap_reg.ir & 0377) << 1;		// low byte x2   (BR/Bxx)
		else										// sign extension
			reg.cmux = (snap_reg.ir & 0377) << 1;	// for branches
	}												//
	break;
	case 12: reg.cmux = snap_reg.psw[0] ? 1 : 0;	// csel3 && csel4 (ADC/SBC)
		break;
	default: reg.cmux = pCMuxData[nx];
	}
}

#ifdef DBG_OUT_PLI_LOG

void C1801VM1::OutPLILog()
{
	static int nOutclklog = 0;
	if (m_nClk != 0)
	{
		if (m_nClk == nOutclklog) //  .
		{
			return;
		}
		else
		{
			nOutclklog = m_nClk;
		}
	}

	fprintf(m_PLILog, "%06d  ", m_nClk);

	for (int i = 19; i >= 0; i--)
	{
		fprintf(m_PLILog, "      %d", (reg.rq >> i) & 1);
	}
	fprintf(m_PLILog, "       ");
	for (int i = 10; i >= 0; i--)
	{
		fprintf(m_PLILog, "      %d", wire.pli[i]);
	}
	fprintf(m_PLILog, "\n");
}
#endif //DBG_OUT_PLI_LOG

#ifdef DBG_OUT_PLM_LOG
static char *strOptypes[8] = {
	"nothing",
	"nothing",
	"write word",
	"write byte",
	"read word",
	"read byte",
	"read - modify - write word",
	"read - modify - write byte"
};

void C1801VM1::OutPLMLog()
{
	static int nOutclklog = 0;
	if (m_nClk != 0)
	{
		if (m_nClk == nOutclklog) //  .
		{
			return;
		}
		else
		{
			nOutclklog = m_nClk;
		}
	}
	fprintf(m_PLMLog, "%06d  ", m_nClk);
	fprintf(m_PLMLog, "%06o  ", reg.ir);
	fprintf(m_PLMLog, "%d", (reg.mj[14] ? 1 : 0));
	fprintf(m_PLMLog, "%d", (reg.mj[13] ? 1 : 0));
	fprintf(m_PLMLog, "%d ", (reg.mj[12] ? 1 : 0));
	fprintf(m_PLMLog, "%d ", (reg.mj[11] ? 1 : 0));
	fprintf(m_PLMLog, "%d ", (reg.mj[10] ? 1 : 0));
	fprintf(m_PLMLog, "%d ", (reg.mj[9] ? 1 : 0));
	fprintf(m_PLMLog, "%d ", (reg.mj[8] ? 1 : 0));
	fprintf(m_PLMLog, "%d ", (reg.mj[7] ? 1 : 0));
	WORD nMJ;
	bita2data(reg.mj, nMJ, 15);
	fprintf(m_PLMLog, " 0x%02x    ", nMJ & 0x7f);
	for (int i = 33; i >= 0; i--)
	{
		fprintf(m_PLMLog, "      %d", wire.plx[i]);
	}
	QWORD nPLX;
	bita2data(wire.plx, nPLX, 34);
	int Optype = (nPLX >> 6) & 7;
	//    plx[0]   ~mj[6];
	//    plx[5]    mj[5]
	//    plx[9]    mj[4]
	//    plx[12]   opcode is not recognized
	//    plx[15]   mj[3]
	//    plx[19]  ~mj[2]
	//    plx[24]  ~mj[1]
	//    plx[29]  ~mj[0]
	int nextPLMOP
		= (wire.plx[0] ? 0 : 0x40)
		| (wire.plx[5] ? 0x20 : 0)
		| (wire.plx[9] ? 0x10 : 0)
		| (wire.plx[15] ? 0x8 : 0)
		| (wire.plx[19] ? 0 : 4)
		| (wire.plx[24] ? 0 : 2)
		| (wire.plx[29] ? 0 : 1);

	fprintf(m_PLMLog, " next:0x%02x / %s", nextPLMOP, strOptypes[Optype]);

	fprintf(m_PLMLog, "\n");
	fflush(m_PLMLog);
}

#endif // DBG_OUT_PLM_LOG

#ifdef DBG_OUT_WIRESDIFF
//  ,       .
void C1801VM1::Out_Difference(int nClk, int n, const char *str)
{
	FILE *f = fopen(DBG_WIRESDIFF_LOG_NAME, "a");

	fprintf(f, "Clk: %06d Phase: %s Wires stage: %d -------------------------\n", m_nClk, str, n);

	compareByte(f, prev_wire.pin_pa, wire.pin_pa, "pin_pa");
	compareBool(f, prev_wire.pin_dclo, wire.pin_dclo, "pin_dclo");
	compareBool(f, prev_wire.pin_aclo, wire.pin_aclo, "pin_aclo");
	compareBoolArray(f, prev_wire.pin_irq, wire.pin_irq, 4, "pin_irq[4]");

	compareWord(f, prev_wire.pin_ad_in, wire.pin_ad_in, "pin_ad_in");
	compareBool(f, prev_wire.pin_sync_in, wire.pin_sync_in, "pin_sync_in");
	compareBool(f, prev_wire.pin_dmgi, wire.pin_dmgi, "pin_dmgi");
	compareBool(f, prev_wire.dma_in, wire.dma_in, "dma_in");
	compareBoolArray(f, prev_wire.plx, wire.plx, 34, "plx[34]");
	compareBoolArray(f, prev_wire.pli, wire.pli, 11, "pli[11]");
	compareBool(f, prev_wire.tve_ack, wire.tve_ack, "tve_ack");
	compareBool(f, prev_wire.exc_uop, wire.exc_uop, "exc_uop");
	compareBool(f, prev_wire.exc_oat, wire.exc_oat, "exc_oat");
	compareBool(f, prev_wire.exc_err7, wire.exc_err7, "exc_err7");
	compareBool(f, prev_wire.qbus_tena, wire.qbus_tena, "qbus_tena");
	compareBool(f, prev_wire.uop_ack, wire.uop_ack, "uop_ack");
	compareBool(f, prev_wire.aclo_ack, wire.aclo_ack, "aclo_ack");
	compareBool(f, prev_wire.irq2_ack, wire.irq2_ack, "irq2_ack");
	compareBool(f, prev_wire.irq3_ack, wire.irq3_ack, "irq3_ack");
	compareBool(f, prev_wire.ir_clr, wire.ir_clr, "ir_clr");
	compareBool(f, prev_wire.ir_seq_rc, wire.ir_seq_rc, "ir_seq_rc");
	compareBool(f, prev_wire.pli_req_rc, wire.pli_req_rc, "pli_req_rc");
	compareBool(f, prev_wire.plm_stb_rc, wire.plm_stb_rc, "plm_stb_rc");
	compareBool(f, prev_wire.plm1x_fc, wire.plm1x_fc, "plm1x_fc");
	compareBool(f, prev_wire.plm2x_fc, wire.plm2x_fc, "plm2x_fc");
	compareBool(f, prev_wire.plm_ena_fc, wire.plm_ena_fc, "plm_ena_fc");
	compareByte(f, prev_wire.plop, wire.plop, "plop");
	compareBool(f, prev_wire.uplr_stb, wire.uplr_stb, "uplr_stb");
	compareByte(f, prev_wire.plm23_fc, wire.plm23_fc, "plm23_fc");
	compareByte(f, prev_wire.tplm_rc, wire.tplm_rc, "tplm_rc");
	compareBool(f, prev_wire.mjres_rc, wire.mjres_rc, "mjres_rc");
	compareBool(f, prev_wire.reset_rc, wire.reset_rc, "reset_rc");
	compareBool(f, prev_wire.abort_rc, wire.abort_rc, "abort_rc");
	compareBool(f, prev_wire.sel_out, wire.sel_out, "sel_out");
	compareBool(f, prev_wire.dmr_out, wire.dmr_out, "dmr_out");
	compareBool(f, prev_wire.iako_out, wire.iako_out, "iako_out");
	compareBool(f, prev_wire.qbus_done, wire.qbus_done, "qbus_done");
	compareBool(f, prev_wire.rply_ack_fc, wire.rply_ack_fc, "rply_ack_fc");
	compareBool(f, prev_wire.oe_set_fc, wire.oe_set_fc, "oe_set_fc");
	compareBool(f, prev_wire.din_done, wire.din_done, "din_done");
	compareBool(f, prev_wire.dmr_req_rc, wire.dmr_req_rc, "dmr_req_rc");
	compareBool(f, prev_wire.dout_req_rc, wire.dout_req_rc, "dout_req_rc");
	compareBool(f, prev_wire.dout_start, wire.dout_start, "dout_start");
	compareBool(f, prev_wire.qbus_flag_rc, wire.qbus_flag_rc, "qbus_flag_rc");
	compareBool(f, prev_wire.sync_stb, wire.sync_stb, "sync_stb");
	compareBool(f, prev_wire.sync_fedge, wire.sync_fedge, "sync_fedge");
	compareBool(f, prev_wire.qbus_nosr_rc, wire.qbus_nosr_rc, "qbus_nosr_rc");
	compareBool(f, prev_wire.qbus_gnt, wire.qbus_gnt, "qbus_gnt");
	compareWord(f, prev_wire.x, wire.x, "x");
	compareWord(f, prev_wire.xr, wire.xr, "xr");
	compareWord(f, prev_wire.y, wire.y, "y");
	compareWord(f, prev_wire.yr, wire.yr, "yr");
	compareBoolArray(f, prev_wire.flag, wire.flag, 4, "flag[4]");
	compareBool(f, prev_wire.cl_fc, wire.cl_fc, "cl_fc");
	compareBool(f, prev_wire.alu_b_fc, wire.alu_b_fc, "alu_b_fc");
	compareBool(f, prev_wire.alu_c_fc, wire.alu_c_fc, "alu_c_fc");
	compareBool(f, prev_wire.alu_d_fc, wire.alu_d_fc, "alu_d_fc");
	compareBool(f, prev_wire.alu_e_fc, wire.alu_e_fc, "alu_e_fc");
	compareBool(f, prev_wire.alu_x_fc, wire.alu_x_fc, "alu_x_fc");
	compareBool(f, prev_wire.alu_s_fc, wire.alu_s_fc, "alu_s_fc");
	compareBool(f, prev_wire.au_qsx, wire.au_qsx, "au_qsx");
	compareBool(f, prev_wire.au_qsy, wire.au_qsy, "au_qsy");
	compareBool(f, prev_wire.au_pswx, wire.au_pswx, "au_pswx");
	compareBool(f, prev_wire.au_pswy, wire.au_pswy, "au_pswy");
	compareBool(f, prev_wire.au_pstbx, wire.au_pstbx, "au_pstbx");
	compareBool(f, prev_wire.au_astb, wire.au_astb, "au_astb");
	compareBool(f, prev_wire.au_qstbx, wire.au_qstbx, "au_qstbx");
	compareBool(f, prev_wire.au_is0, wire.au_is0, "au_is0");
	compareWord(f, prev_wire.rsw, wire.rsw, "rsw");
	compareBool(f, prev_wire.tve_reset, wire.tve_reset, "tve_reset");
	compareBool(f, prev_wire.tve_tclk128, wire.tve_tclk128, "tve_tclk128");
	compareBool(f, prev_wire.pin_spclk, wire.pin_spclk, "pin_spclk");
	compareBool(f, prev_wire.tve_zero, wire.tve_zero, "tve_zero");
	compareBool(f, prev_wire.tve_back, wire.tve_back, "tve_back");

	fprintf(f, "\n");
	fclose(f);
}
void C1801VM1::compareBool(FILE *f, bool bOrig, bool bTest, const char *str)
{
	if (bOrig != bTest)
	{
		fprintf(f, "%s\n  Prev: %d\n  Curr: %d\n", str, bOrig, bTest);
	}
}
void C1801VM1::compareByte(FILE *f, BYTE bOrig, BYTE bTest, const char *str)
{
	if (bOrig != bTest)
	{
		fprintf(f, "%s\n  Prev: %03o\n  Curr: %03o\n", str, bOrig, bTest);
	}
}
void C1801VM1::compareWord(FILE *f, WORD bOrig, WORD bTest, const char *str)
{
	if (bOrig != bTest)
	{
		fprintf(f, "%s\n  Prev: %06o\n  Curr: %06o\n", str, bOrig, bTest);
	}
}
void C1801VM1::compareDWord(FILE *f, DWORD bOrig, DWORD bTest, const char *str)
{
	if (bOrig != bTest)
	{
		fprintf(f, "%s\n  Prev: %08x\n  Curr: %08x\n", str, bOrig, bTest);
	}
}
void C1801VM1::compareQWord(FILE *f, QWORD bOrig, QWORD bTest, const char *str)
{
	if (bOrig != bTest)
	{
		fprintf(f, "%s\n  Prev: %016x\n  Curr: %016x\n", str, bOrig, bTest);
	}
}
void C1801VM1::compareBoolArray(FILE *f, bool *pOrig, bool *pTest, int nLen, const char *str)
{
	bool bComp = false;
	for (int i = 0; i < nLen; ++i)
	{
		if (pOrig[i] != pTest[i])
		{
			bComp = true;
			break;
		}
	}

	if (bComp)
	{
		fprintf(f, "%s\n  Prev: ", str);
		for (int i = nLen - 1; i >= 0; i--)
		{
			fprintf(f, "%d", (pOrig[i] ? 1 : 0));
		}
		fprintf(f, "\n  Curr: ");
		for (int i = nLen - 1; i >= 0; i--)
		{
			fprintf(f, "%d", (pTest[i] ? 1 : 0));
		}
		fprintf(f, "\n");
	}
}

#endif // DBG_OUT_WIRESDIFF
